// AnalyseView.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "AnalyseView.h"
#include "LyapunovKantz.h"

#define LEFTBORDER 40
#define BOTTOMBORDER 30

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAnalyseView

IMPLEMENT_DYNCREATE(CAnalyseView, CView)

CAnalyseView::CAnalyseView()
{
#ifdef _DEBUG
    oldMemState.Checkpoint();
#endif
		
	INT Items=AfxGetMainWnd()->GetMenu()->GetMenuItemCount();
	AfxGetMainWnd()->GetMenu()->GetSubMenu(Items>5?5:3)->AppendMenu(MF_STRING|MF_ENABLED,ID_FENSTER_ANALYSE,"Analyse");
	AfxGetMainWnd()->DrawMenuBar();
}

void CAnalyseView::IniFileRead()
{
	//IniFileWerte einlesen
	m_DimLya=*theApp.GetIniAnalyseDimLya();
	m_TauLya=*theApp.GetIniAnalyseTauLya();
	m_NumberOfLya=*theApp.GetIniAnalyseNumberOfLya();
	m_IterLya=*theApp.GetIniAnalyseIterLya();
	m_NumPointsLya=*theApp.GetIniAnalyseNumPointsLya();
	m_MaxDimLya=*theApp.GetIniAnalyseMaxDimLya();
	m_RadiusMinLya=*theApp.GetIniAnalyseRadiusMinLya();

	m_NumPointsLyaMax=*theApp.GetIniAnalyseNumPointsLyaMax();
	m_IterLyaMax=*theApp.GetIniAnalyseIterLyaMax();
	m_NumberOfLyaMax=*theApp.GetIniAnalyseNumberOfLyaMax();
	m_TauLyaMax=*theApp.GetIniAnalyseTauLyaMax();
	m_RadiusMinLyaMax=*theApp.GetIniAnalyseRadiusMinLyaMax();
	m_RadiusMaxLyaMax=*theApp.GetIniAnalyseRadiusMaxLyaMax();
	m_MinDimDoneMaxLya=*theApp.GetIniAnalyseMinDimDoneMaxLya();
	m_MaxDimDoneMaxLya=*theApp.GetIniAnalyseMaxDimDoneMaxLya();
	m_ReferenzLyaMax=*theApp.GetIniAnalyseReferenzLyaMax();

	m_DimKorr=*theApp.GetIniAnalyseDimKorr();
	m_NumPointsKorr=*theApp.GetIniAnalyseNumPointsKorr();
	m_NumberOfKorr=*theApp.GetIniAnalyseNumberOfKorr();
	m_TauKorr=*theApp.GetIniAnalyseTauKorr();
	m_RadiusMinKorr=*theApp.GetIniAnalyseRadiusMinKorr();
	m_RadiusMaxKorr=*theApp.GetIniAnalyseRadiusMaxKorr();
	m_MaxDimKorr=*theApp.GetIniAnalyseMaxDimKorr();
	m_IterKorr=*theApp.GetIniAnalyseIterKorr();

	m_WhatIs=*theApp.GetIniAnalyseWhatIs();
}

void CAnalyseView::IniFileWrite()
{
/*	switch(m_WhatIs) 
	{
	case 0:	
		m_TauLya=m_Tau;
		m_NumPointsLya=m_NumPoints;
		m_MaxDimLya=m_MaxDim;
		m_DimLya=m_Dim;
		m_IterLya=m_Iter;
		m_NumberOfLya=m_NumberOf;
		m_RadiusMinLya=m_RadiusMin;
		m_RadiusMax=0;
		break;
	case 1:
		m_TauLyaMax=m_Tau;
		m_NumPointsLyaMax=m_NumPoints;
		m_MaxDimDoneMaxLya=m_MaxDim;
		m_MinDimDoneMaxLya=m_Dim;
		m_IterLyaMax=m_Iter;
		m_NumberOfLyaMax=m_NumberOf;
		m_RadiusMinLyaMax=m_RadiusMin;
		m_RadiusMaxLyaMax=m_RadiusMax;
		break;
	case 2:
		m_TauKorr=m_Tau;
		m_NumPointsKorr=m_NumPoints;
		m_MaxDimKorr=m_MaxDim;
		m_DimKorr=m_Dim;
		m_IterKorr=m_Iter;
		m_NumberOfKorr=m_NumberOf;
		m_RadiusMinKorr=m_RadiusMin;
		m_RadiusMaxKorr=m_RadiusMax;
		break;
	}
*/
	//IniFileWerte schreiben
	*theApp.GetIniAnalyseDimLya()=m_DimLya;
	*theApp.GetIniAnalyseTauLya()=m_TauLya;
	*theApp.GetIniAnalyseNumberOfLya()=m_NumberOfLya;
	*theApp.GetIniAnalyseIterLya()=m_IterLya;
	*theApp.GetIniAnalyseNumPointsLya()=m_NumPointsLya;
	*theApp.GetIniAnalyseMaxDimLya()=m_MaxDimLya;
	*theApp.GetIniAnalyseRadiusMinLya()=m_RadiusMinLya;

	*theApp.GetIniAnalyseNumPointsLyaMax()=m_NumPointsLyaMax;
	*theApp.GetIniAnalyseIterLyaMax()=m_IterLyaMax;
	*theApp.GetIniAnalyseNumberOfLyaMax()=m_NumberOfLyaMax;
	*theApp.GetIniAnalyseTauLyaMax()=m_TauLyaMax;
	*theApp.GetIniAnalyseRadiusMinLyaMax()=m_RadiusMinLyaMax;
	*theApp.GetIniAnalyseRadiusMaxLyaMax()=m_RadiusMaxLyaMax;
	*theApp.GetIniAnalyseMinDimDoneMaxLya()=m_MinDimDoneMaxLya;
	*theApp.GetIniAnalyseMaxDimDoneMaxLya()=m_MaxDimDoneMaxLya;
	*theApp.GetIniAnalyseReferenzLyaMax()=m_ReferenzLyaMax;

	*theApp.GetIniAnalyseDimKorr()=m_DimKorr;
	*theApp.GetIniAnalyseNumPointsKorr()=m_NumPointsKorr;
	*theApp.GetIniAnalyseNumberOfKorr()=m_NumberOfKorr;
	*theApp.GetIniAnalyseTauKorr()=m_TauKorr;
	*theApp.GetIniAnalyseRadiusMinKorr()=m_RadiusMinKorr;
	*theApp.GetIniAnalyseRadiusMaxKorr()=m_RadiusMaxKorr;
	*theApp.GetIniAnalyseMaxDimKorr()=m_MaxDimKorr;
	*theApp.GetIniAnalyseIterKorr()=m_IterKorr;

	*theApp.GetIniAnalyseWhatIs()=m_WhatIs;
}

CAnalyseView::~CAnalyseView()
{
	IniFileWrite();
	INT Items=AfxGetMainWnd()->GetMenu()->GetMenuItemCount();
	AfxGetMainWnd()->GetMenu()->GetSubMenu(Items>5?5:3)->RemoveMenu(ID_FENSTER_ANALYSE,MF_BYCOMMAND);
	AfxGetMainWnd()->DrawMenuBar();
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->m_pViewAnalyse=NULL;

	#ifdef _DEBUG
    newMemState.Checkpoint();
    if( diffMemState.Difference( oldMemState, newMemState ) )
    {
//        TRACE( "Speicherverlust!\n" );
//				diffMemState.DumpAllObjectsSince();
    }
	#endif


	for (int i=0;i<(INT)m_LyaSpektrumLaenge;i++)
		free(m_LyaSpektrum[i]);
	free(m_LyaSpektrum);

	for (i=0;i<m_LyaMaxLaenge-1;i++)
    free(m_LyaMax[i]);
	free(m_LyaMax);

	free(m_KorrDim);

  for (i=0;i<m_KorrDimLaengeI;i++)
		for (int j=0;j<m_KorrDimLaengeII;j++)
			free(m_KorrDimWerte[i][j]);
  for (i=0;i<m_KorrDimLaengeI;i++)
		free(m_KorrDimWerte[i]);
  free(m_KorrDimWerte);
}


BEGIN_MESSAGE_MAP(CAnalyseView, CView)
	//{{AFX_MSG_MAP(CAnalyseView)
	ON_BN_CLICKED(IDC_CHECK_KORR, OnCheckKorr)
	ON_BN_CLICKED(IDC_CALCULATE, OnCalculate)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_SAVE, OnSave)
	ON_BN_CLICKED(IDC_CHECK_MAXLYA, OnCheckMaxlya)
	ON_BN_CLICKED(IDC_CHECK_SPECLYA, OnCheckSpeclya)
	ON_EN_CHANGE(IDC_DIM_FELD, OnChangeDimFeld)
	ON_EN_CHANGE(IDC_DIM_MAX, OnChangeDimMax)
	ON_EN_CHANGE(IDC_ITER_FELD, OnChangeIterFeld)
	ON_EN_CHANGE(IDC_NUMBEROF_FELD, OnChangeNumberofFeld)
	ON_EN_CHANGE(IDC_RADIUS_MAX_FELD, OnChangeRadiusMaxFeld)
	ON_EN_CHANGE(IDC_RADIUS_MIN_FELD, OnChangeRadiusMinFeld)
	ON_EN_CHANGE(IDC_TAU_FELD, OnChangeTauFeld)
	ON_EN_CHANGE(IDC_PUNKTE_FELD, OnChangePunkteFeld)
	ON_BN_CLICKED(IDM_CLS, OnCls)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_DIM_SLIDER, OnReleasedcaptureDimSlider)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_ITER_SLIDER, OnReleasedcaptureIterSlider)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_NUMBEROF_SLIDER, OnReleasedcaptureNumberofSlider)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_PUNKTE_SLIDER, OnReleasedcapturePunkteSlider)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_TAU_SLIDER, OnReleasedcaptureTauSlider)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_REFERENZ_SLIDER, OnReleasedcaptureReferenzSlider)
	ON_EN_CHANGE(IDC_REFERENZ_FELD, OnChangeReferenzFeld)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Diagnose CAnalyseView

#ifdef _DEBUG
void CAnalyseView::AssertValid() const
{
	CView::AssertValid();
}

void CAnalyseView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CAnalyseView 

void CAnalyseView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	
	IniFileRead();

	m_pParentAnalyseFrame=(CAnalyseFrame*)GetParentFrame();
	CEdit* Edit;
	CSliderCtrl* Slider;
	CString Text;
	switch(m_WhatIs) 
	{
	case 0:
		m_Tau=m_TauLya;
		m_NumPoints=m_NumPointsLya;
		m_MaxDim=m_MaxDimLya;
		m_Dim=m_DimLya;
		m_Iter=m_IterLya;
		m_NumberOf=m_NumberOfLya;
		m_RadiusMin=m_RadiusMinLya;
		m_RadiusMax=0;
		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_RADIUS_MIN);
		Edit->ShowWindow(SW_HIDE);
		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_RADIUS_MAX);
		Edit->ShowWindow(SW_HIDE);
		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_RADIUS_MAX_FELD);
		Edit->ShowWindow(SW_HIDE);
		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_ITER_STATIC);
		Text.LoadString(IDS_ITERATIONEN);
		Edit->SetWindowText(Text);
		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_STATIC);
		Text.LoadString(IDS_NUMNEIGHBORS);
		Edit->SetWindowText(Text);
		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_MIN);	
		Edit->ShowWindow(SW_HIDE);
		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_MAX);
		Edit->ShowWindow(SW_HIDE);
		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_FELD);
		Edit->ShowWindow(SW_HIDE);
		Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_SLIDER);
		Slider->ShowWindow(SW_HIDE);
		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_STATIC);
		Edit->ShowWindow(SW_HIDE);
		Text.LoadString(IDS_EINBETTUNGSDIMENSION);
		m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemText(IDC_DIM_STATIC,Text);
		break;
	case 1:
		m_Tau=m_TauLyaMax;
		m_NumPoints=m_NumPointsLyaMax;
		m_MaxDim=m_MaxDimDoneMaxLya;
		m_Dim=m_MinDimDoneMaxLya;
		m_Iter=m_IterLyaMax;
		m_NumberOf=m_NumberOfLyaMax;
		m_RadiusMin=m_RadiusMinLyaMax;
		m_RadiusMax=m_RadiusMaxLyaMax;
		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_ITER_STATIC);
		Text.LoadString(IDS_REFERENZVEKTOREN);
		Edit->SetWindowText(Text);
		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_STATIC);
		Text.LoadString(IDS_NUMRADII);
		Edit->SetWindowText(Text);
		break;
	case 2:
		m_Tau=m_TauKorr;
		m_NumPoints=m_NumPointsKorr;
		m_MaxDim=m_MaxDimKorr;
		m_Dim=m_DimKorr;
		m_Iter=m_IterKorr;
		m_NumberOf=m_NumberOfKorr;
		m_RadiusMin=m_RadiusMinKorr;
		m_RadiusMax=m_RadiusMaxKorr;
		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_MIN);
		Edit->ShowWindow(SW_HIDE);
		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_MAX);
		Edit->ShowWindow(SW_HIDE);
		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_FELD);
		Edit->ShowWindow(SW_HIDE);
		Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_SLIDER);
		Slider->ShowWindow(SW_HIDE);
		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_STATIC);
		Edit->ShowWindow(SW_HIDE);

		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_DIM_MIN);
		Edit->ShowWindow(SW_HIDE);
		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_DIM_FELD);
		Edit->ShowWindow(SW_HIDE);
		Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_DIM_SLIDER);
		Slider->ShowWindow(SW_HIDE);
		Text.LoadString(IDS_MAXEINBETTUNGSDIMENSION);
		m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemText(IDC_DIM_STATIC,Text);

		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_ITER_STATIC);
		Text.LoadString(IDS_NUMPAIRS);
		Edit->SetWindowText(Text);
		Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_STATIC);
		Text.LoadString(IDS_NUMRADII);
		Edit->SetWindowText(Text);
		break;
	}	

	Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_DIM_SLIDER);
	Slider->SetRange(1,m_MaxDim,TRUE);
	Slider->SetTicFreq( 1 );    
	Slider->SetLineSize( 1 );   
	Slider->SetPageSize( 2 );

	Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_SLIDER);
	Slider->SetTicFreq( 1 );    
	Slider->SetLineSize( 1 );   
	Slider->SetPageSize( 10 );
	Slider->SetRange(1,m_NumPoints,TRUE);

	Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_PUNKTE_SLIDER);
	Slider->SetTicFreq( 100 );    
	Slider->SetLineSize( 100 );   
	Slider->SetPageSize( 100 );
	Slider->SetRange(1,m_NumPoints,TRUE);

	Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_ITER_SLIDER);
	Slider->SetTicFreq( 10 );    
	Slider->SetLineSize( 10 );   
	Slider->SetPageSize( 100 );
	Slider->SetRange(1,m_NumPoints,TRUE);

	Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_SLIDER);
	Slider->SetRange(1,m_NumPoints,TRUE);

	CString strRadiusMin=Double2String(m_RadiusMin);
	CString strRadiusMax=Double2String(m_RadiusMax);

	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_TAU_FELD,m_Tau);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_PUNKTE_FELD,m_NumPoints);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_PUNKTE_MAX,m_NumPoints);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_NUMBEROF_FELD,m_NumberOf);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_NUMBEROF_MAX,m_NumberOf);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_DIM_FELD,m_Dim);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_DIM_MAX,m_MaxDim);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemText(IDC_RADIUS_MIN_FELD,strRadiusMin);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemText(IDC_RADIUS_MAX_FELD,strRadiusMax);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_ITER_FELD,m_Iter);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_REFERENZ_FELD,m_ReferenzLyaMax);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_REFERENZ_MAX,m_NumPoints);
	

	CSliderCtrl* SliderTau=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_TAU_SLIDER);
	SliderTau->SetTicFreq( 1 );    
	SliderTau->SetLineSize( 1 );   
	SliderTau->SetPageSize( 1 );
	SliderTau->SetRange( 0, 100, TRUE );

	CButton* Button1;
	CButton* Button2;
	CButton* Button3;
	Button1=(CButton*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_SPECLYA);
	Button2=(CButton*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_MAXLYA);
	Button3=(CButton*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_CHECK_KORR);
	switch(m_WhatIs) 
	{
	case 0:
		Button1->SetCheck(TRUE);
		break;
	case 1:
		Button2->SetCheck(TRUE);
		break;
	case 2:
		Button3->SetCheck(TRUE);
		break;
	}

	m_LyaSpektrum=(double**)malloc(sizeof(double*)*m_IterLya);
	for (int i=0;i<(INT)m_IterLya;i++)
		m_LyaSpektrum[i]=(double*)malloc(sizeof(double)*m_DimLya);
	m_LyaSpektrumLaenge=m_IterLya;

	m_LyaMax=(double**)malloc(sizeof(double*)*(m_MaxDimDoneMaxLya-1));
	for (i=0;i<(INT)(m_MaxDimDoneMaxLya-1);i++)
		m_LyaMax[i]=(double*)malloc(sizeof(double)*50); //50=Dummy
	m_LyaMaxLaenge=m_MaxDimDoneMaxLya;

	m_KorrDim=(double*)malloc(sizeof(double)*m_MaxDimKorr);

  m_KorrDimWerte=(double***)malloc(1*m_MaxDimKorr*sizeof(double**)*2);
  for (i=0;i<(LONG)(m_MaxDimKorr*1);i++)
	  m_KorrDimWerte[i]=(double**)malloc(m_NumberOfKorr*sizeof(double*));
	m_KorrDimLaengeI=m_MaxDimKorr;
  for (i=0;i<(LONG)(m_MaxDimKorr*1);i++)
		for (int j=0;j<(INT)m_NumberOfKorr;j++)
			m_KorrDimWerte[i][j]=(double*)malloc(2*sizeof(double));
	m_KorrDimLaengeII=m_NumberOfKorr;
	m_KorrDim_LastMaxDim=m_MaxDimKorr;
	m_KorrDim_LastNumberOf=m_NumberOfKorr;

	m_bIsMaxiLyaData=FALSE;
	m_bIsSpektrumLyaData=FALSE;
	m_bIsKorrData=FALSE;

	m_MaxLyapSteigung="";
	m_Nullpunkt.x=0;
	m_Nullpunkt.y=0;
	m_MoveMousePoint=m_Nullpunkt;
	m_DownMousePoint=m_Nullpunkt;
	m_UpMousePoint=m_Nullpunkt;
	
	m_Marker1=m_Nullpunkt;
	m_Marker2=m_Nullpunkt;
	
	m_Choose=IDYES;
	m_Choose2=IDYES;
}

/////////////////////////////////////////////////////////////////////////////
// Zeichnung CAnalyseView 

void CAnalyseView::OnDraw(CDC* pDC)
{
	CSoundsDoc* pDoc=GetDocument();
	if (pDoc->GetZeitreiheArray()->GetSize()>50) 
	{
		switch(m_WhatIs)
		{
		case 0:
			if (m_bIsSpektrumLyaData) ZeichneLyapunovSpektrum(pDC);
			break;
		case 1:
			if (m_bIsMaxiLyaData) ZeichneLyapunovMax(pDC);
			break;
		case 2:
			if (m_bIsKorrData) ZeichneKorrelationsdimension(pDC);
			break;
		}	
	}
}

void CAnalyseView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if (lHint==50)
	{
		Invalidate(FALSE);
	}
	if (g_bIsCapturing||g_bIsPlayingWave)
		Invalidate(FALSE);

	if (g_bIsPutPoints)
	{
		Invalidate(TRUE);
	}
	if (lHint==11) 
	{
		m_bIsMaxiLyaData=FALSE;
		m_bIsSpektrumLyaData=FALSE;
		m_bIsKorrData=FALSE;

		Invalidate(TRUE);
	}
}


void CAnalyseView::BerechneLyapunovSpektrum(CDC* pDC) 
{
	//Display hourglass
	BeginWaitCursor();

	CLyapunovKantz LyaKantz;
	CSoundsDoc* pDoc=GetDocument();
	CArray<DOUBLE,DOUBLE>* pZeitreiheArray=pDoc->GetZeitreiheArray();
	CArray<DOUBLE,DOUBLE> ZeitreiheArray;
	ZeitreiheArray.Copy(*pZeitreiheArray);
	int numberPts=ZeitreiheArray.GetSize();
	if (numberPts<m_NumPointsLya) m_NumPointsLya=numberPts;
	if (m_NumberOfLya==0) m_NumberOfLya=30;
	if (m_IterLya==0) m_IterLya=1000;
//	m_DimLya=3;
//	m_TauLya=1;
//	m_NumPointsLya=10000;
//	m_MaxDimLya=20;
//	m_RadiusMinLya=0.001;
	

	LyaKantz.SetParameters(m_IterLya,m_MaxDimLya,m_DimLya,m_TauLya,m_NumberOfLya,m_RadiusMinLya,0,0,0);

  for (int i=0;i<m_LyaSpektrumLaenge;i++)
		free(m_LyaSpektrum[i]);
	free(m_LyaSpektrum);

	double** DATA;
  DATA=(double**)malloc(sizeof(double*));	
//		DATA[0]=ZeitreiheArray.GetData();
	DATA[0]=(double*)malloc(sizeof(double)*m_NumPointsLya);	
	for (i=0;i<m_NumPointsLya;i++)
		DATA[0][i]=ZeitreiheArray[i];
	
	HWND hwnd=this->GetSafeHwnd();
	m_LyaSpektrum=LyaKantz.Calc_Lyap_Spektrum(pDC,hwnd,DATA,m_IterLya,m_NumPointsLya);
	m_LyaSpektrumLaenge=m_IterLya;
	ZeitreiheArray.RemoveAll();
//  for (i=0;i<m_NumPoints;i++)
//		free(DATA[0][i]);
	free(DATA[0]);
	free(DATA);
	if (!g_bIsBreak) 
		m_bIsSpektrumLyaData=TRUE;
	else
		g_bIsBreak=FALSE;
	//Parameter sichern
/*	m_NumPointsLya=m_NumPoints;
	m_IterLya=m_Iter;
	m_NumberOfLya=m_NumberOf;
	m_DimLya=m_Dim;
	m_TauLya=m_Tau;
	m_MaxDimLya=m_MaxDim;
	m_RadiusMinLya=m_RadiusMin;
*/

	//Alten Cursor zurcksetzen
	EndWaitCursor();
}

void CAnalyseView::ZeichneLyapunovSpektrum(CDC* pDC) 
{
	CLyapunovKantz LyaKantz;
	HWND hwnd=this->GetSafeHwnd();
	LyaKantz.DrawExponents(pDC,hwnd,m_LyaSpektrum,m_LyaSpektrumLaenge-m_DimLya*m_TauLya,m_LyaSpektrumLaenge,m_DimLya,m_TauLya);
}

void CAnalyseView::BerechneLyapunovMax(CDC* pDC) 
{
	//Display hourglass
	BeginWaitCursor();

	CLyapunovKantz LyaKantz;
	CSoundsDoc* pDoc=GetDocument();
	CArray<DOUBLE,DOUBLE>* pZeitreiheArray=pDoc->GetZeitreiheArray();
	CArray<DOUBLE,DOUBLE> ZeitreiheArray;
	ZeitreiheArray.Copy(*pZeitreiheArray);
	int numberPts=ZeitreiheArray.GetSize();
	if (numberPts<m_NumPointsLyaMax) m_NumPointsLyaMax=numberPts;
	m_ReferenzLyaMax=m_IterLyaMax;
	
	LyaKantz.SetParameters(m_IterLyaMax,m_MaxDimDoneMaxLya,m_MinDimDoneMaxLya,m_TauLyaMax,m_NumberOfLyaMax,m_RadiusMinLyaMax,m_RadiusMaxLyaMax,1,m_ReferenzLyaMax); //Iter==Referenz in der Berechnung
	double* DATA;

	for (int i=0;i<m_LyaMaxLaenge-1;i++)
    free(m_LyaMax[i]);
	free(m_LyaMax);
	m_IterationenDoneMaxLya=0;
	m_EpsilonsDoneMaxLya=0;

	DATA=(double*)malloc(sizeof(double)*m_NumPointsLyaMax);	
	for (i=0;i<m_NumPointsLyaMax;i++)
		DATA[i]=ZeitreiheArray[i];

//	DATA=ZeitreiheArray.GetData();
	HWND hwnd=this->GetSafeHwnd();
	m_LyaMax=LyaKantz.Calc_Max_Lyap_Exponent(pDC,hwnd,DATA,m_NumPointsLyaMax,&m_IterationenDoneMaxLya,&m_EpsilonsDoneMaxLya);
	ZeitreiheArray.RemoveAll();

	if (!g_bIsBreak) 
		m_bIsMaxiLyaData=TRUE;
	else
		g_bIsBreak=FALSE;

	ZeichneLyapunovMax(pDC);

	free(DATA);

 	//Alten Cursor zurcksetzen
	EndWaitCursor();
}
void CAnalyseView::ZeichneLyapunovMax(CDC* pDC) 
{
	CLyapunovKantz LyaKantz;
	HWND hwnd=this->GetSafeHwnd();
	LyaKantz.DrawLyapunovMax(pDC,hwnd,m_LyaMax,m_IterationenDoneMaxLya,m_EpsilonsDoneMaxLya,
													 m_MinDimDoneMaxLya,m_MaxDimDoneMaxLya);
	if (m_UpMousePoint.y>0&&m_MaxLyapSteigung!="") 
	{
		CAutoFont font("Arial");
		font.SetDC(pDC->GetSafeHdc());
		font.SetHeight(16);
		font.SetFontColor(RGB(0,0,0));
		font.SetEscapement(0);
		font.SetOrientation(0);
		pDC->SelectObject(&font);
		CRect rect;
		GetClientRect(rect);
		CPen Stift;
		Stift.CreatePen(PS_SOLID,3,RGB(0,0,0));
		pDC->SelectObject(&Stift);
		pDC->DrawText(m_MaxLyapSteigung,rect,DT_TOP|DT_CENTER);
		pDC->MoveTo(m_DownMousePoint);
		pDC->LineTo(m_UpMousePoint);
	}
}

void CAnalyseView::BerechneKorrelationsdimension(CDC* pDC) 
{
	//Display hourglass
	BeginWaitCursor();

	CLyapunovKantz LyaKantz;
	CSoundsDoc* pDoc=GetDocument();
	CArray<DOUBLE,DOUBLE>* pZeitreiheArray=pDoc->GetZeitreiheArray();
	CArray<DOUBLE,DOUBLE> ZeitreiheArray;
	ZeitreiheArray.Copy(*pZeitreiheArray);
	int numberPts=ZeitreiheArray.GetSize();
	if (numberPts<m_NumPointsKorr) m_NumPointsKorr=numberPts;

	m_Marker1=m_Nullpunkt;
	m_Marker2=m_Nullpunkt;

	LyaKantz.SetParameters(m_IterKorr,m_MaxDimKorr,m_DimKorr,m_TauKorr,m_NumberOfKorr,m_RadiusMinKorr,m_RadiusMaxKorr,2,0);

	double** DATA;
  DATA=(double**)malloc(sizeof(double*));	
//		DATA[0]=ZeitreiheArray.GetData();
	DATA[0]=(double*)malloc(sizeof(double)*m_NumPointsKorr);	
	for (int i=0;i<m_NumPointsKorr;i++)
		DATA[0][i]=ZeitreiheArray[i];

  for (i=0;i<m_KorrDimLaengeI;i++)
		for (int j=0;j<m_KorrDimLaengeII;j++)
			free(m_KorrDimWerte[i][j]);
  for (i=0;i<m_KorrDimLaengeI;i++)
		free(m_KorrDimWerte[i]);
  free(m_KorrDimWerte);
	m_KorrDim_LastMaxDim=m_MaxDimKorr;
	m_KorrDim_LastNumberOf=m_NumberOfKorr;

	HWND hwnd=this->GetSafeHwnd();
	m_KorrDimWerte=LyaKantz.Calc_Korr_Dim(pDC,hwnd,DATA,m_NumPointsKorr);
	m_KorrDimLaengeI=m_MaxDimKorr;
	m_KorrDimLaengeII=m_NumberOfKorr;
	ZeitreiheArray.RemoveAll();

	free(DATA[0]);
	free(DATA);

	if (!g_bIsBreak) 
		m_bIsKorrData=TRUE;
	else
		g_bIsBreak=FALSE;

	ZeichneKorrelationsdimension(pDC);

	//Alten Cursor zurcksetzen
	EndWaitCursor();
}

void CAnalyseView::ZeichneKorrelationsdimension(CDC* pDC) 
{
	CLyapunovKantz LyaKantz;
	HWND hwnd=this->GetSafeHwnd();
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
//	pDC->SelectPalette(pDoc->GetPalette(), FALSE);
//	pDC->RealizePalette();

	LyaKantz.DrawKorrDim(pDC,hwnd,m_KorrDimWerte,m_KorrDim_LastMaxDim,m_KorrDim_LastNumberOf,m_Marker1.x,m_Marker2.x);

	//Markerpunkte zeichnen
	CRect rect;
	GetClientRect(rect);
	pDC->SetROP2(R2_COPYPEN);
	CPen Markerstift;		
	Markerstift.CreatePen(PS_SOLID,1,RGB(0,0,255));
	pDC->SelectObject(&Markerstift);
	if (m_Marker1.x!=0)
	{
		pDC->MoveTo(m_Marker1.x,0);
		pDC->LineTo(m_Marker1.x,rect.bottom/2-BOTTOMBORDER);
	}
	if (m_Marker2.x!=0)
	{
		pDC->MoveTo(m_Marker2.x,0);
		pDC->LineTo(m_Marker2.x,rect.bottom/2-BOTTOMBORDER);
	}
}


void CAnalyseView::ReadData(int* window,int* num_of_points,int* m,double* MAX_VAL,double** data_array,int skip)
{
  double databit,buffer[100];
//	double* buffer = new double[100];
  int i,l,j=0;

	CSoundsDoc* pDoc=GetDocument();
	CArray<DOUBLE,DOUBLE>* pZeitreiheArray=pDoc->GetZeitreiheArray();
//	INT MaxAmplitude=ldexp(1,*pDoc->GetBitRate());
	i=0;
//  while (LyapunovHelper.ReadDoubleFromArray(&databit)==0 && i<=skip)
//    i++;
	// Filedaten schreiben
//	FILE *FileStream;
//	FileStream=fopen("d:\\AdrianBauernhaus\\Testfiles\\Rekonstruktion.txt","w");
  for(l=1;l<=(*m)*(*window);l++)
	{
    buffer[l]=pZeitreiheArray->GetAt(l);///MaxAmplitude;
  }
  i=0;
  while ((i<pZeitreiheArray->GetSize()-(*m)*(*window)-1 ) && (i<=*num_of_points))
	{
    i++;
    for (l=0;l< *window;l++)
		{
			data_array[i][l+1]=buffer[l* (*m) +1];
    }
    for (l=1;l<=(*m)*(*window) -1;l++)
			buffer[l]=buffer[l+1];
		databit=pZeitreiheArray->GetAt((*m)*(*window)+i);//MaxAmplitude;
    buffer[(*m)* (*window)]=databit;
	  if (databit<0) databit*=-1;
    if (*MAX_VAL < databit)
			*MAX_VAL=databit;
  }

  *num_of_points=i-1;

//	for (j=1;j<= *num_of_points;j++)
//		fprintf (FileStream,"%5d %+12.6f %+12.6f %12.6f\n", j, data_array[j][1],data_array[j][2],data_array[j][3]);
//
//	fclose(FileStream);
//
}


DOUBLE CAnalyseView::BerechnePunktweiseDimension(double** DATA, double* MAX_VAL, int GlobDim,
																							 int NumOfPoints,double Radius)
{
	DOUBLE Summendichte=0;
  srand( (unsigned)time( NULL ) );
	for (int k=0;k<m_Iter;k++)
	{
		int Count=0;
		DOUBLE Bezugsradius=2*Radius*(*MAX_VAL);
		INT Zufallsstelle=(INT)((DOUBLE)rand()/33040*(DOUBLE)NumOfPoints);
		for (int i=1;i<NumOfPoints; i++)
		{
			if (Abstand(DATA,Zufallsstelle,i,GlobDim)<Bezugsradius) 
				Count++;
		}
		DOUBLE CiVonR=(DOUBLE)Count/NumOfPoints;
		DOUBLE Dichte=Count==0?0:log(CiVonR)/log(Radius);
		Summendichte+=Dichte;
	}
	DOUBLE PunktweiseDimension=Summendichte/m_Iter;
	
	return PunktweiseDimension;
}
 
DOUBLE CAnalyseView::Abstand(double** DATA, INT Vektor1Nr, INT Vektor2Nr, INT Dimension)
{
	DOUBLE Summe=0; 
	for	( INT z=1; z<=Dimension; z++ )
	{
		Summe+=pow(DATA[Vektor1Nr][z]-DATA[Vektor2Nr][z],2);
	}
	return sqrt(Summe);
}

//******************************************************************************************************
//******************************************************************************************************
//******************************************************************************************************
void CAnalyseView::OnSave() 
{
	// Obtain a handle to a reference device context. 
	CDC* RefDC = GetDC(); 
 
	// Determine the picture frame dimensions. 
	// iWidthMM is the display width in millimeters. 
	// iHeightMM is the display height in millimeters. 
	// iWidthPels is the display width in pixels. 
	// iHeightPels is the display height in pixels 
 
	INT iWidthMM = GetDeviceCaps(RefDC->GetSafeHdc(), HORZSIZE); 
	INT iHeightMM = GetDeviceCaps(RefDC->GetSafeHdc(), VERTSIZE); 
	INT iWidthPels = GetDeviceCaps(RefDC->GetSafeHdc(), HORZRES); 
	INT iHeightPels = GetDeviceCaps(RefDC->GetSafeHdc(), VERTRES); 
 
	// Retrieve the coordinates of the client rectangle, in pixels. 
	CRect rect;
	GetClientRect(rect); 
 
	// Convert client coordinates to .01-mm units. 
	// Use iWidthMM, iWidthPels, iHeightMM, and 
	// iHeightPels to determine the number of 
	// .01-millimeter units per pixel in the x- 
	//  and y-directions. 
 
	rect.left = (rect.left * iWidthMM * 100)/iWidthPels; 
	rect.top = (rect.top * iHeightMM * 100)/iHeightPels; 
	rect.right = (rect.right * iWidthMM * 100)/iWidthPels; 
	rect.bottom = (rect.bottom * iHeightMM * 100)/iHeightPels; 
 
	// Load the filename Dialog
	CFileDialog SaveAnalyseFileDlg(FALSE,NULL,NULL,OFN_OVERWRITEPROMPT|OFN_NOREADONLYRETURN|OFN_ENABLESIZING,\
              "WMF - Enhanced Metafile|*.wmf|");
  SaveAnalyseFileDlg.m_ofn.nFilterIndex=1;
	SaveAnalyseFileDlg.m_ofn.lpstrDefExt=".wmf";
	CString Text;
	Text.LoadString(IDS_SAVE_ANALYSE);
	SaveAnalyseFileDlg.m_ofn.lpstrTitle=Text.GetBuffer(Text.GetLength());
  if (SaveAnalyseFileDlg.DoModal()==IDOK) 
	{
		BeginWaitCursor();

		// Create the metafile device context. 
		CString Pfad=SaveAnalyseFileDlg.GetPathName();
		LPTSTR strFileName=Pfad.GetBuffer(MAX_PATH);
		CMetaFileDC MetaFileDC;
		MetaFileDC.CreateEnhanced(RefDC,strFileName,rect,"SOUNDS Soundanalyse\0Analyse Abbild\0\0");

		switch(m_WhatIs)
		{	
		case 0:
			if (m_bIsSpektrumLyaData) ZeichneLyapunovSpektrum(&MetaFileDC);
			break;
		case 1:
			if (m_bIsMaxiLyaData) ZeichneLyapunovMax(&MetaFileDC);
			break;
		case 2:
//			if (m_bIsKorrData) ZeichneKorrelationsdimension(&MetaFileDC,m_KorrDimLaengeI);
			if (m_bIsKorrData) ZeichneKorrelationsdimension(&MetaFileDC);
			break;
		}

		HENHMETAFILE pMetaFile=MetaFileDC.CloseEnhanced();
		DeleteEnhMetaFile(pMetaFile);

		//Alten Cursor zurcksetzen
		EndWaitCursor();

	}
	// Release the reference device context. 
	ReleaseDC(RefDC); 	
}

void CAnalyseView::OnEditCopy() 
{
	BeginWaitCursor();

	CMetaFileDC * pMetaDC = new CMetaFileDC();
	pMetaDC->CreateEnhanced(GetDC(),NULL,NULL,"SOUNDS Soundanalyse\0Analyse Abbild\0\0");
	//draw meta file
		switch(m_WhatIs)
		{	
		case 0:
			if (m_bIsSpektrumLyaData) ZeichneLyapunovSpektrum(pMetaDC);
			break;
		case 1:
			if (m_bIsMaxiLyaData) ZeichneLyapunovMax(pMetaDC);
			break;
		case 2:
//			if (m_bIsKorrData) ZeichneKorrelationsdimension(pMetaDC,m_KorrDimLaenge);
			if (m_bIsKorrData) ZeichneKorrelationsdimension(pMetaDC);
			break;
		}


	//close meta file dc and prepare for clipboard;
	HENHMETAFILE hMF = pMetaDC->CloseEnhanced();

	//copy to clipboard
	// Open the clipboard...
	if(!OpenClipboard()) 
	{
    AfxMessageBox(IDS_OPEN_CLIPBOARD_FAIL);
    return;
	}
	EmptyClipboard();
	::SetClipboardData(CF_ENHMETAFILE,hMF);
	CloseClipboard();
	//DeleteMetaFile(hMF);
	delete pMetaDC;

	//Alten Cursor zurcksetzen
	EndWaitCursor();
}

void CAnalyseView::OnCalculate() 
{
	CDC* pDC=GetDC();
	
	CSoundsDoc* pDoc=GetDocument();
	OnCls();

	if(pDoc->GetZeitreiheArray()->GetSize()<50)
	{
		CRect rect;
		GetClientRect(rect);
		CAutoFont font("Century Gothic");
		font.SetDC(pDC->GetSafeHdc());
		font.SetHeight(20);
		font.SetFontColor(RGB(0,0,0));
		pDC->SelectObject(&font);
		CString Text;
		Text.LoadString(E_ONCALCULATE);
		pDC->DrawText(Text,rect,DT_WORDBREAK);
	}
	else
	{
		CSliderCtrl* Slider;
		switch(m_WhatIs) 
		{
			case 0:
				if (m_Iter>1000&&m_Choose2==IDYES)
				{
					char buffer[20];
					CString strDaten=itoa( m_Iter, buffer, 10 );
					CString Text;
					AfxFormatString1(Text,IDS_STRINGLYAEXP,strDaten);
					if ((m_Choose2=AfxMessageBox(Text,MB_YESNO))==IDYES) 
					m_Iter=1000;	
				}
				Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_ITER_SLIDER);
				Slider->SetPos(m_Iter);
				m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_ITER_FELD,m_Iter);
				BerechneLyapunovSpektrum(pDC);
				break;
			case 1:
				if (m_IterLyaMax>50&&m_WhatIs==1&&m_Choose==IDYES) 
				{
					char buffer[20];
					CString strDaten=itoa( m_IterLyaMax, buffer, 10 );
					CString Text;
					AfxFormatString1(Text,IDS_STRINGMAXLYA,strDaten);
					if ((m_Choose=AfxMessageBox(Text,MB_YESNO))==IDYES) 
						m_IterLyaMax=50;
				}
				Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_SLIDER);
				Slider->SetPos(m_IterLyaMax);
				m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_REFERENZ_FELD,m_IterLyaMax);
				BerechneLyapunovMax(pDC);
				break;
			case 2:
				BerechneKorrelationsdimension(pDC);
				break;
			default:
				AfxMessageBox(IDS_STRING_ANALYSE_FAULT_CASE);
		} 
	}
}


void CAnalyseView::OnCheckMaxlya() 
{
	m_WhatIs=1;

	CSliderCtrl* Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_SLIDER);
	Slider->ShowWindow(SW_SHOW);

	CEdit* Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_RADIUS_MIN);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_RADIUS_MAX);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_RADIUS_MAX_FELD);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_MIN);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_MAX);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_FELD);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_SLIDER);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_STATIC);
	Edit->ShowWindow(SW_SHOW);

	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_DIM_MIN);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_DIM_FELD);
	Edit->ShowWindow(SW_SHOW);
	Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_DIM_SLIDER);
	Slider->ShowWindow(SW_SHOW);
	CString Text;
	Text.LoadString(IDS_EINBETTUNGSDIMENSION);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemText(IDC_DIM_STATIC,Text);

	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_MIN);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_MAX);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_FELD);
	Edit->ShowWindow(SW_SHOW);
	Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_SLIDER);
	Slider->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_STATIC);
	Edit->ShowWindow(SW_SHOW);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_REFERENZ_FELD,m_IterLyaMax);


	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_ITER_STATIC);
	Text.LoadString(IDS_REFERENZVEKTOREN);
	Edit->SetWindowText(Text);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_STATIC);
	Text.LoadString(IDS_NUMRADII);
	Edit->SetWindowText(Text);

	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_TAU_FELD,1);
	Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_SLIDER);
	Slider->SetRange(1,100);
	
//	Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_ITER_SLIDER);
////	Slider->SetRange(1,m_NumPointsLyaMax);
//	Slider->SetPos(m_ReferenzLyaMax);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_ITER_FELD,m_ReferenzLyaMax);

	CString strRadiusMin=Double2String(m_RadiusMinLyaMax);
	CString strRadiusMax=Double2String(m_RadiusMaxLyaMax);

	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_TAU_FELD,m_TauLyaMax);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_PUNKTE_FELD,m_NumPointsLyaMax);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_NUMBEROF_FELD,m_NumberOfLyaMax);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemText(IDC_NUMBEROF_MAX,"100");
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_DIM_FELD,m_MinDimDoneMaxLya);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_DIM_MAX,m_MaxDimDoneMaxLya);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemText(IDC_RADIUS_MIN_FELD,strRadiusMin);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemText(IDC_RADIUS_MAX_FELD,strRadiusMax);

//	CDC* pDC=GetDC();
//	if (m_bIsMaxiLyaData) ZeichneLyapunovMax(pDC);
		Invalidate(TRUE);

}

void CAnalyseView::OnCheckSpeclya() 
{
	m_WhatIs=0;
	CString Text;
	CSliderCtrl* Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_SLIDER);
	Slider->ShowWindow(SW_SHOW);

	CEdit* Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_RADIUS_MIN);
	Edit->ShowWindow(SW_HIDE);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_RADIUS_MAX);
	Edit->ShowWindow(SW_HIDE);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_RADIUS_MAX_FELD);
	Edit->ShowWindow(SW_HIDE);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_MIN);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_MAX);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_FELD);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_SLIDER);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_STATIC);
	Edit->ShowWindow(SW_SHOW);

	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_ITER_STATIC);

	Text.LoadString(IDS_ITERATIONEN);
	Edit->SetWindowText(Text);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_STATIC);
	Text.LoadString(IDS_NUMNEIGHBORS);
	Edit->SetWindowText(Text);

	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_MIN);
	Edit->ShowWindow(SW_HIDE);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_MAX);
	Edit->ShowWindow(SW_HIDE);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_FELD);
	Edit->ShowWindow(SW_HIDE);
	Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_SLIDER);
	Slider->ShowWindow(SW_HIDE);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_STATIC);
	Edit->ShowWindow(SW_HIDE);

	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_DIM_MIN);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_DIM_FELD);
	Edit->ShowWindow(SW_SHOW);
	Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_DIM_SLIDER);
	Slider->ShowWindow(SW_SHOW);
	Slider->SetRange(1,m_MaxDimLya,TRUE);
	Slider->SetPos(m_DimLya);
	Text.LoadString(IDS_EINBETTUNGSDIMENSION);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemText(IDC_DIM_STATIC,Text);

	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_TAU_FELD,m_TauLya);
	Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_SLIDER);
	Slider->SetRange(1,500);
	Slider->SetPos(m_NumberOfLya);

//	Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_ITER_SLIDER);
//	Slider->SetRange(1,m_NumPointsLya);
//	Slider->SetPos(m_IterLya);

	CString strRadius=Double2String(m_RadiusMinLya);

	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_PUNKTE_FELD,m_NumPointsLya);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_NUMBEROF_FELD,m_NumberOfLya);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_ITER_FELD,m_IterLya);
//	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_ITER_MAX,m_NumPointsLya);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_NUMBEROF_MAX,500);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_DIM_FELD,m_DimLya);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_DIM_MAX,m_MaxDimLya);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemText(IDC_RADIUS_MIN_FELD,strRadius);

//	CDC* pDC=GetDC();
//	if (m_bIsSpektrumLyaData) ZeichneLyapunovSpektrum(pDC);
		Invalidate(TRUE);

}

void CAnalyseView::OnCheckKorr() 
{
	m_WhatIs=2;
	CString Text;

	CSliderCtrl* Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_SLIDER);
	Slider->ShowWindow(SW_SHOW);

	CEdit* Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_RADIUS_MIN);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_RADIUS_MAX);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_RADIUS_MAX_FELD);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_MIN);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_MAX);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_FELD);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_SLIDER);
	Edit->ShowWindow(SW_SHOW);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_STATIC);
	Edit->ShowWindow(SW_SHOW);

	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_MIN);
	Edit->ShowWindow(SW_HIDE);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_MAX);
	Edit->ShowWindow(SW_HIDE);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_FELD);
	Edit->ShowWindow(SW_HIDE);
	Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_SLIDER);
	Slider->ShowWindow(SW_HIDE);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_STATIC);
	Edit->ShowWindow(SW_HIDE);


	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_DIM_MIN);
	Edit->ShowWindow(SW_HIDE);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_DIM_FELD);
	Edit->ShowWindow(SW_HIDE);
	Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_DIM_SLIDER);
	Slider->ShowWindow(SW_HIDE);

	Text.LoadString(IDS_MAXEINBETTUNGSDIMENSION);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemText(IDC_DIM_STATIC,Text);

	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_ITER_STATIC);
	Text.LoadString(IDS_NUMPAIRS);
	Edit->SetWindowText(Text);
	Edit=(CEdit*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_STATIC);
	Text.LoadString(IDS_NUMRADII);
	Edit->SetWindowText(Text);
//	Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_ITER_SLIDER);
//	Slider->SetRange(1,m_NumPoints);
//	Slider->SetPos(m_NumPoints>300?300:m_NumPoints);

	CString strRadiusMin=Double2String(m_RadiusMinKorr);
	CString strRadiusMax=Double2String(m_RadiusMaxKorr);

	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_TAU_FELD,m_TauKorr);
	Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_SLIDER);
	Slider->SetRange(1,1000);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_PUNKTE_FELD,m_NumPointsKorr);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_NUMBEROF_FELD,m_NumberOfKorr);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_NUMBEROF_MAX,1000);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_ITER_FELD,m_IterKorr);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_ITER_MAX,m_NumPointsKorr);
//	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_DIM_FELD,2);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_DIM_MAX,m_MaxDimKorr);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemText(IDC_RADIUS_MIN_FELD,strRadiusMin);
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemText(IDC_RADIUS_MAX_FELD,strRadiusMax);

//	CDC* pDC=GetDC();
//	if (m_bIsKorrData) ZeichneKorrelationsdimension(pDC);
	Invalidate(TRUE);
}

CString CAnalyseView::Double2String(DOUBLE dblWert)
{
	int dec;
	int sign;

	CString strWert=ecvt(dblWert,3, &dec,&sign );
	if (dec<=0) 
		for(int z=0;z<=abs(dec);z++) strWert.Insert(0,'0');
	if (dec<=0) strWert.Insert(1,'.');
	else strWert.Insert(dec,'.');

	return strWert;
}

void CAnalyseView::OnChangeDimFeld() 
{
	m_Dim=m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItemInt(IDC_DIM_FELD);
	if (m_Dim>m_MaxDim)
	{
		m_Dim=m_MaxDim;
		m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_DIM_FELD,m_Dim);
	}
	if (m_Dim<2)
	{
		m_Dim=2;
		m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_DIM_FELD,m_Dim);
	}
	CSliderCtrl* Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_DIM_SLIDER);
	Slider->SetPos(m_Dim);
	switch(m_WhatIs) {
	case 0:
		m_DimLya=m_Dim;
		break;
	case 1:
		m_MinDimDoneMaxLya=m_Dim;
		break;
	case 2:
		m_DimKorr=m_Dim;
		break;
	}
}

void CAnalyseView::OnChangeDimMax() 
{
	m_MaxDim=m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItemInt(IDC_DIM_MAX);
	CSliderCtrl* Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_DIM_SLIDER);
	if (m_MaxDim<2)
	{
		m_MaxDim=2;
		m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_DIM_MAX,m_MaxDim);
	}
	if (m_Dim>m_MaxDim)
	{
		m_Dim=m_MaxDim;
		m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_DIM_FELD,m_Dim);
	}
	Slider->SetPos(m_Dim);
	//	Slider->SetRange(m_Dim,m_MaxDim,TRUE);
	Slider->SetRange(2,m_MaxDim,TRUE);
	switch(m_WhatIs) {
	case 0:
		m_MaxDimLya=m_MaxDim;
		break;
	case 1:
		m_MaxDimDoneMaxLya=m_MaxDim;
		break;
	case 2:
		m_MaxDimKorr=m_MaxDim;
		break;
	}
}

void CAnalyseView::OnChangeIterFeld() 
{
	m_Iter=m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItemInt(IDC_ITER_FELD);
	if (m_Iter>m_NumPoints) 
	{
		m_Iter=m_NumPoints;
		m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_ITER_FELD,m_Iter);
	}
	CSliderCtrl* Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_ITER_SLIDER);
	Slider->SetPos(m_Iter);
	if (m_WhatIs==1) m_ReferenzLyaMax=m_Iter;
	switch(m_WhatIs) {
	case 0:
		m_IterLya=m_Iter;
		break;
	case 1:
		//m_IterMaxLya=m_Iter;
		break;
	case 2:
		m_IterKorr=m_Iter;
		break;
	}
}

void CAnalyseView::OnChangeNumberofFeld() 
{
	m_NumberOf=m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItemInt(IDC_NUMBEROF_FELD);
	if (m_NumberOf>m_NumPoints) 
	{
		m_NumberOf=m_NumPoints;
		m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_NUMBEROF_FELD,m_NumberOf);
	}
/*	if (m_WhatIs==2&&m_NumberOf>300)
	{
		m_NumberOf=300;
		m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_NUMBEROF_FELD,m_NumberOf);
	}
*/
	CSliderCtrl* Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_SLIDER);
	Slider->SetPos(m_NumberOf);
	switch(m_WhatIs) {
	case 0:
		m_NumberOfLya=m_NumberOf;
		break;
	case 1:
		m_NumberOfLyaMax=m_NumberOf;
		break;
	case 2:
		m_NumberOfKorr=m_NumberOf;
		break;
	}

}

void CAnalyseView::OnChangeRadiusMaxFeld() 
{
	CString Text;
	m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItemText(IDC_RADIUS_MAX_FELD,Text);
  char *test[50],str[50];
  strcpy(str,(char *)Text.GetBuffer(10));
  m_RadiusMax=strtod(str,test);
	switch(m_WhatIs) {
	case 0:
//		m_RadiusMaxLy=m_RadiusMax;
		break;
	case 1:
		m_RadiusMaxLyaMax=m_RadiusMax;
		break;
	case 2:
		m_RadiusMaxKorr=m_RadiusMax;
		break;
	}

}

void CAnalyseView::OnChangeRadiusMinFeld() 
{
	CString Text;
	m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItemText(IDC_RADIUS_MIN_FELD,Text);
  char *test[50],str[50];
  strcpy(str,(char *)Text.GetBuffer(10));
  m_RadiusMin=strtod(str,test);
	switch(m_WhatIs) {
	case 0:
		m_RadiusMinLya=m_RadiusMin;
		break;
	case 1:
		m_RadiusMinLyaMax=m_RadiusMin;
		break;
	case 2:
		m_RadiusMinKorr=m_RadiusMin;
		break;
	}
}

void CAnalyseView::OnChangeTauFeld() 
{
	m_Tau=m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItemInt(IDC_TAU_FELD);
	CSliderCtrl* Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_TAU_SLIDER);
	Slider->SetPos(m_Tau);
	switch(m_WhatIs) {
	case 0:
		m_TauLya=m_Tau;
		break;
	case 1:
		m_TauLyaMax=m_Tau;
		break;
	case 2:
		m_TauKorr=m_Tau;
		break;
	}

}

void CAnalyseView::OnChangePunkteFeld() 
{	
	m_NumPoints=m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItemInt(IDC_PUNKTE_FELD);
	CSliderCtrl* Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_PUNKTE_SLIDER);
	Slider->SetPos(m_NumPoints);
	if (m_NumberOf>m_NumPoints)
	{
		m_NumberOf=m_NumPoints;
		Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_SLIDER);
		Slider->SetPos(m_NumberOf);
		m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_NUMBEROF_FELD,m_NumberOf);
	}
	if (m_Iter>m_NumPoints)
	{
		m_Iter=m_NumPoints;
		if (m_WhatIs==1) m_ReferenzLyaMax=m_Iter;

		Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_ITER_SLIDER);
		Slider->SetPos(m_Iter);
		m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_ITER_FELD,m_Iter);
	}
	switch(m_WhatIs) {
	case 0:
		m_NumPointsLya=m_NumPoints;
		break;
	case 1:
		m_NumPointsLyaMax=m_NumPoints;
		break;
	case 2:
		m_NumPointsKorr=m_NumPoints;
		break;
	}
}	

void CAnalyseView::OnChangeReferenzFeld() 
{
	m_IterLyaMax=m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItemInt(IDC_REFERENZ_FELD);
	CSliderCtrl* Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_SLIDER);
	Slider->SetPos(m_IterLyaMax);
}

void CAnalyseView::OnCls() 
{
	CDC* pDC=GetDC();
	CRect rect;
	GetClientRect(rect);
	pDC->FillSolidRect(rect,RGB(255,255,255));
	m_Choose=IDYES;
}


void CAnalyseView::OnReleasedcaptureReferenzSlider(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CSliderCtrl* Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_REFERENZ_SLIDER);
	int Stelle=Slider->GetPos();
	m_IterLyaMax=Stelle;
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_REFERENZ_FELD,m_IterLyaMax);
	*pResult = 0;
}


void CAnalyseView::OnReleasedcaptureDimSlider(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CSliderCtrl* Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_DIM_SLIDER);
	int Stelle=Slider->GetPos();
	m_Dim=Stelle;
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_DIM_FELD,m_Dim);
	*pResult = 0;
}

void CAnalyseView::OnReleasedcaptureIterSlider(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CSliderCtrl* Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_ITER_SLIDER);
	int Stelle=Slider->GetPos();
	m_Iter=Stelle;
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_ITER_FELD,m_Iter);
	*pResult = 0;
}

void CAnalyseView::OnReleasedcaptureNumberofSlider(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CSliderCtrl* Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_NUMBEROF_SLIDER);
	int Stelle=Slider->GetPos();
	m_NumberOf=Stelle;
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_NUMBEROF_FELD,m_NumberOf);

	*pResult = 0;
}

void CAnalyseView::OnReleasedcapturePunkteSlider(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CSliderCtrl* Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_PUNKTE_SLIDER);
	int Stelle=Slider->GetPos();
	m_NumPoints=Stelle;
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_PUNKTE_FELD,m_NumPoints);
	*pResult = 0;
}

void CAnalyseView::OnReleasedcaptureTauSlider(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CSliderCtrl* Slider=(CSliderCtrl*)m_pParentAnalyseFrame->m_wndDlgBar.GetDlgItem(IDC_TAU_SLIDER);
	int Stelle=Slider->GetPos();
	m_Tau=Stelle;
	m_pParentAnalyseFrame->m_wndDlgBar.SetDlgItemInt(IDC_TAU_FELD,m_Tau);
	*pResult = 0;
}

void CAnalyseView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CDC* pDC=GetDC();
	CRect rect;
	GetClientRect(rect);
	if	(m_WhatIs==1&&m_bIsMaxiLyaData)
	{
		pDC->SetROP2(R2_NOT);
		pDC->MoveTo(m_DownMousePoint);
		pDC->LineTo(m_UpMousePoint);
		m_TopYPlus=0;
		m_TopYMinus=0;
		m_XWert1=0;
		m_XWert2=0;
		m_YWert1=0;
		m_YWert2=0;
		m_FaktorXMaxLya=0;
		m_FaktorYMaxLya=0;

		double MaxData=0;
	  for (int i=m_MinDimDoneMaxLya-2;i<m_MaxDimDoneMaxLya-1;i++) 
		{
	    for (int j=0;j<=m_LyaMaxLaenge;j++)
			{
				if (m_LyaMax[i][j]<MaxData) 
					MaxData=m_LyaMax[i][j];
			}
		 }
		MaxData=fabs(MaxData);
		
		//Bildschirmskalierung berechnen
		m_FaktorXMaxLya=(rect.right-LEFTBORDER)/(m_IterationenDoneMaxLya+1);
		m_FaktorYMaxLya=(rect.bottom-BOTTOMBORDER)/MaxData;

		m_XWert1=(point.x-LEFTBORDER)/m_FaktorXMaxLya;
		m_YWert1=point.y/m_FaktorYMaxLya;
		m_DownMousePoint=point;
		m_MoveMousePoint=point;
	}
	CView::OnLButtonDown(nFlags, point);
}

void CAnalyseView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CDC* pDC=GetDC();
	CRect rect;
	GetClientRect(rect);
	if	(m_WhatIs==1&&m_bIsMaxiLyaData)
	{
		m_UpMousePoint=point;
		pDC->SetROP2(R2_NOT);
		pDC->MoveTo(m_DownMousePoint);
		pDC->LineTo(m_MoveMousePoint);
		pDC->SetROP2(R2_COPYPEN);
		pDC->MoveTo(m_DownMousePoint);
		pDC->LineTo(m_UpMousePoint);

		CAutoFont font("Arial");
		font.SetDC(pDC->GetSafeHdc());
		font.SetHeight(16);
		font.SetFontColor(RGB(0,0,0));
		font.SetEscapement(0);
		font.SetOrientation(0);
		pDC->SelectObject(&font);

		m_XWert2=(point.x-LEFTBORDER)/m_FaktorXMaxLya;
		m_YWert2=point.y/m_FaktorYMaxLya;
		double Steigung=-(m_YWert2-m_YWert1)/(m_XWert2-m_XWert1);
		int dec;
		int sign;
		CString strSteigung=ecvt(Steigung,10, &dec,&sign );
		if (dec<=0) 
			for(int z=0;z<=abs(dec);z++) strSteigung.Insert(0,'0');
		if (dec<=0) 
			strSteigung.Insert(1,'.');
		else 
			strSteigung.Insert(dec,'.');
		if (sign!=0) strSteigung.Insert(0,'-');
		CString Text;
		Text.LoadString(IDS_STEIGUNG);
		strSteigung=Text + strSteigung.Left(6);
		pDC->DrawText(strSteigung,rect,DT_TOP|DT_CENTER);
		m_MaxLyapSteigung=strSteigung;
	}
	if	(m_WhatIs==2&&m_bIsKorrData)
	{
		switch(IsAtMarkerLine(&point)) 
		{
		case 0:
			if (m_Marker1.x==0) 
				m_Marker1=point;
			else  if (m_Marker2.x==0)
							m_Marker2=point;
						else
						{
							if (abs(m_Marker1.x-point.x)<abs(m_Marker2.x-point.x)) 
								m_Marker1=point;
							else
								m_Marker2=point;
						}
			break;
		case 1:
			m_Marker1=m_Nullpunkt;
		break;
		case 2:
			m_Marker2=m_Nullpunkt;
		break;
		}

		if (m_Marker1.x>m_Marker2.x&&m_Marker1.x!=0&&m_Marker2.x!=0) 
		{
			POINT TempPoint;
			TempPoint=m_Marker1;
			m_Marker1=m_Marker2;
			m_Marker2=TempPoint;
		}
		Invalidate(TRUE);
	}
	CView::OnLButtonUp(nFlags, point);
}

void CAnalyseView::OnMouseMove(UINT nFlags, CPoint point) 
{
	CDC* pDC=GetDC();
	CRect rect;
	GetClientRect(rect);
	if	(m_WhatIs==1&&nFlags==MK_LBUTTON&&m_bIsMaxiLyaData)
	{
//		Invalidate(TRUE);
		m_XWert2=(point.x-LEFTBORDER)/m_FaktorXMaxLya;
		m_YWert2=point.y/m_FaktorYMaxLya;
		double Steigung=-(m_YWert2-m_YWert1)/(m_XWert2-m_XWert1);
		pDC->SetROP2(R2_NOT);
		pDC->MoveTo(m_DownMousePoint);
		pDC->LineTo(m_MoveMousePoint);
		pDC->MoveTo(m_DownMousePoint);
		pDC->LineTo(point);

		CAutoFont font("Arial");
		font.SetDC(pDC->GetSafeHdc());
		font.SetHeight(16);
		font.SetFontColor(RGB(0,0,0));
		font.SetEscapement(0);
		font.SetOrientation(0);
		pDC->SelectObject(&font);

		int dec;
		int sign;
		CString strSteigung=ecvt(Steigung,10, &dec,&sign );
		if (dec<=0) 
			for(int z=0;z<=abs(dec);z++) strSteigung.Insert(0,'0');
		if (dec<=0) 
			strSteigung.Insert(1,'.');
		else 
			strSteigung.Insert(dec,'.');
		if (sign!=0) strSteigung.Insert(0,'-');
		CString Text;
		Text.LoadString(IDS_STEIGUNG);
		strSteigung=Text+ strSteigung.Left(6);
		pDC->DrawText(strSteigung,rect,DT_TOP|DT_CENTER);
		m_MoveMousePoint=point;
	}
	if	(m_WhatIs==2&&nFlags==MK_LBUTTON&&m_bIsKorrData)
  {

	}
	CView::OnMouseMove(nFlags, point);
}

int CAnalyseView::IsAtMarkerLine(POINT* ppoint)
{
	if (abs(m_Marker1.x - ppoint->x)<5)
		return 1;
	if (abs(m_Marker2.x - ppoint->x)<5)
		return 2;

	return 0;
}


BOOL CAnalyseView::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	CSoundsDoc* pDoc=GetDocument();
	pDoc->m_help.SetHelpFile(pDoc->m_strHelpFile);
	pDoc->m_help.DisplayTopic("html/Zeitreihenanalysefenster.html");
	
	return CView::OnHelpInfo(pHelpInfo);
}

