// CaptureThread.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "RecordData.h"
#include "CaptureThread.h"
#include "SoundsDoc.h"

UINT CaptureThreadProc(LPVOID pParam)
{

	CCaptureThreadInfo* pCaptureThreadInfo = (CCaptureThreadInfo*)pParam;
	pCaptureThreadInfo->m_pCaptureWaveFile=NULL;
	//	CWaveFile* pRecordWaveFile=NULL;
//  pRecordWaveFile = new CWaveFile;

	
	//-----------------------------------------------------------------------------
	// Desc: Creates a capture buffer and sets the format 
	//-----------------------------------------------------------------------------
 DSCBUFFERDESC dscbd;
	DWORD dwNotifySize;
	DWORD dwCaptureBufferSize;
	DWORD dwNextCaptureOffset;
	LPDIRECTSOUNDCAPTUREBUFFER pDSBCapture;
	LPDIRECTSOUNDNOTIFY        pDSNotify;
	DSBPOSITIONNOTIFY          aPosNotify[NUM_REC_NOTIFICATIONS+1];  

	ZeroMemory( &aPosNotify, sizeof(DSBPOSITIONNOTIFY) * (NUM_REC_NOTIFICATIONS + 1) );

  // Set the notification size
  dwNotifySize  = pCaptureThreadInfo->m_NumFFTPoints;
  dwNotifySize  -=  dwNotifySize % pCaptureThreadInfo->m_pwfxInput->nBlockAlign;   
  // Set the buffer sizes 
  dwCaptureBufferSize = dwNotifySize * NUM_REC_NOTIFICATIONS;

  // Create the capture buffer
  ZeroMemory( &dscbd, sizeof(dscbd) );
  dscbd.dwSize        = sizeof(dscbd);
  dscbd.dwBufferBytes = dwCaptureBufferSize;
  dscbd.lpwfxFormat   = pCaptureThreadInfo->m_pwfxInput; // Set the format during creation

  if( FAILED(theApp.m_pDSCapture->CreateCaptureBuffer( &dscbd, &pDSBCapture, NULL ) ) )
        AfxMessageBox(E_CAPTURETHREAD_CREATEBUFFER);

  dwNextCaptureOffset = 0;

	//-----------------------------------------------------------------------------
	// Desc: Inits the notifications on the capture buffer 
	//-----------------------------------------------------------------------------

  // Create a notification event, for when the sound stops playing
  if( FAILED( pDSBCapture->QueryInterface( IID_IDirectSoundNotify, (VOID**)&pDSNotify ) ) )
      AfxMessageBox(E_CAPTURETHREAD_QUERYINTERFACE);

  // Setup the notification positions
  for( INT i = 0; i < NUM_REC_NOTIFICATIONS; i++ )
  {
    aPosNotify[i].dwOffset = (dwNotifySize * i) + dwNotifySize - 1;
    aPosNotify[i].hEventNotify = pCaptureThreadInfo->m_hEventCaptureBufferNotify;             
  }
    
  // Tell DirectSound when to notify us. the notification will come in the from 
  // of signaled events that are handled in WinMain()
  if( FAILED( pDSNotify->SetNotificationPositions( NUM_REC_NOTIFICATIONS, aPosNotify ) ) )
      AfxMessageBox(E_CAPTURETHREAD_SETNOTIFICATIONPOSITIONS);

	pCaptureThreadInfo->m_pDSBCapture=pDSBCapture;
	pDSBCapture->Start( DSCBSTART_LOOPING );


	BOOL FileHolen=TRUE;
	BOOL bSoundCaptureDone;
	while (g_bIsCapturing)
	{
		if (g_bIsRecording && FileHolen)
		{
			//Dummy entfernen
			SAFE_DELETE (pCaptureThreadInfo->m_pCaptureWaveFile);

			  // Load the wave file
				pCaptureThreadInfo->m_pCaptureWaveFile = new CWaveFile;

				
				//Standarddateidialog bei Grundschulmodus
				CString WaveName;
  			WaveName = theApp.GetModulPath()+"Aufnahme.wav";
			  LPTSTR strFileName=WaveName.GetBuffer(MAX_PATH);

				
				if( FAILED( pCaptureThreadInfo->m_pCaptureWaveFile->Open( strFileName, pCaptureThreadInfo->m_pwfxInput, WAVEFILE_WRITE ) ) )
						AfxMessageBox(E_CAPTURETHREAD_WAVEFILEOPEN);
				pCaptureThreadInfo->m_strRecordFile=strFileName;
				FileHolen=FALSE;
		}

		// This capturing thread runs in an infinite loop, waiting to capture the
		// buffers whenever the main application thread sets the "do capture" event.
		// The recalc thread exits the loop only when the main application sets the
		// "kill thread" event.

		bSoundCaptureDone = FALSE;

		if (WaitForSingleObject(pCaptureThreadInfo->m_hEventCaptureBufferNotify, INFINITE)!= WAIT_OBJECT_0)
			break;

		// Exit the thread if the main application sets the "kill recalc"
		// event. The main application will set the "start recalc" event
		// before setting the "kill recalc" event.

		if (WaitForSingleObject(pCaptureThreadInfo->m_hEventKillCaptureThread, 0)	== WAIT_OBJECT_0)
			break; // Terminate this thread by existing the proc.

		CArray<DOUBLE,DOUBLE> Array1,Array2;
		Array1.RemoveAll();
		Array1.Add(0);
		Array2.RemoveAll();
		Array2.Add(0);
		pCaptureThreadInfo->m_pThreadFrequenzenArray=&Array1;
		pCaptureThreadInfo->m_pThreadZeitreiheArray=&Array2;

		// Reset event to indicate "not done", that is, recalculation is in progress.
		ResetEvent(pCaptureThreadInfo->m_hEventCaptureDone);
		bSoundCaptureDone = RecordCapturedData(pDSBCapture,
			dwNotifySize,
			dwCaptureBufferSize,
			&dwNextCaptureOffset,
			pCaptureThreadInfo->m_pThreadZeitreiheArray,
			pCaptureThreadInfo->m_pThreadFrequenzenArray,
			pCaptureThreadInfo->m_pCaptureWaveFile,
			pCaptureThreadInfo,
			pCaptureThreadInfo->m_hwndNotifyCaptureInProgress,
			pCaptureThreadInfo->m_pwfxInput);

		// Set event to indicate that recalculation is done (i.e., no longer in progress)
		if (bSoundCaptureDone)
			::SendMessageTimeout(pCaptureThreadInfo->m_hwndNotifyCaptureDone,\
													 WM_USER_CAPTURE_DONE,0,0,SMTO_ABORTIFHUNG,1000,NULL);
	}
	pDSBCapture->Stop();
 	SAFE_DELETE (pCaptureThreadInfo->m_pCaptureWaveFile);
  SAFE_RELEASE( pDSNotify );
  SAFE_RELEASE( pDSBCapture );
	SetEvent(pCaptureThreadInfo->m_hEventCaptureThreadKilled);
	return 0;
}

