#if !defined(AFX_FFT3DVIEW_H__4E2EC7FC_A147_45E9_B425_17521792B186__INCLUDED_)
#define AFX_FFT3DVIEW_H__4E2EC7FC_A147_45E9_B425_17521792B186__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FFT3DView.h : Header-Datei
//

// Meine  FFTvertex als Flexibles Vertex Format wie weiter unten definiert
typedef struct FFT3DVERTEX
{
public:
    FLOAT x, y, z;
		FLOAT nx, ny, nz;  // normal
 		FLOAT ptsize;
		DWORD color;
} FFT3DVERTEX, *LPFFT3DVERTEX;


// Our custom FVF, which describes our custom vertex structure
#define D3DFVF_FFT3DVERTEX (D3DFVF_XYZ|D3DFVF_NORMAL|D3DFVF_PSIZE|D3DFVF_DIFFUSE)//)//


/////////////////////////////////////////////////////////////////////////////
// Ansicht CFFT3DView 

class CFFT3DView : public CView, public CD3DApplication
{
protected:
	CFFT3DView();           // Dynamische Erstellung verwendet geschtzten Konstruktor
	DECLARE_DYNCREATE(CFFT3DView)

    // Font for drawing text
    CD3DFont* m_pFont;
    CD3DFont* m_pFontSmall;

    // Scene
    LPDIRECT3DVERTEXBUFFER8 m_pVB;
    LPDIRECT3DVERTEXBUFFER8 m_pVBKoord;
    LPDIRECT3DVERTEXBUFFER8 m_pVBFFT3D;
    DWORD        m_dwNumVertices;

    // Transforms
    D3DXMATRIXA16		m_matPosition;
    D3DXMATRIXA16		m_matView;
    D3DXMATRIXA16		m_matProj;
		D3DXMATRIXA16		m_matStandard;
    D3DXMATRIXA16		m_matWorld;
    
		// Navigation
    BYTE        m_bKey[256];
    FLOAT       m_fSpeed;
    FLOAT       m_fAngularSpeed;
    BOOL        m_bShowHelp;
		BOOL				m_bFinishMultiple;
		BOOL				m_bFailedMesh;
		
    D3DXVECTOR3 m_vVelocity;
    D3DXVECTOR3 m_vAngularVelocity;

		FLOAT				x,y,z,u,v,w,k,MoveStep;
		POINT				m_ptPrev;
		INT					m_Breite;
		
		BOOL				m_bNetzNeu;
		INT					m_counter;

		CString			m_strHint;
protected:
    HWND							m_hwndRenderWindow;
		CFFT3DFrame*			m_pParentFFTFrame;
		CClrButton				m_FarbButton;
		CClrButton				m_FarbButtonBkg;
		COLORREF					m_clrRekoREF;
		COLORREF					m_clrText;
		COLORREF					m_clrBkg;
		CSpinButtonCtrl*	m_pEpsilonCtrl;
		CEdit*						m_pTauWertCtrl;
		CEdit*						m_pPunkteWertCtrl;
		CButton*					m_pRadioFesteFarbe;
		CButton*					m_pRadioBunt;
		CButton*					m_pRadioLinien;
		CButton*					m_pRadioFaces;
		FLOAT							m_Schrittweite;
		DWORD							m_dwNumFaces;
		ID3DXMesh*				m_pMesh1;
		INT								m_AnzahlFFTPts;
		FFT3DVERTEX*			m_pVerticesMeshKopie;
		INT								m_TatsaechlichAngezeigtFFTPunkte;


public:
  	CArray<D3DVECTOR,D3DVECTOR> m_FFTPtArray;   
		INT													m_NumFFTPoints;
		INT													m_BottomCutHz;
		INT													m_TopCutkHz;
		HRESULT						m_hr;
		
public:	//Fr Zugriff von Steuerleiste aus.
		INT					m_Tau;	
		BOOL				m_Recalc;
		DWORD				m_clrReko;
		DWORD				m_clrBackBuffer;
		BOOL				m_bIsBunt;
		BOOL				m_bIsWire;
		FLOAT				m_SizePts;
		FLOAT				m_Epsilon;
		BOOL				m_bIsAmpLinear;
		BOOL				m_bIsFreqLinear;

public:
		HRESULT OneTimeSceneInit();
		void		DrawMultiple3DFFTs();
		void		IniFileWrite();
		void		IniFileRead();

protected:
    HRESULT InitDeviceObjects();
    HRESULT RestoreDeviceObjects();
    HRESULT InvalidateDeviceObjects();
    HRESULT DeleteDeviceObjects();
    HRESULT FinalCleanup();
    HRESULT ConfirmDevice( D3DCAPS8* pCaps, DWORD dwBehavior, D3DFORMAT Format );
    HRESULT Render();
    HRESULT FrameMove();
		VOID		SetupLights();
		void		DoFrameMove(char Buchstabe) ;
		void		NeuesNetz(DWORD dwNumFaces, DWORD dwNumVertices, ID3DXMesh* ppMesh,
											INT PtsPerRow,INT Rows,CArray<D3DVECTOR,D3DVECTOR>* pNeueFFTReihe);
		HRESULT NeueFFTPunkte(CArray<DOUBLE,DOUBLE>* pFrequenzenArray);
		DWORD		Farbwahl(INT counter);
		inline	CSoundsDoc* GetDocument() { return (CSoundsDoc*)m_pDocument; }
		void		RedrawMesh();

// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(CFFT3DView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void OnDraw(CDC* pDC);      // berschrieben zum Zeichnen dieser Ansicht
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	virtual void CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType = adjustBorder);
	//}}AFX_VIRTUAL

// Implementierung
protected:
	virtual ~CFFT3DView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generierte Nachrichtenzuordnungsfunktionen
public:
	afx_msg void OnResetview();
protected:
	//{{AFX_MSG(CFFT3DView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnTogglehelp();
	afx_msg void OnTogglestart();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnSinglestep();
	afx_msg void OnChangedevice();
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnFarbwahl();
	afx_msg void OnFestefarbe();
	afx_msg void OnBunt();
	afx_msg void OnButtonDrehxl();
	afx_msg void OnButtonDrehxr();
	afx_msg void OnButtonDrehyl();
	afx_msg void OnButtonDrehyr();
	afx_msg void OnButtonDrehzl();
	afx_msg void OnButtonDrehzr();
	afx_msg void OnSave();
	afx_msg void OnFaces();
	afx_msg void OnWire();
	afx_msg void OnChangeEpsilonFeld();
	afx_msg void OnScaleAmpLin();
	afx_msg void OnScaleAmpLog();
	afx_msg void OnScaleFreqLin();
	afx_msg void OnScaleFreqLog();
	afx_msg void OnEditClearall();
	afx_msg void OnEditCopy();
	afx_msg void OnBkgclr();
	afx_msg void OnButtonTransxl();
	afx_msg void OnButtonTransxr();
	afx_msg void OnButtonTransyl();
	afx_msg void OnButtonTransyr();
	afx_msg void OnButtonTranszl();
	afx_msg void OnButtonTranszr();
	afx_msg void OnReleasedcaptureBreiteSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnChangeBottomcutFeld();
	afx_msg void OnChangeTopcutFeld();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // AFX_FFT3DVIEW_H__4E2EC7FC_A147_45E9_B425_17521792B186__INCLUDED_
