// GrafikDeviceDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "RekoView.h"
#include "GrafikDeviceDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CGrafikDeviceDlg 


CGrafikDeviceDlg::CGrafikDeviceDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGrafikDeviceDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGrafikDeviceDlg)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
}


void CGrafikDeviceDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGrafikDeviceDlg)
	DDX_Control(pDX, IDC_MULTISAMPLE_COMBO, m_MultiSampleListCtrl);
	DDX_Control(pDX, IDC_DEVICE_COMBO, m_DeviceListCtrl);
	DDX_Control(pDX, IDC_ADAPTER_COMBO, m_AdapterListCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGrafikDeviceDlg, CDialog)
	//{{AFX_MSG_MAP(CGrafikDeviceDlg)
	ON_CBN_SELENDOK(IDC_ADAPTER_COMBO, OnSelendokAdapterCombo)
	ON_CBN_SELENDOK(IDC_DEVICE_COMBO, OnSelendokDeviceCombo)
	ON_CBN_SELENDOK(IDC_MULTISAMPLE_COMBO, OnSelendokMultisampleCombo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CGrafikDeviceDlg 

BOOL CGrafikDeviceDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

  // Old state
  if (m_bReko==TRUE) 
		pd3dApp      = m_RekoView;
  else
		pd3dApp      = m_FFTView;
  dwOldAdapter = pd3dApp->m_dwAdapter;
  pAdapter     = &pd3dApp->m_Adapters[dwOldAdapter];

  dwOldDevice  = pAdapter->dwCurrentDevice;
  pDevice      = &pAdapter->devices[dwOldDevice];

  dwOldMode    = pDevice->dwCurrentMode;
  bOldWindowed = pDevice->bWindowed;
  OldMultiSampleTypeWindowed = pDevice->MultiSampleTypeWindowed;
  OldMultiSampleTypeFullscreen = pDevice->MultiSampleTypeFullscreen;

  // New state is initially the same as the old state
  dwNewAdapter = dwOldAdapter;
  dwNewDevice  = dwOldDevice;
  dwNewMode    = dwOldMode;
  bNewWindowed = bOldWindowed;
  NewMultiSampleTypeWindowed = OldMultiSampleTypeWindowed;
  NewMultiSampleTypeFullscreen = OldMultiSampleTypeFullscreen;

  // Set flag to update dialog controls below
  UpdateUIControls();
	
	return TRUE;  // return TRUE unless you set the focus to a control
}

void CGrafikDeviceDlg::OnOK() 
{
	if( dwNewAdapter != dwOldAdapter || dwNewDevice  != dwOldDevice  ||
				  dwNewMode    != dwOldMode    || bNewWindowed != bOldWindowed ||
		      NewMultiSampleTypeWindowed != OldMultiSampleTypeWindowed ||
				  NewMultiSampleTypeFullscreen != OldMultiSampleTypeFullscreen )
		  {
		    pd3dApp->m_dwAdapter = dwNewAdapter;

		    pAdapter = &pd3dApp->m_Adapters[dwNewAdapter];
				pAdapter->dwCurrentDevice = dwNewDevice;

		    pAdapter->devices[dwNewDevice].dwCurrentMode = dwNewMode;
				pAdapter->devices[dwNewDevice].bWindowed     = bNewWindowed;
		    pAdapter->devices[dwNewDevice].MultiSampleTypeWindowed = NewMultiSampleTypeWindowed;
				pAdapter->devices[dwNewDevice].MultiSampleTypeFullscreen = NewMultiSampleTypeFullscreen;
				CDialog::OnOK();
			}
	else
		CDialog::OnCancel();
}

void CGrafikDeviceDlg::OnCancel() 
{
	// TODO: Zustzlichen Bereinigungscode hier einfgen
	
	CDialog::OnCancel();
}

void CGrafikDeviceDlg::OnSelendokAdapterCombo() 
{
  dwNewAdapter = m_AdapterListCtrl.GetCurSel();
  pAdapter     = &pd3dApp->m_Adapters[dwNewAdapter];

  dwNewDevice  = pAdapter->dwCurrentDevice;
  dwNewMode    = pAdapter->devices[dwNewDevice].dwCurrentMode;
  bNewWindowed = pAdapter->devices[dwNewDevice].bWindowed;
}

void CGrafikDeviceDlg::OnSelendokDeviceCombo() 
{
  pAdapter     = &pd3dApp->m_Adapters[dwNewAdapter];

  dwNewDevice  = m_DeviceListCtrl.GetCurSel();
  dwNewMode    = pAdapter->devices[dwNewDevice].dwCurrentMode;
  bNewWindowed = pAdapter->devices[dwNewDevice].bWindowed;
}

void CGrafikDeviceDlg::OnSelendokMultisampleCombo() 
{
  DWORD dwItem = m_MultiSampleListCtrl.GetCurSel();
  if( bNewWindowed )
     NewMultiSampleTypeWindowed = (D3DMULTISAMPLE_TYPE)m_MultiSampleListCtrl.GetItemData(dwItem);
  else
     NewMultiSampleTypeFullscreen = (D3DMULTISAMPLE_TYPE)m_MultiSampleListCtrl.GetItemData(dwItem);
	
}

// Update the dialog controls
void CGrafikDeviceDlg::UpdateUIControls() 
{
  // Reset the content in each of the combo boxes
//  m_AdapterListCtrl.ResetContent();
//	m_DeviceListCtrl.ResetContent();
//	m_MultiSampleListCtrl.ResetContent();
	
  pAdapter = &pd3dApp->m_Adapters[dwNewAdapter];
  pDevice  = &pAdapter->devices[dwNewDevice];

  // Add a list of adapters to the adapter combo box
  for( DWORD a=0; a < pd3dApp->m_dwNumAdapters; a++ )
  {
    // Add device name to the combo box
    DWORD dwItem = m_AdapterListCtrl.AddString( pd3dApp->m_Adapters[a].d3dAdapterIdentifier.Description );
 
		// Set the item data to identify this adapter
    m_AdapterListCtrl.SetItemData(dwItem,a);

    // Set the combobox selection on the current adapater
    if( a == dwNewAdapter )
      m_AdapterListCtrl.SetCurSel(dwItem);
  }

  // Add a list of devices to the device combo box
  for( DWORD d=0; d < pAdapter->dwNumDevices; d++ )
  {
    // Add device name to the combo box
    DWORD dwItem = m_DeviceListCtrl.AddString(pAdapter->devices[d].strDesc);

    // Set the item data to identify this device
    m_DeviceListCtrl.SetItemData(dwItem, d);

    // Set the combobox selection on the current device
    if( d == dwNewDevice )
      m_DeviceListCtrl.SetCurSel(dwItem);
  }

  // Add a list of multisample modes to the multisample combo box
  for( DWORD m=0; m <= 16; m++ )
  {
    TCHAR strDesc[50];

    D3DFORMAT fmt;
    if( bNewWindowed )
      fmt = pd3dApp->m_Adapters[dwNewAdapter].d3ddmDesktop.Format;
    else
      fmt = pDevice->modes[dwNewMode].Format;

    if ( m == 1 ) // 1 is not a valid multisample type
      continue;

    if( SUCCEEDED( pd3dApp->m_pD3D->CheckDeviceMultiSampleType( dwNewAdapter,
         pDevice->DeviceType, fmt, bNewWindowed, (D3DMULTISAMPLE_TYPE)m ) ) )
    {
      if( m == 0 )
        lstrcpy( strDesc, _T("none") );
      else
        wsprintf( strDesc, _T("%d samples"), m );

	    // Add device name to the combo box
      DWORD dwItem = m_MultiSampleListCtrl.AddString(strDesc);

      // Set the item data to identify this multisample type
      m_MultiSampleListCtrl.SetItemData(dwItem,m);

      // Set the combobox selection on the current multisample type
      if( bNewWindowed )
      {
				if( (D3DMULTISAMPLE_TYPE)m == NewMultiSampleTypeWindowed || m == 0 )
             m_MultiSampleListCtrl.SetCurSel(dwItem);
      }
      else
      {
        if( (D3DMULTISAMPLE_TYPE)m == NewMultiSampleTypeFullscreen || m == 0 )
             m_MultiSampleListCtrl.SetCurSel(dwItem);
      }
    }
  }
  DWORD dwItem = m_MultiSampleListCtrl.GetCurSel();
  if( bNewWindowed )
    NewMultiSampleTypeWindowed = (D3DMULTISAMPLE_TYPE)m_MultiSampleListCtrl.GetItemData(dwItem);
  else
    NewMultiSampleTypeFullscreen = (D3DMULTISAMPLE_TYPE)m_MultiSampleListCtrl.GetItemData(dwItem);
	if (m_MultiSampleListCtrl.GetCount()>1)
			m_MultiSampleListCtrl.EnableWindow();
}

