// NotenbildView.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "NotenbildView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define RandL 10
#define RandO 10
#define RandU 10
#define RandR 40

/////////////////////////////////////////////////////////////////////////////
// CNotenbildView

IMPLEMENT_DYNCREATE(CNotenbildView, CScrollView)

CNotenbildView::CNotenbildView()
{
	INT Items=AfxGetMainWnd()->GetMenu()->GetMenuItemCount();
	AfxGetMainWnd()->GetMenu()->GetSubMenu(Items>5?5:3)->AppendMenu(MF_STRING|MF_ENABLED,ID_FENSTER_NOTENBILD,"Notenbild");
	AfxGetMainWnd()->DrawMenuBar();
}

void CNotenbildView::IniFileRead()
{
	//INIFile Werte einlesen
	m_bIsLinear=*theApp.GetIniNotenbildbisLinear();
	m_WhatIs=*theApp.GetIniNotenbildWhatIs();
	m_Obertonanzahl=*theApp.GetIniNotenbildObertonanzahl();
}

void CNotenbildView::IniFileWrite()
{
	//IniDateiwerte schreiben
	*theApp.GetIniNotenbildbisLinear()=m_bIsLinear;
	*theApp.GetIniNotenbildWhatIs()=m_WhatIs;
	*theApp.GetIniNotenbildObertonanzahl()=m_Obertonanzahl;
}

CNotenbildView::~CNotenbildView()
{
	IniFileWrite();
	INT Items=AfxGetMainWnd()->GetMenu()->GetMenuItemCount();
	AfxGetMainWnd()->GetMenu()->GetSubMenu(Items>5?5:3)->RemoveMenu(ID_FENSTER_NOTENBILD,MF_BYCOMMAND);
	AfxGetMainWnd()->DrawMenuBar();
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->m_pViewNotenbild=NULL;
}


BEGIN_MESSAGE_MAP(CNotenbildView, CScrollView)
	//{{AFX_MSG_MAP(CNotenbildView)
	ON_BN_CLICKED(IDC_NOTEN, OnNoten)
	ON_BN_CLICKED(IDC_OBERTONABSTRAKT, OnObertonabstrakt)
	ON_BN_CLICKED(IDC_OBERTONINNOTEN, OnObertoninnoten)
	ON_BN_CLICKED(IDC_LOG, OnLog)
	ON_BN_CLICKED(IDC_LIN, OnLin)
	ON_EN_CHANGE(IDC_OBERZAHL_FELD, OnChangeOberzahlFeld)
	ON_BN_CLICKED(IDC_LISTEN_SINGLE, OnListenSingle)
	ON_COMMAND(ID_SAVE, OnSave)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_WM_HELPINFO()
	ON_WM_ERASEBKGND()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Zeichnung CNotenbildView 

void CNotenbildView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	IniFileRead();
	ScrollZurueckSetzen();
	m_pParentNotenbildFrame=(CNotenbildFrame*)GetParentFrame();

	CButton* pButton1;
	CButton* pButton2;
	CButton* pButton3;
	
	pButton1=(CButton*)m_pParentNotenbildFrame->m_wndDlgBar.GetDlgItem(IDC_LIN);
	pButton2=(CButton*)m_pParentNotenbildFrame->m_wndDlgBar.GetDlgItem(IDC_LOG);

	if (m_bIsLinear) 
		pButton1->SetCheck(1);
	else
		pButton2->SetCheck(1);

	pButton1=(CButton*)m_pParentNotenbildFrame->m_wndDlgBar.GetDlgItem(IDC_OBERTONABSTRAKT);
	pButton2=(CButton*)m_pParentNotenbildFrame->m_wndDlgBar.GetDlgItem(IDC_OBERTONINNOTEN);
	pButton3=(CButton*)m_pParentNotenbildFrame->m_wndDlgBar.GetDlgItem(IDC_NOTEN);

	switch(m_WhatIs) {
	case 0:
		pButton1->SetCheck(1);
		break;
	case 1:
		pButton2->SetCheck(1);
		break;
	case 2:
		pButton3->SetCheck(1);
		break;
	}  

	CSpinButtonCtrl*	m_pSpinCtrl=(CSpinButtonCtrl*)m_pParentNotenbildFrame->m_wndDlgBar.GetDlgItem(IDC_OBERZAHL_SPIN);
	m_pSpinCtrl->SetRange(3,40);
	m_pSpinCtrl->SetBuddy(m_pParentNotenbildFrame->m_wndDlgBar.GetDlgItem(IDC_OBERZAHL_FELD));
	m_pSpinCtrl->SetPos(m_Obertonanzahl);

	m_NotenCounter=0;
	m_bReset=TRUE;
	m_LastTon=0;
	m_LastTonAmp=0;
	time(&m_lasttime);

	if (*theApp.GetIniAllgemeinGrundschulprofil())
	{
		CSoundsDoc* pDoc=GetDocument();
		*pDoc->GetFFTPoints()=32768;
		pDoc->UpdateStatusBar();
	}
}

void CNotenbildView::ScrollZurueckSetzen()
{
	CSize sizeTotal;
	CRect rect;
	GetClientRect(rect);
	sizeTotal.cx = rect.right;
	sizeTotal.cy = rect.bottom;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

void CNotenbildView::OnDraw(CDC* dc)
{
	CMemDC pDC(dc);
	switch(m_WhatIs) 
	{
	case 0:
		ZeichneObertonabstrakt(pDC);
		break;
	case 1:
		ZeichneObertoninnoten(pDC);
		break;
	case 2:
		CRect rect;
		GetClientRect(rect);
		CSize size=GetTotalSize();
		rect.right=MAX(size.cx,rect.right);
		rect.bottom=MAX(size.cy,rect.bottom);

		CSoundsDoc* pDoc=GetDocument();

		CAutoFont font("Century Gothic");
		font.SetDC(pDC->GetSafeHdc());
		font.SetHeight(14);
		font.SetFontColor(RGB(0,0,0));

		pDC->SelectObject(&font);
		pDC->SetTextColor(font.GetFontColor());

		ZeichneNoten(pDC);
		CString Text;
		if (*theApp.GetIniAllgemeinGrundschulprofil()) 
		{
			Text.LoadString(IDS_NOTENBILD_HINT_GRUND);
			pDC->DrawText(Text,rect,DT_TOP|DT_LEFT);
		}
		else
		{
			Text.LoadString(IDS_NOTENBILD_HINT);
			pDC->DrawText(Text,rect,DT_TOP|DT_LEFT);
		}

		break;
	}

}

/////////////////////////////////////////////////////////////////////////////
// Diagnose CNotenbildView

#ifdef _DEBUG
void CNotenbildView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CNotenbildView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CNotenbildView 


void CNotenbildView::ZeichneObertonabstrakt(CDC* pDC) 
{
//	HolePeaks();
	BerechnePeaks();
	CRect rect;
	GetClientRect(rect);
	pDC->FillSolidRect(rect,RGB(255,255,255));
	ZeichneReineObertonreihe(pDC);
	ZeichnePeaksInObertonreihe(pDC);
}

void CNotenbildView::ZeichneObertoninnoten(CDC* pDC) 
{
//	HolePeaks();
	BerechnePeaks();
	CRect rect;
	GetClientRect(rect);
	pDC->FillSolidRect(rect,RGB(255,255,255));
	ZeichneNotensystem(1,pDC);
	ZeichnePeaksInNotensystem(pDC);
}

void CNotenbildView::ZeichneNoten(CDC* pDC) 
{
//	HolePeaks();
	BerechnePeaks();
	if (g_bIsCapturing||g_bIsPlayingWave||g_bIsPutPoints)
	{
		ZeichneNotensystem(0,pDC);
		ZeichneAktuelleNoteInNotensystem(pDC);
		ZeichnePartitur(pDC);
	}
	else 
	{
		CRect rect;
		GetClientRect(rect);
		CSize	size=GetTotalSize();
		rect.right=size.cx;
//		pDC->FillSolidRect(rect,RGB(255,255,255));
		ZeichneNotensystem(0,pDC);
		ZeichnePartitur(pDC);
	}
}


void CNotenbildView::HolePeaks()
{
	m_ObertonArray.RemoveAll();
	CSoundsDoc* pDoc=GetDocument();
	CArray<DBLPOINT,DBLPOINT>* Peaks=pDoc->GetPeakArray();
	m_ObertonArray.Copy(*Peaks);
}

void CNotenbildView::BerechnePeaks()
{
	CSoundsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CArray<DOUBLE,DOUBLE>* pFrequenzenArray=pDoc->GetFrequenzenArray();
	INT MaxFrequenzen=pFrequenzenArray->GetSize();
	INT SamplingRate=*pDoc->GetSampleRate();
	DOUBLE MaxAmplitude=ldexp(1,*pDoc->GetBitRate());

	if (MaxFrequenzen>1) 
	{
		//Alte Peaks lschen
		if (m_ObertonArray.GetSize()>0) 
		{
			m_ObertonArray.RemoveAll();
		}

		//Peaks suchen
		INT MinAbstandNachbarMin=*theApp.GetIniFFTMinAbstandNachbarMin();
		INT MinAbstandMax=*theApp.GetIniFFTMinAbstandMaxima();
		DOUBLE LastWert=0;
		INT Count=1;
		INT ZaehlerRauf=0;
		INT ZaehlerRunter=0;
		INT ZaehlerGleich=0;
		while(Count<MaxFrequenzen)
		{
			while (pFrequenzenArray->GetAt(Count)>LastWert) 
			{
				LastWert=pFrequenzenArray->GetAt(Count);
				ZaehlerRauf++;
				if (Count==MaxFrequenzen-1) break;
				Count++;
			}
			while (pFrequenzenArray->GetAt(Count)==LastWert)
			{
				LastWert=pFrequenzenArray->GetAt(Count);
				ZaehlerGleich++;
				if (Count==MaxFrequenzen-1) break;
				Count++;
			}
			while (pFrequenzenArray->GetAt(Count)<LastWert) 
			{
				LastWert=pFrequenzenArray->GetAt(Count);
				ZaehlerRunter++;
				Count++;
				if (Count==MaxFrequenzen) break;
			}
			ZaehlerRauf+=ZaehlerGleich;
			
			if (ZaehlerRauf>0&&ZaehlerRunter>0) 
			{
				INT StelleInFreqArray=Count-ZaehlerRunter-1;
				DOUBLE Peak=pFrequenzenArray->GetAt(StelleInFreqArray);
				DOUBLE RechtsvonPeak=pFrequenzenArray->GetAt(StelleInFreqArray+MinAbstandNachbarMin<MaxFrequenzen?StelleInFreqArray+MinAbstandNachbarMin:MaxFrequenzen-1); ///3: Abstand rechts links
				DOUBLE LinksvonPeak=pFrequenzenArray->GetAt(StelleInFreqArray-MinAbstandNachbarMin>0?StelleInFreqArray-MinAbstandNachbarMin:0);
				if ((Peak*0.2>RechtsvonPeak||Peak*0.2>LinksvonPeak)&&Peak>MaxAmplitude*0.0001) 
				{
					//In Peakarray eintragen
					DOUBLE Frequenz=StelleInFreqArray*(SamplingRate/2/(DOUBLE)MaxFrequenzen);
					DOUBLE Pegel=20*log10(Peak/MaxAmplitude);			
					DBLPOINT Peak;
					Peak.x=Frequenz;
					Peak.y=Pegel;
					if (Frequenz<1000&&Pegel>-50&&Frequenz>25)
						m_ObertonArray.Add(Peak);
					else if (Frequenz>=1000&&Frequenz<5000&&Pegel>-70) 
								m_ObertonArray.Add(Peak);
//							else if (Frequenz>=5000)
//								m_ObertonArray.Add(Peak);
//					m_ObertonArray.Add(Peak);
				}
			}
			if (Count==MaxFrequenzen-1) Count++;
			ZaehlerRauf=0;
			ZaehlerRunter=0;
			ZaehlerGleich=0;
		}
		//weitere Modifikationen
		//den kleineren zweier dicht liegender Punkte entfernen
		for(INT i=0; i<m_ObertonArray.GetSize()-1;i++)
		{
			DBLPOINT Links,Rechts;
			Links=m_ObertonArray.GetAt(i);
			Rechts=m_ObertonArray.GetAt(i+1);
			if (Links.x>=Rechts.x-MinAbstandNachbarMin) 
			{
				m_ObertonArray.RemoveAt(Links.y<Rechts.y?i+1:i);
				i--;
			}
		}
	}
}
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
// Zeichenroutinen
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CNotenbildView::ZeichneReineObertonreihe(CDC* pDC)
{
	CRect rect;
	GetClientRect(rect);
	CPen RasterStift;
	RasterStift.CreatePen(PS_SOLID,1,RGB(0,0,0));
	CAutoFont font("Century Gothic");
	font.SetDC(pDC->GetSafeHdc());
	font.SetHeight(14);
	font.SetFontColor(RGB(0,0,0));
	pDC->SelectObject(&font);
	if (m_bIsLinear) 
	{
		pDC->SelectObject(&RasterStift);
		INT Abstand=(INT)((rect.bottom-RandO-RandU)/m_Obertonanzahl);
		m_HoeheY=Abstand*m_Obertonanzahl;
		for(int i=0;i<=m_Obertonanzahl;i++)
		{
			pDC->MoveTo(RandL,rect.bottom-RandU-i*Abstand);
			pDC->LineTo(rect.right-RandR,rect.bottom-RandU-i*Abstand);
			char buffer[20];
			CString AddOn;
			switch(i) 
			{
			case 0:
				AddOn.LoadString(IDS_GRUNDTON);
				break;
			case 1:
				AddOn.LoadString(IDS_OKTAVE);
				break;
			case 2:
				AddOn.LoadString(IDS_QUINTE);
				break;
			case 3:
				AddOn.LoadString(IDS_QUARTE);
				break;
			case 4:
				AddOn.LoadString(IDS_GRTERZ);
				break;
			case 5:
				AddOn.LoadString(IDS_KLTERZ);
				break;
/*			case 6:
				AddOn=": <kl.Terz";
				break;
			case 7:
				AddOn=": >gr.Sekunde";
				break;
			case 8:
				AddOn=": gr.Sekunde";
				break;
			case 9:
				AddOn=": gr.Sekunde";
				break;
			case 10:
				AddOn=": <gr.Sekunde";
				break;
			case 11:
				AddOn=": >kl.Sekunde";
				break;
*/			default:
				AddOn="";
			};
			CString Text=itoa(i, buffer,10);

			pDC->TextOut(2,rect.bottom-RandU-i*Abstand-6,Text+AddOn);
		}
	}
	else
	{
		pDC->SelectObject(&RasterStift);
		double FaktorY=(rect.bottom-RandO-RandU)/(log10(m_Obertonanzahl)/log10(2));
		m_HoeheYlog=FaktorY;
		for(int i=1;i<=m_Obertonanzahl+1;i++)
		{
			pDC->MoveTo(RandL,(LONG)(rect.bottom-RandU-(log10(i)/log10(2))*FaktorY));
			pDC->LineTo(rect.right-RandR,(LONG)(rect.bottom-RandU-(log10(i)/log10(2))*FaktorY));
			char buffer[20];
			CString AddOn;
			switch(i-1) 
			{
			case 0:
				AddOn.LoadString(IDS_GRUNDTON);
				break;
			case 1:
				AddOn.LoadString(IDS_OKTAVE);
				break;
			case 2:
				AddOn.LoadString(IDS_QUINTE);
				break;
			case 3:
				AddOn.LoadString(IDS_QUARTE);
				break;
			case 4:
				AddOn.LoadString(IDS_GRTERZ);
				break;
			case 5:
				AddOn.LoadString(IDS_KLTERZ);
				break;
/*			case 6:
				AddOn=": <kl.Terz";
				break;
			case 7:
				AddOn=": >gr.Sekunde";
				break;
			case 8:
				AddOn=": gr.Sekunde";
				break;
			case 9:
				AddOn=": gr.Sekunde";
				break;
			case 10:
				AddOn=": <gr.Sekunde";
				break;
			case 11:
				AddOn=": >kl.Sekunde";
				break;
*/			default:
				AddOn="";
			};
			CString Text=itoa(i-1, buffer,10);

			pDC->TextOut(2,(LONG)(rect.bottom-RandU-(log10(i)/log10(2))*FaktorY-6),Text+AddOn);
		}

	}
}


void CNotenbildView::ZeichnePeaksInObertonreihe(CDC* pDC)
{
	CRect rect;
	GetClientRect(rect);
	CPen ObertonStift;
	ObertonStift.CreatePen(PS_SOLID,3,RGB(255,0,0));
	CAutoFont font("Century Gothic");
	font.SetDC(pDC->GetSafeHdc());
	font.SetHeight(14);
	font.SetFontColor(RGB(0,0,0));
	pDC->SelectObject(&font);
	if (m_ObertonArray.GetSize()>0) 
	{
//		double Grundfrequenz=(m_ObertonArray.GetAt(0).x+m_ObertonArray.GetAt(1).x)/3;
		double Grundfrequenz=m_ObertonArray.GetAt(0).x;
		double MaxFrequenz=(m_Obertonanzahl+1)*Grundfrequenz;
			pDC->SelectObject(&ObertonStift);
			INT Abstand=(INT)((rect.bottom-RandO-RandU)/m_Obertonanzahl);
			double FaktorX=(rect.right-RandL-RandR)/(log(81))*1.5;
			double FaktorY;
			if (m_bIsLinear) 
				FaktorY=(m_HoeheY)/(MaxFrequenz-Grundfrequenz);
			else
				FaktorY=m_HoeheYlog;
			int i=0;
			while(i<=m_Obertonanzahl)
			{
				LONG yWert;
				if (m_bIsLinear) 
					yWert=(LONG)(rect.bottom-RandU-(m_ObertonArray.GetAt(i).x-Grundfrequenz)*FaktorY);			
				else
					yWert=(LONG)(rect.bottom-RandU-log10((m_ObertonArray.GetAt(i).x-Grundfrequenz)/Grundfrequenz+1)/log10(2)*FaktorY);			

				LONG xBreite;
				xBreite=(LONG)((log(81)-log(m_ObertonArray.GetAt(i).y*(-1)+1))*FaktorX);
			
				pDC->MoveTo(RandL+(rect.right-RandL-RandR)/2-xBreite/2,yWert);
				pDC->LineTo(RandL+(rect.right-RandL-RandR)/2+xBreite/2,yWert);
				int dec;
				int sign;
				CString strWert=ecvt(m_ObertonArray.GetAt(i).x,5, &dec,&sign );
				if (dec<=0) 
					for(int z=0;z<=abs(dec);z++) strWert.Insert(0,'0');
				if (dec<=0) strWert.Insert(1,'.');
				else strWert.Insert(dec,'.');
				strWert=strWert.Left(dec);
				if (sign!=0) strWert.Insert(0,'-');
				CString AddOn=" Hz";
				pDC->TextOut(rect.right-RandR+2,yWert-7,strWert+AddOn);

				//Differenz
				if (i>0) 
				{
					strWert=ecvt(m_ObertonArray.GetAt(i).x-m_ObertonArray.GetAt(i-1).x,5, &dec,&sign );
					if (dec<=0) 
						for(int z=0;z<=abs(dec);z++) strWert.Insert(0,'0');
					if (dec<=0) strWert.Insert(1,'.');
					else strWert.Insert(dec,'.');
					strWert=strWert.Left(dec);
					if (sign!=0) strWert.Insert(0,'-');
					AddOn=" Hz";
					pDC->TextOut(rect.right-RandR-45,(LONG)(yWert+(Grundfrequenz*FaktorY)/2-5),strWert+AddOn);
				}

				i++;
				if (i==m_ObertonArray.GetSize()) break;
			}
/*
		}
		else
		{
			pDC->SelectObject(&ObertonStift);
			double FaktorX=(rect.right-RandL-RandR)/(log(81))*1.5;
			double FaktorY=m_HoeheYlog;
			int i=0;
			while(i<=m_Obertonanzahl)
			{
				LONG yWert;
				LONG xBreite;
				xBreite=(LONG)((log(81)-log(m_ObertonArray.GetAt(i).y*(-1)+1))*FaktorX);
				yWert=(LONG)(rect.bottom-RandU-log10((m_ObertonArray.GetAt(i).x-Grundfrequenz)/Grundfrequenz+1)/log10(2)*FaktorY);			
		
				pDC->MoveTo(RandL+(rect.right-RandL-RandR)/2-xBreite/2,yWert);
				pDC->LineTo(RandL+(rect.right-RandL-RandR)/2+xBreite/2,yWert);
				int dec;
				int sign;
				CString strWert=ecvt(m_ObertonArray.GetAt(i).x,5, &dec,&sign );
				if (dec<=0) 
					for(int z=0;z<=abs(dec);z++) strWert.Insert(0,'0');
				if (dec<=0) strWert.Insert(1,'.');
				else strWert.Insert(dec,'.');
				strWert=strWert.Left(dec);
				if (sign!=0) strWert.Insert(0,'-');
				CString AddOn=" Hz";
				pDC->TextOut(rect.right-RandR+2,yWert-7,strWert+AddOn);

				//Differenz
				if (i>0) 
				{
					strWert=ecvt(m_ObertonArray.GetAt(i).x-m_ObertonArray.GetAt(i-1).x,5, &dec,&sign );
					if (dec<=0) 
						for(int z=0;z<=abs(dec);z++) strWert.Insert(0,'0');
					if (dec<=0) strWert.Insert(1,'.');
					else strWert.Insert(dec,'.');
					strWert=strWert.Left(dec);
					if (sign!=0) strWert.Insert(0,'-');
					AddOn=" Hz";
					pDC->TextOut(RandL+(rect.right-RandL-RandR)/2-20,(LONG)(yWert+(Grundfrequenz*FaktorY)/2),strWert+AddOn);
				}

				i++;
				if (i==m_ObertonArray.GetSize()) break;
			}
		}
*/
	}
}


//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
void CNotenbildView::ZeichneNotensystem(INT Typ,CDC* pDC)
{
	CRect rect;
	GetClientRect(rect);
	CSize size=GetTotalSize();
	CPen LinienStift,HilfslinienStift,SchluesselStift;
	LinienStift.CreatePen(PS_SOLID,2,RGB(0,0,0));
	HilfslinienStift.CreatePen(PS_SOLID,1,RGB(0,0,0));
	SchluesselStift.CreatePen(PS_SOLID,2,RGB(20,20,20));
	CBrush BlackPinsel;
	BlackPinsel.CreateSolidBrush(RGB(0,0,0));

	rect.right=size.cx;
	pDC->FillSolidRect(rect,RGB(255,255,255));

	GetClientRect(rect);

	CAutoFont font("Century Gothic");
	font.SetDC(pDC->GetSafeHdc());
	font.SetHeight(14);
	font.SetFontColor(RGB(0,0,0));
	pDC->SelectObject(&font);
	//Notenlinien
	int i;
	
	if (Typ==1) 
	{
		//untere Hilfslinien
		pDC->SelectObject(&HilfslinienStift);
		for(i=0;i<=6;i++)
		{
			pDC->MoveTo(RandL+50,rect.bottom-RandU-i*10);
			pDC->LineTo(RandL+50+50,rect.bottom-RandU-i*10);
		}
	}
	//Bassystem
	pDC->SelectObject(&LinienStift);
	for(i=7;i<=11;i++)
	{
		pDC->MoveTo(RandL,rect.bottom-RandU-i*10);
		pDC->LineTo(size.cx-RandR,rect.bottom-RandU-i*10);
	}
	if (Typ==1) 
	{
		//Zwischenlinie
		pDC->SelectObject(&HilfslinienStift);
		pDC->MoveTo(RandL+50,rect.bottom-RandU-12*10);
		pDC->LineTo(RandL+50+50,rect.bottom-RandU-12*10);
	}
	//Violinsystem
	pDC->SelectObject(&LinienStift);
	for(i=13;i<=17;i++)
	{
		pDC->MoveTo(RandL,rect.bottom-RandU-i*10);
		pDC->LineTo(size.cx-RandR,rect.bottom-RandU-i*10);
	}
	if (Typ==1) 
	{
		//obere Hilfslinien
		pDC->SelectObject(&HilfslinienStift);
		for(i=18;i<=35;i++)
		{
			pDC->MoveTo(RandL+50,rect.bottom-RandU-i*10);
			pDC->LineTo(RandL+50+50,rect.bottom-RandU-i*10);
		}
		pDC->MoveTo(RandL,rect.bottom-RandU-70);
		pDC->LineTo(RandL,rect.bottom-RandU-170);
		pDC->MoveTo(size.cx-RandR,rect.bottom-RandU-70);
		pDC->LineTo(size.cx-RandR,rect.bottom-RandU-170);
	}
	//Notenschlssel
	//Bassschlssel

	CDC BitmapDC;
	BitmapDC.CreateCompatibleDC(pDC);
  CBitmap Bass;
	Bass.LoadBitmap(IDB_BASSKEY);
	CSize sz;
	sz.cx=30;
	sz.cy=40;
	BitmapDC.SelectObject(Bass);

	pDC->BitBlt(RandL+5,rect.bottom-70-sz.cy-RandU,sz.cx,sz.cy,&BitmapDC,0,0,SRCAND);

	//Violinschlssel
  CBitmap Violon;
	Violon.LoadBitmap(IDB_VIOLONKEY);
	sz.cx=30;
	sz.cy=80;
	BitmapDC.SelectObject(Violon);

	pDC->BitBlt(RandL,rect.bottom-107-sz.cy-RandU,sz.cx,sz.cy,&BitmapDC,0,0,SRCAND);

}

void CNotenbildView::ZeichneAktuelleNoteInNotensystem(CDC* pDC)
{
	CRect rect;
	GetClientRect(rect);
	CSize size=GetTotalSize();
	if (m_bReset)
	{
//		m_NotenCounter=0;
		m_bReset=FALSE;
	}
	if (m_ObertonArray.GetSize()>0) 
	{
		int i=0;
		LONG xWert;
		DOUBLE Frequenz=m_ObertonArray.GetAt(i).x;
		DOUBLE TonNummer=log10(Frequenz/27.5)/log10(2)*12;

		INT Ton;
		if (fabs(TonNummer-(INT)TonNummer)<=0.5) 
		{
			Ton=floor(TonNummer);
		}
		else	
		{
			Ton=ceil(TonNummer);
		}
		
//		BOOL Akkord=CheckIfTonOrNoise();
//		if (!Akkord) m_LastTon=0;

		//Wenn zuwenig Zeit vergangen und nur Halbtonabstand zwischen aufeinanderfolgenden Tnen
		//ist das Zeichen ein Zeichen fr groes Vibrato auf einem Ton
//		if (((m_LastTon!=Ton)||g_bIsPutPoints)&&(Akkord)&&(time(&m_newtime)-m_lasttime>0.5))
		BOOL bWechsel=FALSE;

		if (m_LastTon==Ton) 
		{
			m_ListeLetzteToene.Add(Ton);
			m_LastTonPt=m_ObertonArray.GetAt(i);
		}
		else
		{
			bWechsel=TRUE;
			m_ListeLetzteToene.RemoveAll();
		}
/*		else if (m_LastTon==Ton+1||m_LastTon==Ton-1) 
		{
			
		}
*/
		m_LastTon=Ton;

		if (m_ListeLetzteToene.GetSize()==4||g_bIsPutPoints) 
		{
			//damit die Darstellung einigermaen synchron mit dem Abspielen luft
			//wird die Note schon bei der ersten Regelmigkeit (4 FFTS hintereinander)
			//gezeichnet, aber aus Tonwechselgrnden die letzte FFT verwendet
			//Bei der PutPointsAuswahl durch den User wird die aktuelle FFT verwendet
			if (g_bIsPutPoints)	m_AkkordArray.Add(m_ObertonArray.GetAt(i));
			else m_AkkordArray.Add(m_LastTonPt);
//			if (bWechsel) m_ListeLetzteToene.RemoveAll();
			m_NotenCounter++;
			m_lasttime=m_newtime;
			m_LastTonAmp=m_ObertonArray.GetAt(i).y;

			xWert=RandL+40+m_NotenCounter*20;
		
			if (xWert+RandR+20>=size.cx) 
			{
				size.cx+=rect.right;
				SetScrollSizes(MM_TEXT,size);
				POINT Punkt;
				Punkt.x=size.cx-rect.right-RandR-60;
				Punkt.y=rect.bottom;
				ScrollToPosition(Punkt);
				ZeichneNotensystem(0,pDC);
			}
/*				POINT Punkt;
				Punkt.x=(LONG)((1-rect.right/(FLOAT)size.cx)*rect.right+(m_NotenCounter-(rect.right-RandL+40)/20.0f)*20);//xWert-20;
				Punkt.y=rect.bottom;
				ScrollToPosition(Punkt);
*/		}
	}
}

void CNotenbildView::ZeichnePartitur(CDC* pDC)
{
	CRect rect;
	GetClientRect(rect);
	CPen HilfslinienStift;
	HilfslinienStift.CreatePen(PS_SOLID,1,RGB(0,0,0));
	CPen VorzeichenStift;
	VorzeichenStift.CreatePen(PS_SOLID,1,RGB(0,0,0));
	CPen NotenStift;
	NotenStift.CreatePen(PS_INSIDEFRAME,1,RGB(0,0,0));
	CBrush RotPinsel;
	RotPinsel.CreateSolidBrush(RGB(255,0,0));
	CAutoFont font("Century Gothic");
	font.SetDC(pDC->GetSafeHdc());
	font.SetHeight(14);
	font.SetFontColor(RGB(0,0,0));
	pDC->SelectObject(&font);
	for (INT z=0;z<m_AkkordArray.GetSize();z++) 
	{
		pDC->SelectObject(&NotenStift);
		pDC->SelectObject(&RotPinsel);
		LONG yWert,xWert,xWertVorzeichen;
		double WertY=(log10(m_AkkordArray.GetAt(z).x/27.5)/log10(2)*35+5);
		DOUBLE Frequenz=m_AkkordArray.GetAt(z).x;
		DOUBLE TonNummer=log10(Frequenz/27.5)/log10(2)*12;
		LONG PixelY=0;

		INT Ton;
		if (fabs(TonNummer-(INT)TonNummer)<=0.5) 
		{
			Ton=floor(TonNummer);
		}
		else	
		{
			Ton=ceil(TonNummer);
		}
		
		for (INT j=0; j<=Ton; j++)
		{
			if ((j%12==2)||(j%12==3)||(j%12==5)||(j%12==7)||(j%12==8)||(j%12==10)||((j%12==0)&&(j>=1))) PixelY+=5;
		}
		PixelY+=5;

		BOOL Vorzeichen=FALSE;
		if ((Ton%12==1)||(Ton%12==4)||(Ton%12==6)||(Ton%12==9)
				||(Ton%12==11)) Vorzeichen=TRUE;

		yWert=rect.bottom-RandU-PixelY;		
		xWert=RandL+40+z*20;
		xWertVorzeichen=xWert-10;
		if (xWert>rect.right) m_bReset=TRUE;

		if (Vorzeichen) 
		{
			pDC->SelectObject(&NotenStift);
			pDC->MoveTo(xWertVorzeichen-2,yWert-5);
			pDC->LineTo(xWertVorzeichen-2,yWert+5);
			pDC->MoveTo(xWertVorzeichen+1,yWert-5);
			pDC->LineTo(xWertVorzeichen+1,yWert+5);
			pDC->MoveTo(xWertVorzeichen-4,yWert-1);
			pDC->LineTo(xWertVorzeichen+4,yWert-3);
			pDC->MoveTo(xWertVorzeichen-4,yWert+3);
			pDC->LineTo(xWertVorzeichen+4,yWert+1);
			pDC->SelectObject(&NotenStift);
		}
		INT AnzahlOben=0;
		INT AnzahlUnten=0;

		if ((Ton==1)||(Ton==2)) AnzahlUnten=6;
		if ((Ton==3)||(Ton==4)||(Ton==5)||(Ton==6)) AnzahlUnten=5;
		if ((Ton==7)||(Ton==8)||(Ton==9)) AnzahlUnten=4;
		if ((Ton==10)||(Ton==11)||(Ton==12)||(Ton==13)) AnzahlUnten=3;
		if ((Ton==14)||(Ton==15)||(Ton==16)) AnzahlUnten=2;
		if ((Ton==17)||(Ton==18)||(Ton==19)) AnzahlUnten=1;

		if ((Ton==39)||(Ton==40)) 
		{
			pDC->SelectObject(&HilfslinienStift);
			pDC->MoveTo(xWert-8,rect.bottom-RandU-12*10);
			pDC->LineTo(xWert+8,rect.bottom-RandU-12*10);
		}

		if ((Ton==60)||(Ton==61)||(Ton==62)) AnzahlOben=1;
		if ((Ton==63)||(Ton==64)||(Ton==65)||(Ton==66)) AnzahlOben=2;
		if ((Ton==67)||(Ton==68)||(Ton==69)) AnzahlOben=3;
		if ((Ton==70)||(Ton==71)||(Ton==72)||(Ton==73)) AnzahlOben=4;
		if ((Ton==74)||(Ton==75)||(Ton==76)) AnzahlOben=5;
		if ((Ton==77)||(Ton==78)||(Ton==79)) AnzahlOben=6;
		if ((Ton==80)||(Ton==81)||(Ton==82)||(Ton==83)) AnzahlOben=7;

		//untere Hilfslinien
		for(int i=0;i<AnzahlUnten;i++)
		{
			pDC->SelectObject(&HilfslinienStift);
			pDC->MoveTo(xWert-8,rect.bottom-RandU-(6-i)*10);
			pDC->LineTo(xWert+8,rect.bottom-RandU-(6-i)*10);
		}

		//obere Hilfslinien
		for(i=0;i<AnzahlOben;i++)
		{
			pDC->MoveTo(xWert-8,rect.bottom-RandU-(18+i)*10);
			pDC->LineTo(xWert+8,rect.bottom-RandU-(18+i)*10);
		}
		pDC->Ellipse(xWert-5,yWert-4,xWert+5,yWert+4);
	}
}

void CNotenbildView::ZeichnePeaksInNotensystem(CDC* pDC)
{
	CRect rect;
	GetClientRect(rect);
	CPen VorzeichenStift;
	VorzeichenStift.CreatePen(PS_SOLID,1,RGB(0,0,0));
	CPen NotenStift;
	NotenStift.CreatePen(PS_INSIDEFRAME,1,RGB(0,0,0));
	CBrush RotPinsel;
	RotPinsel.CreateSolidBrush(RGB(255,0,0));
	CAutoFont font("Century Gothic");
	font.SetDC(pDC->GetSafeHdc());
	font.SetHeight(14);
	font.SetFontColor(RGB(0,0,0));
	pDC->SelectObject(&font);
	if (m_ObertonArray.GetSize()>0) 
	{
		pDC->SelectObject(&NotenStift);
		pDC->SelectObject(&RotPinsel);
		int i=0;
		while(i<=m_Obertonanzahl)
		{
			if (i>=m_ObertonArray.GetSize()) break;
			LONG yWert,xWert,xWertVorzeichen;
			double WertY=(log10(m_ObertonArray.GetAt(i).x/27.5)/log10(2)*35+5);
			DOUBLE Frequenz=m_ObertonArray.GetAt(i).x;
			DOUBLE TonNummer=log10(Frequenz/27.5)/log10(2)*12;
			LONG PixelY=0;

			INT Ton;
			if (fabs(TonNummer-(INT)TonNummer)<=0.5) 
			{
				Ton=floor(TonNummer);
			}
			else	
			{
				Ton=ceil(TonNummer);
			}

			for (INT j=0; j<=Ton; j++)
			{
				if ((j%12==2)||(j%12==3)||(j%12==5)||(j%12==7)||(j%12==8)||(j%12==10)||((j%12==0)&&(j>=1))) PixelY+=5;
			}
			PixelY+=5;

			BOOL Vorzeichen=FALSE;

			if ((Ton%12==1)||(Ton%12==4)||(Ton%12==6)||(Ton%12==9)
					||(Ton%12==11)) Vorzeichen=TRUE;

			yWert=rect.bottom-RandU-PixelY;		
			if (PixelY%10==0) 
			{
				xWert=RandL+50+20;
				xWertVorzeichen=RandL+50+10;
			}
			else
			{
				xWert=RandL+50+40;
				xWertVorzeichen=RandL+50+30;
			}

			if (Vorzeichen) 
			{
				pDC->SelectObject(&NotenStift);
				pDC->MoveTo(xWertVorzeichen-2,yWert-5);
				pDC->LineTo(xWertVorzeichen-2,yWert+5);
				pDC->MoveTo(xWertVorzeichen+1,yWert-5);
				pDC->LineTo(xWertVorzeichen+1,yWert+5);
				pDC->MoveTo(xWertVorzeichen-4,yWert-1);
				pDC->LineTo(xWertVorzeichen+4,yWert-3);
				pDC->MoveTo(xWertVorzeichen-4,yWert+3);
				pDC->LineTo(xWertVorzeichen+4,yWert+1);
				pDC->SelectObject(&NotenStift);
			}
			pDC->Ellipse(xWert-5,yWert-4,xWert+5,yWert+4);

/*
			int dec;
			int sign;
			CString strWert=ecvt(m_ObertonArray.GetAt(i).x,5, &dec,&sign );
			if (dec<=0) 
				for(int z=0;z<=abs(dec);z++) strWert.Insert(0,'0');
			if (dec<=0) strWert.Insert(1,'.');
			else strWert.Insert(dec,'.');
			strWert=strWert.Left(dec);
			if (sign!=0) strWert.Insert(0,'-');
			CString AddOn=" Hz";
			pDC->TextOut(rect.right-RandR+2,yWert-7,strWert+AddOn);
*/
		
			i++;
			if (i==m_ObertonArray.GetSize()) break;
		}
	}
}

BOOL CNotenbildView::CheckIfTonOrNoise()
{
	CArray<DBLPOINT,DBLPOINT> KopieObertonArray;
	INT AnzahlKorrekteObertoene=0;
	INT AnzahlFalscheObertoene=0;
	KopieObertonArray.Copy(m_ObertonArray);
	BOOL bIsTon=FALSE;

	//Testen ob Tne der Obertonreihe fehlen, wenn ja ergnzen
/*	if (KopieObertonArray.GetSize()>2) 
	{
		DOUBLE Grundton=KopieObertonArray.GetAt(0).x;
		DOUBLE Oberton1=KopieObertonArray.GetAt(1).x;
		DOUBLE AbsolutDifferenz=fabs(Grundton-Oberton1);
		DBLPOINT newPt;
		newPt.y=KopieObertonArray.GetAt(0).y;
		//Grundton fehlt
		if (AbsolutDifferenz>0.4*Grundton&&AbsolutDifferenz<0.6*Grundton) 
		{
			newPt.x=AbsolutDifferenz;
			m_ObertonArray.InsertAt(0,newPt);
		}
		//1.Oberton fehlt
		else if (AbsolutDifferenz>1.9*Grundton&&AbsolutDifferenz<2.1*Grundton) 
		{
			newPt.x=AbsolutDifferenz;
			m_ObertonArray.InsertAt(1,newPt);
		}
	}
*/
/*
	//	while (KopieObertonArray.GetSize()>0) 
	{
		for	(int i=1;i<KopieObertonArray.GetSize();i++)
		{
			//Testen ob Obertne geradzahlig sind
			DOUBLE Rest=fmod(KopieObertonArray.GetAt(i).x/KopieObertonArray.GetAt(0).x,1);
			if ((Rest<0.15)||(1-Rest<0.15))  //bei mehr als 15% Abweichung aussortieren
			{
//				KopieObertonArray.RemoveAt(i);
//				i--;
				AnzahlKorrekteObertoene++;
				if (i>=5&&AnzahlKorrekteObertoene>=3) 
				{
//					m_AkkordArray.Add(KopieObertonArray.GetAt(0));
					bIsTon=TRUE;
					break;
				}
			}
			else
			{
				AnzahlFalscheObertoene++;
			}
		}
		if (!bIsTon&&AnzahlKorrekteObertoene>AnzahlFalscheObertoene) 
		{
			bIsTon=TRUE;
		}
		if	(!bIsTon&&KopieObertonArray.GetSize()==1)
			bIsTon=TRUE;
//		if (bIsTon) m_AkkordArray.Add(KopieObertonArray.GetAt(0));
		return bIsTon;
//		KopieObertonArray.RemoveAt(0);
	}
*/
/*	if (KopieObertonArray.GetSize()<=4||AnzahlFalscheObertoene<5) 
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
	*/
	DOUBLE Rest=0;
	DOUBLE RestZusammen=0;
		for	(int i=1;i<KopieObertonArray.GetSize();i++)
		{
			//Testen ob Obertne geradzahlig sind
			Rest=fmod(KopieObertonArray.GetAt(i).x/KopieObertonArray.GetAt(0).x,1);
			if (Rest>0.5) Rest=1-Rest;
			RestZusammen+=Rest;
		}
	DOUBLE Genauigkeit=Rest/KopieObertonArray.GetSize();
	if (Genauigkeit<0.1) 
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
// MessageHandler
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
void CNotenbildView::OnNoten() 
{
	m_WhatIs=2;
	ScrollZurueckSetzen();
	Invalidate(TRUE);
}

void CNotenbildView::OnObertonabstrakt() 
{
	m_WhatIs=0;
	ScrollZurueckSetzen();
	Invalidate(TRUE);
}

void CNotenbildView::OnObertoninnoten() 
{
	m_WhatIs=1;
	ScrollZurueckSetzen();
	Invalidate(TRUE);
}

void CNotenbildView::OnLog() 
{
	CButton* pButton=(CButton*)m_pParentNotenbildFrame->m_wndDlgBar.GetDlgItem(IDC_LIN);
	pButton->SetCheck(0);
	pButton=(CButton*)m_pParentNotenbildFrame->m_wndDlgBar.GetDlgItem(IDC_LOG);
	pButton->SetCheck(1);
	m_bIsLinear=FALSE;
	Invalidate(TRUE);
}

void CNotenbildView::OnLin() 
{
	CButton* pButton=(CButton*)m_pParentNotenbildFrame->m_wndDlgBar.GetDlgItem(IDC_LIN);
	pButton->SetCheck(1);
	pButton=(CButton*)m_pParentNotenbildFrame->m_wndDlgBar.GetDlgItem(IDC_LOG);
	pButton->SetCheck(0);
	m_bIsLinear=TRUE;
	Invalidate(TRUE);
}

void CNotenbildView::OnChangeOberzahlFeld() 
{
	m_Obertonanzahl=m_pParentNotenbildFrame->m_wndDlgBar.GetDlgItemInt(IDC_OBERZAHL_FELD);
	Invalidate(TRUE);
}

void CNotenbildView::OnListenSingle() 
{
	CRect rect;
	GetClientRect(rect);
	int i=0;
	if (m_ObertonArray.GetSize()>2) 
	{
		while (i<m_Obertonanzahl)
		{
			INT Frequenz=(INT)m_ObertonArray.GetAt(i).x;
			Beep((INT)Frequenz,300);				
			i++;
			if (i==m_ObertonArray.GetSize()) break;
		}
	}
}

void CNotenbildView::OnSave() 
{
	// Obtain a handle to a reference device context. 
	CDC* RefDC = GetDC(); 
 
	// Determine the picture frame dimensions. 
	// iWidthMM is the display width in millimeters. 
	// iHeightMM is the display height in millimeters. 
	// iWidthPels is the display width in pixels. 
	// iHeightPels is the display height in pixels 
 
	INT iWidthMM = GetDeviceCaps(RefDC->GetSafeHdc(), HORZSIZE); 
	INT iHeightMM = GetDeviceCaps(RefDC->GetSafeHdc(), VERTSIZE); 
	INT iWidthPels = GetDeviceCaps(RefDC->GetSafeHdc(), HORZRES); 
	INT iHeightPels = GetDeviceCaps(RefDC->GetSafeHdc(), VERTRES); 
 
	// Retrieve the coordinates of the client rectangle, in pixels. 
	CRect rect;
	GetClientRect(rect); 
 
	CSize size=GetTotalSize();
	rect.right=MAX(size.cx,rect.right);
	rect.bottom=MAX(size.cy,rect.bottom);

	// Convert client coordinates to .01-mm units. 
	// Use iWidthMM, iWidthPels, iHeightMM, and 
	// iHeightPels to determine the number of 
	// .01-millimeter units per pixel in the x- 
	//  and y-directions. 
 
	rect.left = (rect.left * iWidthMM * 100)/iWidthPels; 
	rect.top = (rect.top * iHeightMM * 100)/iHeightPels; 
	rect.right = (rect.right * iWidthMM * 100)/iWidthPels; 
	rect.bottom = (rect.bottom * iHeightMM * 100)/iHeightPels; 
 
	// Load the filename Dialog
	CFileDialog SaveNotenbildFileDlg(FALSE,NULL,NULL,OFN_OVERWRITEPROMPT|OFN_NOREADONLYRETURN|OFN_ENABLESIZING,\
              "WMF - Enhanced Metafile|*.wmf|");
  SaveNotenbildFileDlg.m_ofn.nFilterIndex=1;
	SaveNotenbildFileDlg.m_ofn.lpstrDefExt=".wmf";
	SaveNotenbildFileDlg.m_ofn.lpstrTitle="Speichert Notenbild...";
  if (SaveNotenbildFileDlg.DoModal()==IDOK) 
	{
		BeginWaitCursor();

		// Create the metafile device context. 
		CString Pfad=SaveNotenbildFileDlg.GetPathName();
		LPTSTR strFileName=Pfad.GetBuffer(MAX_PATH);
		CMetaFileDC MetaFileDC;
		MetaFileDC.CreateEnhanced(RefDC,strFileName,rect,"SOUNDS Soundanalyse\0Notenbild\0\0");
	
		OnDraw(&MetaFileDC);

		HENHMETAFILE pMetaFile=MetaFileDC.CloseEnhanced();
		DeleteEnhMetaFile(pMetaFile);

		//Alten Cursor zurcksetzen
		EndWaitCursor();

	}
	// Release the reference device context. 
	ReleaseDC(RefDC); 	
}

void CNotenbildView::OnEditCopy() 
{
	BeginWaitCursor();

	CDC* pDC=GetDC();
	CMetaFileDC MetaDC;
	MetaDC.CreateEnhanced(pDC,NULL,NULL,"SOUNDS Soundanalyse\0Notenbild\0\0");
	
	OnDraw(&MetaDC);
	
	//close meta file dc and prepare for clipboard;
	HENHMETAFILE hMF = MetaDC.CloseEnhanced();

	//copy to clipboard
	// Open the clipboard...
	if(!OpenClipboard()) 
	{
    AfxMessageBox(IDS_OPEN_CLIPBOARD_FAIL);
    return;
	}
	EmptyClipboard();
	::SetClipboardData(CF_ENHMETAFILE,hMF);
	CloseClipboard();

	//Alten Cursor zurcksetzen
	EndWaitCursor();
}

BOOL CNotenbildView::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	CSoundsDoc* pDoc=GetDocument();
	pDoc->m_help.SetHelpFile(pDoc->m_strHelpFile);
	pDoc->m_help.DisplayTopic("html/NotenbildundObertonspektrum.html");
	
	return CScrollView::OnHelpInfo(pHelpInfo);
}


BOOL CNotenbildView::OnEraseBkgnd(CDC* pDC) 
{
	return FALSE;
}

void CNotenbildView::DeleteNoten() 
{
	m_AkkordArray.RemoveAll();
	m_ObertonArray.RemoveAll();
	m_ListeLetzteToene.RemoveAll();
	m_NotenCounter=0;
	ScrollZurueckSetzen();
}

void CNotenbildView::OnSize(UINT nType, int cx, int cy) 
{
	CScrollView::OnSize(nType, cx, cy);
	
	CSize size;
	size.cx=MAX(RandL+40+m_AkkordArray.GetSize()*20+RandR,cx);
	size.cy=cy;
	SetScrollSizes(MM_TEXT,size);
	
}

void CNotenbildView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	Invalidate(TRUE);
	if ((lHint==12||g_bIsCapturing)&&m_WhatIs==2)
	{
		CPoint pt=GetScrollPosition();
		CRect rect;
		GetClientRect(rect);
		rect.right=MAX(0,RandL+40+(m_NotenCounter-1)*20-15-pt.x);
//		ValidateRect(rect);
		GetClientRect(rect);
		rect.left=RandL+40+m_NotenCounter*20+5-pt.x;
//		ValidateRect(rect);
	}
	if (lHint==11) 
	{
		DeleteNoten();
	}
}

void CNotenbildView::OnDelete() 
{
	DeleteNoten();
	Invalidate(TRUE);
}
