// RecordData.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "RecordData.h"
#include "SoundsDoc.h"
#include "CaptureThread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//-----------------------------------------------------------------------------
// Desc: Copies data from the capture buffer to the output buffer 
//-----------------------------------------------------------------------------
BOOL RecordCapturedData(LPDIRECTSOUNDCAPTUREBUFFER pDSBCapture,
												DWORD dwNotifySize, 
												DWORD dwCaptureBufferSize,
												DWORD* pdwNextCaptureOffset,
												CArray<DOUBLE,DOUBLE>* pThreadZeitreiheArray,
												CArray<DOUBLE,DOUBLE>* pThreadFrequenzenArray,
												CWaveFile* pMyWaveFile,
												CCaptureThreadInfo* pInfo,
												HWND hwndNotifyProgress,
												WAVEFORMATEX* pwfx)
{
  HRESULT hr;
  VOID*   pbCaptureData    = NULL;
  DWORD   dwCaptureLength;
  VOID*   pbCaptureData2   = NULL;
  DWORD   dwCaptureLength2;
  VOID*   pbPlayData       = NULL;
  UINT    dwDataWrote;
  DWORD   dwReadPos;
  DWORD   dwCapturePos;
  LONG		lLockSize;

// 	CWnd* pWndNotifyProgress = CWnd::FromHandle(hwndNotifyProgress);


	// Das Capturing beginnt.
	if (pInfo != NULL)
	{
		if( NULL == pDSBCapture )
        return FALSE;

    if( FAILED( pDSBCapture->GetCurrentPosition( &dwCapturePos, &dwReadPos ) ) )
        return FALSE;

    lLockSize = dwReadPos - *pdwNextCaptureOffset;
    if( lLockSize < 0 )
        lLockSize += dwCaptureBufferSize;

    // Block align lock size so that we are always write on a boundary
    lLockSize -= (lLockSize % dwNotifySize);

    if( lLockSize == 0 )
        return FALSE;

    // Lock the capture buffer down
    if( FAILED( pDSBCapture->Lock( *pdwNextCaptureOffset, lLockSize, 
                                          &pbCaptureData, &dwCaptureLength, 
                                          &pbCaptureData2, &dwCaptureLength2, 0L ) ) )
        return FALSE;
		
		// Daten in Zeitreihenarray ausgeben und in Testfile
		pThreadZeitreiheArray->RemoveAll();
		pThreadZeitreiheArray->SetSize(pwfx->wBitsPerSample==8?(UINT)dwCaptureLength:(UINT)(dwCaptureLength/2));//+dwCaptureLength2);

		DWORD cT=0;
		for(UINT register x=0;x<(pwfx->wBitsPerSample==8?(UINT)dwCaptureLength:(UINT)(dwCaptureLength/2)); x++)	
		{
			DOUBLE Wert=pwfx->wBitsPerSample==8?*((BYTE*)(pbCaptureData)+x):(*((short*)(pbCaptureData)+x));
			pThreadZeitreiheArray->SetAt(x,Wert);
		}

		// Write the data into the wav file
		if (g_bIsRecording)
		{
	    if( NULL != pMyWaveFile )
				{
				if( FAILED( hr = pMyWaveFile->Write( dwCaptureLength,(BYTE*)pbCaptureData, &dwDataWrote ) ) )
          return FALSE;
				}
		}
		
	 if (g_bIsCapturing) 
	 {
    // Move the capture offset along
    *pdwNextCaptureOffset += dwCaptureLength; 
    *pdwNextCaptureOffset %= dwCaptureBufferSize; // Circular buffer

    if( pbCaptureData2 != NULL )
    {
      // Write the data into the Array
/*			for(UINT register x=0;x<(pwfx->wBitsPerSample==8?(UINT)dwCaptureLength2:(UINT)(dwCaptureLength2/2));x=x++)	
			{
				DOUBLE Wert=pwfx->wBitsPerSample==8?*((BYTE*)(pbCaptureData2)+x):*((short*)(pbCaptureData2)+x);
				pThreadZeitreiheArray->Add(Wert);
			}
*/
	/*
			switch (pwfx->wBitsPerSample)
			{
				case 8:
					for( cT = 0; cT < (UINT)dwCaptureLength2; cT++ )
						pThreadZeitreiheArray->Add((DOUBLE)(*((BYTE*)pbCaptureData2+cT)));
					break;
				case 16:
					for( cT = 0; cT < (UINT)dwCaptureLength2; cT+=2 )
					{
						DOUBLE Wert1=(DOUBLE)(*((BYTE*)(pbCaptureData2)+cT));
						DOUBLE Wert2=(DOUBLE)(*((BYTE*)(pbCaptureData2)+cT+1));
						DOUBLE Wert=Wert1+Wert2*256;
						if (Wert>=32768)
							Wert-=65536;
						pThreadZeitreiheArray->Add(Wert);
					}
					break;
				default:
					AfxMessageBox("Fehlerhafte Bitangabe, bitte nochmal aufrufen");
			} //SWITCH
*/

			// Write the data into the wav file
			if (g_bIsRecording)
			{
       	if( NULL != pMyWaveFile )
				{
					if( FAILED( pMyWaveFile->Write( dwCaptureLength2, (BYTE*)pbCaptureData2, &dwDataWrote ) ) )
            return FALSE;
				}
			}
      // Move the capture offset along
      *pdwNextCaptureOffset += dwCaptureLength2; 
      *pdwNextCaptureOffset %= dwCaptureBufferSize; // Circular buffer
    }
	 }

    // Unlock the capture buffer
    if (FAILED (pDSBCapture->Unlock( pbCaptureData,  dwCaptureLength, pbCaptureData2, dwCaptureLength2 )))
			return FALSE;

		return TRUE;
	} //Notification Message there
	else
		return FALSE;

}
