// Sounds.cpp : Legt das Klassenverhalten fr die Anwendung fest.
//

#include "stdafx.h"
#include "Sounds.h"
#include "InfoView.h"
#include "SoundsOverView.h"
#include "MainFrm.h"
#include "ChildFrm.h"
#include "SplitterFrame.h"
#include "FFTFrame.h"
#include "D3DRekoFrame.h"
#include "ZeitreiheFrame.h"
#include "SoundsDoc.h"
#include "SoundsView.h"
#include "FFTView.h"
#include "ZeitreiheView1.h"
#include "SoundkarteDlg.h"
#include "DirectSoundInit.h"
#include "RekoView.h"
#include "SonoView.h"
#include "SonoFrame.h"
#include "FFT3DFrame.h"
#include "FFT3DView.h"
#include "AnalyseView.h"
#include "NotenbildView.h"
#include "WaveletView.h"
#include "DXCheck.h"
#include "INI.h"
#include "ProfileDLG.h"
#include "StartProfileDLG.h"
#include "SaveProfileDLG.h"
#include "GrundschuleStartDLG.h"
#include <tchar.h>
#include <afxwin.h>
#include "HyperLink.h"
#include "ShortCutsInfoDLG.h"
#include "LanguageDLG.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSoundsApp

BEGIN_MESSAGE_MAP(CSoundsApp, CWinApp)
	//{{AFX_MSG_MAP(CSoundsApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_EINSTELLUNGEN_SOUNDKARTE, OnEinstellungenSoundkarte)
	ON_COMMAND(IDM_SINGLESTEP, OnSinglestep)
	ON_COMMAND(ID_MIXER, OnMixer)
	ON_COMMAND(ID_BREAK, OnBreak)
	ON_COMMAND(ID_EINSTELLUNGEN_PROFIL_CHOOSE, OnEinstellungenProfilChoose)
	ON_COMMAND(ID_EINSTELLUNGEN_PROFIL_WRITE, OnEinstellungenProfilWrite)
	ON_COMMAND(ID_HELP_SHORTCUTS, OnHelpShortcuts)
	ON_COMMAND(ID_UPDATE, OnUpdate)
	ON_COMMAND(ID_EINSTELLUNGEN_LANGUAGE, OnEinstellungenLanguage)
	//}}AFX_MSG_MAP
	// Dateibasierte Standard-Dokumentbefehle
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard-Druckbefehl "Seite einrichten"
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSoundsApp Konstruktion

CSoundsApp::CSoundsApp()
{
}

CSoundsApp::~CSoundsApp()
{
	FreeDirectSound();

  // Release COM
  CoUninitialize();
	CloseHandle(g_hEventBreak);
}

/////////////////////////////////////////////////////////////////////////////
// Die globalen Variablen

CSoundsApp								 theApp;
BOOL											 g_bIsCapturing=FALSE; 
BOOL											 g_bIsRecording=FALSE; 
BOOL											 g_bIsPlayingWave=FALSE;	
BOOL											 g_bIsWaveLoaded=FALSE;	
BOOL											 g_bLooped=FALSE;	
BOOL											 g_bIsConvertedPlay=FALSE;	
BOOL											 g_bIsPutPoints=FALSE;
BOOL											 g_bIsBreak=FALSE;
BOOL											 g_bLButtonDown=FALSE;
BOOL											 g_bIsBusy=FALSE;
HANDLE										 g_hEventBreak = CreateEvent(NULL, TRUE, FALSE, NULL); // manual reset, initially reset
block_pool								 mem_pool;

/////////////////////////////////////////////////////////////////////////////

//CSoundsApp DirectX81Check

BOOL CSoundsApp::CheckForDirectX()
{
    CString strResult;
    DWORD  dwDXVersion = GetDXVersion();

    switch( dwDXVersion )
    {
        case 0x000:
            strResult.LoadString(IDS_NO_DX);
            break;
        case 0x100:
            strResult = "DirectX 1 ";
            break;
        case 0x200:
            strResult = "DirectX 2 ";
            break;
        case 0x300:
            strResult = "DirectX 3 ";
            break;
        case 0x500:
            strResult = "DirectX 5 ";
            break;
        case 0x600:
            strResult = "DirectX 6 ";
            break;
        case 0x601:
            strResult = "DirectX 6.1 ";
            break;
        case 0x700:
            strResult = "DirectX 7 ";
            break;
        case 0x800:
            strResult = "DirectX 8.0 ";
            break;
        case 0x801:
            strResult.LoadString(IDS_DX81_ORBETTER);
            break;
        default:
            strResult.LoadString(IDS_DX_UNKNOWN);
            break;
    }

		if( dwDXVersion >= 0x801 ) 
			return TRUE; //DirectX 8.1 or better installed 
		else
		{
			CString Fehlermeldung;
			AfxFormatString1(Fehlermeldung,E_NODIRECTX,strResult);
			AfxMessageBox(Fehlermeldung, MB_OK | MB_ICONINFORMATION );
			return FALSE; //DirectX 8.1 not installed
		}

}

void	CSoundsApp::SetLanguageSettings()
{
		//Run only once in Installation time
		static DWORD dwLanguageSelected;
		static DWORD dwLanguageEnglish;
		static DWORD dwLanguageGerman;
		// initialization code
		dwLanguageEnglish = MAKELCID(MAKELANGID(LANG_ENGLISH, SUBLANG_DEFAULT),SORT_DEFAULT);
		dwLanguageGerman	= MAKELCID(MAKELANGID(LANG_GERMAN, SUBLANG_DEFAULT),SORT_DEFAULT);

		LCID UserDefault=GetUserDefaultLCID();
		if (UserDefault==dwLanguageEnglish) 
		{
			dwLanguageSelected=dwLanguageEnglish;
		}
		else if (UserDefault==dwLanguageGerman) 
		{
			dwLanguageSelected=dwLanguageGerman;
		}
		else
		{
			dwLanguageSelected=dwLanguageEnglish;
		}
		// load resource	
		SetThreadLocale(dwLanguageSelected);	
		IniAllgemeinLanguage=dwLanguageSelected;

		//Update all INIFiles
		BOOL bFromIni=FALSE;
		CString strIniFile;

		strIniFile = "Profile\\SoundsStandardProfil.ini";
		m_strIniFile = GetModulPath()+strIniFile;
		CIni ini1( m_strIniFile, "Allgemein");
		ini1.SER_GET(bFromIni,IniAllgemeinLanguage);

		strIniFile = "Profile\\SoundsMusikerProfil.ini";
		m_strIniFile = GetModulPath()+strIniFile;
		CIni ini2( m_strIniFile, "Allgemein");
	  ini2.SER_GET(bFromIni,IniAllgemeinLanguage);

		strIniFile = "Profile\\SoundsAnalytikerProfil.ini";
		m_strIniFile = GetModulPath()+strIniFile;
		CIni ini3( m_strIniFile, "Allgemein");
	  ini3.SER_GET(bFromIni,IniAllgemeinLanguage);

		strIniFile = "Profile\\SoundsKomplettProfil.ini";
		m_strIniFile = GetModulPath()+strIniFile;
		CIni ini4( m_strIniFile, "Allgemein");
	  ini4.SER_GET(bFromIni,IniAllgemeinLanguage);

		strIniFile = "Profile\\SoundsOberschuleProfil.ini";
		m_strIniFile = GetModulPath()+strIniFile;
		CIni ini5( m_strIniFile, "Allgemein");
	  ini5.SER_GET(bFromIni,IniAllgemeinLanguage);

		strIniFile = "Profile\\SoundsforKidsProfil.ini";
		m_strIniFile = GetModulPath()+strIniFile;
		CIni ini6( m_strIniFile, "Allgemein");
	  ini6.SER_GET(bFromIni,IniAllgemeinLanguage);

		strIniFile = "Profile\\SoundsUserVorlage.ini";
		m_strIniFile = GetModulPath()+strIniFile;
		CIni ini7( m_strIniFile, "Allgemein");
	  ini7.SER_GET(bFromIni,IniAllgemeinLanguage);

		strIniFile = "Profile\\SoundsZuletztVerwendetProfil.ini";
		m_strIniFile = GetModulPath()+strIniFile;
		CIni ini8( m_strIniFile, "Allgemein");
	  ini8.SER_GET(bFromIni,IniAllgemeinLanguage);
}

// CSoundsApp Initialisierung
BOOL CSoundsApp::InitInstance()
{
	// Standardinitialisierung
	#ifdef _AFXDLL
		Enable3dControls();			// Diese Funktion bei Verwendung von MFC in gemeinsam genutzten DLLs aufrufen
	#else
		Enable3dControlsStatic();	// Diese Funktion bei statischen MFC-Anbindungen aufrufen
	#endif


	//DirectX check
	//DirectX Version muss besser als 8.1 sein, sonst Programm beenden
	if (!CheckForDirectX()) 
	{
		exit(0);
	}
	else
	{
		//Select Language from SystemDefaultUserLanguage, if nothing set in Inifiles
		m_strIniFile = GetModulPath()+"Profile\\SoundsStandardProfil.ini";
		CIni ini1( m_strIniFile, "Allgemein");
		ini1.SER_GET(TRUE,IniAllgemeinLanguage);
		if (IniAllgemeinLanguage==0) 
		{
			SetLanguageSettings();
		}
		else
		{
			SetThreadLocale(IniAllgemeinLanguage);	
		}

		//Set paramters
		m_pDS									= NULL;
		m_pDSCapture					=	NULL;
		m_pDSBPrimary					=	NULL;
		m_pCaptureGUID				=	NULL;
		m_pSoundGUID					=	NULL;
		m_strSoundAusgang = _T("Primrer Soundtreiber");
		m_strSoundEingang = _T("Primrer Soundaufnahmetreiber");
		mp_doc								= NULL;
		m_strIniFile					= _T("");
		m_Profil							= STANDARD;
		m_strSelfDefinedProfileName = "";
		m_strAppTitle					= "SOUNDS";

		IniFensterFFT=0;
		IniFensterFFT3D=0;
		IniFensterAnalyse=0;
		IniFensterNotenbild=0;
		IniFensterReko=0;
		IniFensterSono=0;
		IniFensterWavelet=0;
		IniFensterZeitreihe=0;

		// Initialize COM
	  if( FAILED( CoInitialize(NULL) ) )
	    AfxMessageBox(E_SOUNDSAPP_COINITIALIZE);

	}
	m_bStartWithDatei=TRUE;



	// ndern des Registrierungsschlssels, unter dem unsere Einstellungen gespeichert sind.
//	SetRegistryKey(_T("Addis SoundSoftware"));
//	LoadStdProfileSettings(0);  // Standard INI-Dateioptionen laden (einschlielich MRU)

	// Dokumentvorlagen der Anwendung registrieren. Dokumentvorlagen
	// dienen als Verbindung zwischen Dokumenten, Rahmenfenstern und Ansichten.

  CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_SOUNDSTYPE,
		RUNTIME_CLASS(CSoundsDoc),
		RUNTIME_CLASS(CSplitterFrame), 
		RUNTIME_CLASS(CSoundsView));
	AddDocTemplate(pDocTemplate);

	//KommandozeilenObjekt initialisieren und Kommandozeile auslesen
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	//Grundschulmodus abfangen
	if (cmdInfo.m_strFileName=="") 
	{
		//Profile einlesen
		if (!StartProfilDlg()) return FALSE;
	}
	else if (cmdInfo.m_strFileName=="Kids") 
	{
		m_Profil=GRUNDSCHULE;
		if (!StartGrundschulDlg()) return FALSE;
	}
	else
	{
		m_strSelfDefinedProfileName="SoundsUserProfil-"+cmdInfo.m_strFileName+".ini";
		m_Profil=SELFDEFINED;
	}

	//Inifile einlesen
	if (!ReadIniFile()) return FALSE;


	// Haupt-MDI-Rahmenfenster erzeugen
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	//Parserbefehl von ffnen auf Neu umstellen, damit das Programm nicht versucht Grundschule zu ffnen als Dokument
	cmdInfo.m_strFileName="";
	cmdInfo.m_nShellCommand=CCommandLineInfo::FileNew;

	if (!ProcessShellCommand(cmdInfo))
	{
		AfxMessageBox(E_INITINSTANCE_PROCESSSHELLCOMMAND);
		return FALSE;
	}

  // ffnen per DragDrop aktivieren
//	m_pMainWnd->DragAcceptFiles();

	// DDE-Execute-Open aktivieren
//	EnableShellOpen();
//	RegisterShellFileTypes(TRUE);

	if( InitDirectSoundInterfaces()==1 )
	{
		AfxMessageBox(E_INITINSTANCE_INITDIRECTSOUND);
		return FALSE;
	}

	//Fr andere Views den Dokumentzeiger speichern
	POSITION Docpos=pDocTemplate->GetFirstDocPosition();
	mp_doc=(CSoundsDoc*)pDocTemplate->GetNextDoc(Docpos);

	// Das Hauptfenster ist initialisiert und kann jetzt angezeigt und aktualisiert werden.
	m_pMainWnd->SetWindowPlacement(&m_WPMain);
	if ((m_Profil==STANDARD)||(m_Profil==MUSIKER)||(m_Profil==ANALYTIKER)||(m_Profil==KOMPLETT)
			||(m_Profil==GRUNDSCHULE)||(m_Profil==OBERSCHULE))
	{
		m_WPMain.showCmd=SW_SHOWMAXIMIZED;
	}
	m_pMainWnd->ShowWindow(m_WPMain.showCmd);
	m_pMainWnd->UpdateWindow();

	ProfilVerwirklichen();
	return TRUE;
}


BOOL CSoundsApp::ReadIniFile()
{
	CString strIniFile;
	switch(m_Profil) 
	{
	case STANDARD:
		strIniFile = "Profile\\SoundsStandardProfil.ini";
		break;
	case MUSIKER:
		strIniFile = "Profile\\SoundsMusikerProfil.ini";
		break;
	case ANALYTIKER:
		strIniFile = "Profile\\SoundsAnalytikerProfil.ini";
		break;
	case KOMPLETT:
		strIniFile = "Profile\\SoundsKomplettProfil.ini";
		break;
	case OBERSCHULE:
		strIniFile = "Profile\\SoundsOberschuleProfil.ini";
		break;
	case GRUNDSCHULE:
		strIniFile = "Profile\\SoundsforKidsProfil.ini";
		break;
	case RECENT:
		strIniFile = "Profile\\SoundsZuletztVerwendetProfil.ini";
		break;
	case SELFDEFINED:
		strIniFile = "Profile\\"+m_strSelfDefinedProfileName;
		break;
	}

	m_strIniFile = GetModulPath()+strIniFile;
		
	CFileStatus status;
	if( CFile::GetStatus( m_strIniFile, status ) )
	{
	  // Datei existiert 
		UpdateIni(TRUE);  //Werte laden
		return TRUE;
	}
	else
	{
		//Datei existiert nicht
		CString Text;
		AfxFormatString1(Text,E_READINIFILE,m_strIniFile);
		AfxMessageBox(Text,MB_ICONSTOP);
		return FALSE;
	}
}

CString CSoundsApp::GetModulPath()
{
	// Pfad des INI Files einlesen
	TCHAR acIniFile[MAX_PATH];
	LPTSTR pPathEnd = acIniFile;

	int nChars = ::GetModuleFileName(NULL, acIniFile, MAX_PATH);
	if (nChars > 0)
	{
		// Find end of path.
		for (LPTSTR pch = acIniFile; *pch; pch++)
		{
			if (*pch == '\\' || *pch == '/')
				pPathEnd = pch + 1;
		}
	}

	_tcscpy(pPathEnd,"");												//Modulfilename abschneiden

	return (CString)acIniFile;
}

BOOL CSoundsApp::WriteIniFile()
{
//	LPCTSTR pszIniFile;
//	LPCTSTR pszIniFileVorlage;
	CString FileNameProfil;
	CString FileNameVorlage;
	if (m_Profil==SELFDEFINED)
	{
		FileNameProfil="Profile\\"+m_strSelfDefinedProfileName;
		FileNameVorlage = "Profile\\SoundsUserVorlage.ini";
	}
	else
	{
		FileNameProfil = "Profile\\SoundsZuletztVerwendetProfil.ini";
		FileNameVorlage = "";
	}
	
	m_strIniFile = GetModulPath()+FileNameProfil;

  if ((m_Profil==SELFDEFINED)) 
	{
		CString strIniFileVorlage;
		strIniFileVorlage = GetModulPath()+FileNameVorlage;
		CFile StandardIniFile;
		BOOL bOpenOK;
		CFileStatus status;
		if( CFile::GetStatus( m_strIniFile, status ) )
		{
	   // Datei existiert schon
			INT result=AfxMessageBox(IDS_WRITEINIFILE,MB_OKCANCEL);
			if (result==IDOK) 
			{
//				bOpenOK = CFile( m_strIniFile, CFile::modeCreate|CFile::modeWrite );
			}
			else
				return FALSE;
		}
		else
		{
	    // Datei aus Vorlage neu erstellen
			CFile* theNewFile;
			bOpenOK = StandardIniFile.Open( strIniFileVorlage, CFile::modeRead );
			theNewFile = StandardIniFile.Duplicate();
			theNewFile->SetFilePath(m_strIniFile);
			theNewFile->Close();
			delete theNewFile;
//	    bOpenOK = theFile.Open( m_strIniFile, CFile::modeCreate | CFile::modeWrite );
		}
  }

	UpdateIni(FALSE);  //Werte schreiben

	return TRUE;
}

void CSoundsApp::UpdateIni(BOOL bFromIni /*=TRUE*/)
{
	CIni ini( m_strIniFile, "Allgemein");
  ini.SER_GET(bFromIni,IniAllgemeinLanguage);
  ini.SER_GET(bFromIni,IniAllgemeinGrundschulprofil);
  ini.SER_GET(bFromIni,IniAllgemeinStatusbar);
  ini.SER_GET(bFromIni,IniAllgemeinToolbarNormal);
  ini.SER_GET(bFromIni,IniAllgemeinToolbarSchule);
	ini.SER_GET(bFromIni,IniAllgemeinMenu);
		
  ini.SetSection("Dokument"); 
  ini.SER_GET(bFromIni,IniDokumentNumFFTPoints);

	//Fehler abfangen, dass nicht durch zwei teilbare FFT Zahlen in Inidatei angegeben sind.
	INT Test=(INT)(10*log10(IniDokumentNumFFTPoints)/log10(2));
	if (Test%10!=0) IniDokumentNumFFTPoints=(INT)ldexp(1,(Test-Test%10)/10); 

	ini.SER_GET(bFromIni,IniDokumentPlayFile);

  ini.SetSection("Fenster"); 
  ini.SER_GET(bFromIni,IniFensterFFT);
  ini.SER_GET(bFromIni,IniFensterFFT3D);
  ini.SER_GET(bFromIni,IniFensterAnalyse);
  ini.SER_GET(bFromIni,IniFensterNotenbild);
  ini.SER_GET(bFromIni,IniFensterReko);
  ini.SER_GET(bFromIni,IniFensterSono);
  ini.SER_GET(bFromIni,IniFensterWavelet);
  ini.SER_GET(bFromIni,IniFensterZeitreihe);

  ini.SetSection("ZEITREIHE"); 
  ini.SER_GET(bFromIni,IniZeitreiheKorrCount);
  ini.SER_GET(bFromIni,IniZeitreihePartitions);
  ini.SER_GET(bFromIni,IniZeitreiheCorrlength);
  ini.SER_GET(bFromIni,IniZeitreiheWhatIs);

  ini.SetSection("FFT"); 
  ini.SER_GET(bFromIni,IniFFTBottomCutHz);
  ini.SER_GET(bFromIni,IniFFTTopCutkHz);
  ini.SER_GET(bFromIni,IniFFTBottomCutAmp);
  ini.SER_GET(bFromIni,IniFFTTopCutAmp);
  ini.SER_GET(bFromIni,IniFFTDelay);
  ini.SER_GET(bFromIni,IniFFTbIsDelay);
  ini.SER_GET(bFromIni,IniFFTbGrid);
  ini.SER_GET(bFromIni,IniFFTMinAbstandMaxima);
  ini.SER_GET(bFromIni,IniFFTMinAbstandNachbarMin);
  ini.SER_GET(bFromIni,IniFFTbIsAmpLinear);
  ini.SER_GET(bFromIni,IniFFTbIsFreqLinear);
  ini.SER_GET(bFromIni,IniFFTbDarstellung);
  ini.SER_GET(bFromIni,IniFFTbIsCrossVisible);
  ini.SER_GET(bFromIni,IniFFTbIsSpline);
  ini.SER_GET(bFromIni,IniFFTSplineTyp);
  ini.SER_GET(bFromIni,IniFFTbIsSumme);

  ini.SetSection("3DFFT");
  ini.SER_GET(bFromIni,Ini3DFFTSchrittweite);
  ini.SER_GET(bFromIni,Ini3DFFTclrBackBuffer);
  ini.SER_GET(bFromIni,Ini3DFFTBottomCutHz);
  ini.SER_GET(bFromIni,Ini3DFFTTopCutkHz);
  ini.SER_GET(bFromIni,Ini3DFFTSizePts);
  ini.SER_GET(bFromIni,Ini3DFFTbIsWire);
  ini.SER_GET(bFromIni,Ini3DFFTBreite);
  ini.SER_GET(bFromIni,Ini3DFFTEpsilon);
  ini.SER_GET(bFromIni,Ini3DFFTTau);
  ini.SER_GET(bFromIni,Ini3DFFTbIsBunt);
  ini.SER_GET(bFromIni,Ini3DFFTbIsAmpLinear);
  ini.SER_GET(bFromIni,Ini3DFFTbIsFreqLinear);

	ini.SetSection("Rekonstruktion");
  ini.SER_GET(bFromIni,IniRekoTau);
  ini.SER_GET(bFromIni,IniRekoclrBackBuffer);
  ini.SER_GET(bFromIni,IniRekoSizePts);
  ini.SER_GET(bFromIni,IniRekobIsPunkte);
  ini.SER_GET(bFromIni,IniRekoNumRekoPoints);
  ini.SER_GET(bFromIni,IniRekobIsBunt);

  ini.SetSection("Sonogramm");
  ini.SER_GET(bFromIni,IniSonoBottomCutHz);
  ini.SER_GET(bFromIni,IniSonoLiniendicke);
  ini.SER_GET(bFromIni,IniSonobIsSmooth);
  ini.SER_GET(bFromIni,IniSonoTopCutkHz);
  ini.SER_GET(bFromIni,IniSonobIsAmpLinear);
  ini.SER_GET(bFromIni,IniSonobIsFreqLinear);
	ini.SER_GET(bFromIni,IniSonobIsFarbig1);

  ini.SetSection("Notenbild");
  ini.SER_GET(bFromIni,IniNotenbildIsLinear);
  ini.SER_GET(bFromIni,IniNotenbildWhatIs);
  ini.SER_GET(bFromIni,IniNotenbildObertonanzahl);

  ini.SetSection("Wavelet");
  ini.SER_GET(bFromIni,IniWaveletWavelet);
  ini.SER_GET(bFromIni,IniWaveletFreqmin);
  ini.SER_GET(bFromIni,IniWaveletFreqmax);
  ini.SER_GET(bFromIni,IniWaveletFreqn);
  ini.SER_GET(bFromIni,IniWaveletZeitn);
  ini.SER_GET(bFromIni,IniWaveletadiv);

  ini.SetSection("Analyse");
	ini.SER_GET(bFromIni,IniAnalyseDimLya);
  ini.SER_GET(bFromIni,IniAnalyseTauLya);
  ini.SER_GET(bFromIni,IniAnalyseNumberOfLya);
  ini.SER_GET(bFromIni,IniAnalyseIterLya);
  ini.SER_GET(bFromIni,IniAnalyseNumPointsLya);
  ini.SER_GET(bFromIni,IniAnalyseMaxDimLya);
  ini.SER_GET(bFromIni,IniAnalyseRadiusMinLya);

  ini.SER_GET(bFromIni,IniAnalyseNumPointsLyaMax);
  ini.SER_GET(bFromIni,IniAnalyseIterLyaMax);
  ini.SER_GET(bFromIni,IniAnalyseNumberOfLyaMax);
  ini.SER_GET(bFromIni,IniAnalyseTauLyaMax);
  ini.SER_GET(bFromIni,IniAnalyseRadiusMinLyaMax);
  ini.SER_GET(bFromIni,IniAnalyseRadiusMaxLyaMax);
  ini.SER_GET(bFromIni,IniAnalyseMinDimDoneMaxLya);
  ini.SER_GET(bFromIni,IniAnalyseMaxDimDoneMaxLya);
  ini.SER_GET(bFromIni,IniAnalyseReferenzLyaMax);

  ini.SER_GET(bFromIni,IniAnalyseDimKorr);
  ini.SER_GET(bFromIni,IniAnalyseNumPointsKorr);
  ini.SER_GET(bFromIni,IniAnalyseNumberOfKorr);
  ini.SER_GET(bFromIni,IniAnalyseTauKorr);
  ini.SER_GET(bFromIni,IniAnalyseRadiusMinKorr);
  ini.SER_GET(bFromIni,IniAnalyseRadiusMaxKorr);
  ini.SER_GET(bFromIni,IniAnalyseMaxDimKorr);
  ini.SER_GET(bFromIni,IniAnalyseIterKorr);

  ini.SER_GET(bFromIni,IniAnalyseWhatIs);


	 //Fensterpositionen schreiben
	WINDOWPLACEMENT wpDummy;
	wpDummy.flags=0;
	wpDummy.length=sizeof(wpDummy);
	wpDummy.ptMaxPosition.x=-1;
	wpDummy.ptMaxPosition.y=-1;
	wpDummy.ptMinPosition.x=-1;
	wpDummy.ptMinPosition.y=-1;
	wpDummy.rcNormalPosition.bottom=10;
	wpDummy.rcNormalPosition.right=10;
	wpDummy.rcNormalPosition.left=0;
	wpDummy.rcNormalPosition.top=0;
	wpDummy.showCmd=SW_SHOW;

	//MainWindow
/*	WINDOWPLACEMENT wpMain;
	if (bFromIni) 
	{
		wpMain.length=sizeof(wpMain);
		m_pMainWnd->GetWindowPlacement(&wpMain);
		m_WPMain.length=sizeof(m_WPMain);
	}
*/
	WindowConfigIni(ini,bFromIni,&m_WPMain,wpDummy,"MainWindow");
	if (bFromIni) 
	{
		ScaleMainWindowIfLost(m_WPMain);
	}

	//ChildWindows
	if ((m_Profil==RECENT)||(m_Profil==SELFDEFINED)||bFromIni) 
	{
		WindowConfigIni(ini,bFromIni,&m_WPUebersicht,wpDummy,"UebersichtWindow");
		WindowConfigIni(ini,bFromIni,&m_WPFFT,wpDummy,"FFTWindow");
		WindowConfigIni(ini,bFromIni,&m_WPFFT3D,wpDummy,"FFT3DWindow");
		WindowConfigIni(ini,bFromIni,&m_WPAnalyse,wpDummy,"AnalyseWindow");
		WindowConfigIni(ini,bFromIni,&m_WPNotenbild,wpDummy,"NotenbildWindow");
		WindowConfigIni(ini,bFromIni,&m_WPReko,wpDummy,"RekonstruktionsWindow");
		WindowConfigIni(ini,bFromIni,&m_WPSono,wpDummy,"SonogrammWindow");
		WindowConfigIni(ini,bFromIni,&m_WPWavelet,wpDummy,"WaveletWindow");
		WindowConfigIni(ini,bFromIni,&m_WPZeitreihe,wpDummy,"ZeitreiheWindow");
	}

}
void CSoundsApp::ScaleMainWindowIfLost(WINDOWPLACEMENT wp)
{
	CRect rcTemp;
	CRect rcScreen(0,0,GetSystemMetrics(SM_CXSCREEN),GetSystemMetrics(SM_CYSCREEN));

	// ::SystemParametersInfo(SPI_GETWORKAREA) gives us the screen space
	// minus the system taskbar and application toolbars, which is what 
	// we want our application to fit into.
	
	::SystemParametersInfo(SPI_GETWORKAREA,0,&rcScreen,0);

	// Normalise the existing rectangle, and force equality

	rcTemp=m_WPMain.rcNormalPosition;
	rcTemp.NormalizeRect();
	m_WPMain.rcNormalPosition=rcTemp;

	// See if any part of the window is on the screen

	if(::IntersectRect(&m_WPMain.rcNormalPosition, &rcTemp, &rcScreen))
	{
		if(rcTemp!=m_WPMain.rcNormalPosition)
		{	// some part of the window is off the screen
			if(rcTemp.left<rcScreen.left) 		// off the left edge
				rcTemp.OffsetRect(rcScreen.left-rcTemp.left,0);
			if(rcTemp.right>rcScreen.right) 	// off the right edge
				rcTemp.OffsetRect(rcScreen.right-rcTemp.right,0);
			if(rcTemp.left<rcScreen.left) 		// won't fit, shrink
				rcTemp.left=rcScreen.left;
			if(rcTemp.top<rcScreen.top) 		// off the top edge
				rcTemp.OffsetRect(0,rcScreen.top-rcTemp.top);
			if(rcTemp.bottom>rcScreen.bottom) 	// off the bottom edge
				rcTemp.OffsetRect(0,rcScreen.bottom-rcTemp.bottom);
			if(rcTemp.top<rcScreen.top) 		// won't fit, shrink
				rcTemp.top=rcScreen.top;
			m_WPMain.rcNormalPosition=rcTemp;
		}
	}
	else
	{	// entire window is offscreen
		m_WPMain=wp;
	}
}

void CSoundsApp::WindowConfigIni(CIni ini,BOOL bFromIni, WINDOWPLACEMENT* wp, 
																WINDOWPLACEMENT wpDefault, LPCTSTR Section)
{
	ini.SetSection(Section);
	ini.SER_GETD(bFromIni,wp->showCmd,wpDefault.showCmd);
	ini.SER_GETD(bFromIni,wp->flags,wpDefault.flags);
	ini.SER_GETD(bFromIni,wp->ptMinPosition.x,wpDefault.ptMaxPosition.x);
	ini.SER_GETD(bFromIni,wp->ptMinPosition.y,wpDefault.ptMinPosition.y);
	ini.SER_GETD(bFromIni,wp->ptMaxPosition.x,wpDefault.ptMaxPosition.x);
	ini.SER_GETD(bFromIni,wp->ptMaxPosition.y,wpDefault.ptMaxPosition.y);
	ini.SER_GETD(bFromIni,wp->rcNormalPosition.left,wpDefault.rcNormalPosition.left);
	ini.SER_GETD(bFromIni,wp->rcNormalPosition.top,wpDefault.rcNormalPosition.top);
	ini.SER_GETD(bFromIni,wp->rcNormalPosition.right,wpDefault.rcNormalPosition.right);
	ini.SER_GETD(bFromIni,wp->rcNormalPosition.bottom,wpDefault.rcNormalPosition.bottom);
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialog fr Info ber Anwendung

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogdaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CHyperLink		  m_HyperLink ;
	//}}AFX_DATA

	// berladungen fr virtuelle Funktionen, die vom Anwendungs-Assistenten erzeugt wurden
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_HYPERLINK, m_HyperLink);
	//}}AFX_DATA_MAP
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_HyperLink.SetURL( _T( "http://didaktik.physik.fu-berlin.de/sounds" ) ) ;
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// Anwendungsbefehl zum Ausfhren des Dialogfelds
void CSoundsApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

void CSoundsApp::OnHelpShortcuts() 
{
	CShortCutsInfoDLG ShortCutDlg;
	ShortCutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CSoundsApp-Nachrichtenbehandlungsroutinen


BOOL CSoundsApp::OnIdle(LONG lCount) 
{
	g_bIsBreak=FALSE;
	if (mp_doc->m_bIsNot3D) mp_doc->DeActivate3DViews();
	g_bIsPutPoints=FALSE;
	AfxGetMainWnd()->SetWindowText (m_strAppTitle);
	return CWinApp::OnIdle(lCount);
}

void CSoundsApp::OnSinglestep() 
{
	// TODO: Code fr Befehlsbehandlungsroutine hier einfgen
	
}

void CSoundsApp::OnMixer() 
{
 if (WinExec("sndvol32.exe",SW_RESTORE)<32) 
	 AfxMessageBox(E_MIXER_NOT_FOUND);
}

void CSoundsApp::OnUpdate() 
{
	CString Pfad=GetModulPath()+"Updater\\updater.exe";
//  if (WinExec(Pfad,SW_SHOWNORMAL)<32) 
//	 AfxMessageBox("Updateprogramm 'updater.exe' nicht auffindbar.");
  SHELLEXECUTEINFO sei; 
	ZeroMemory(&sei,sizeof(sei));
  sei.cbSize=sizeof(sei);
  sei.fMask=SEE_MASK_NOCLOSEPROCESS;
  sei.hwnd=AfxGetMainWnd()->GetSafeHwnd();
  sei.lpVerb=NULL;
  sei.lpFile=Pfad;
  sei.lpParameters="";
  sei.lpDirectory=GetModulPath()+"Updater\\";
  sei.nShow=SW_SHOWNORMAL;
  BOOL res=ShellExecuteEx(&sei);
}


void CSoundsApp::OnBreak() 
{
	g_bIsBreak=TRUE;
}


int CSoundsApp::ExitInstance() 
{
	if (IniDokumentNumFFTPoints!=0) 
	{
		m_Profil=RECENT;
		WriteIniFile();
	}
	return CWinApp::ExitInstance();
}

// BEGIN WINDOW PLACEMENT CODE

const WINDOWPLACEMENT& CSoundsApp::GetWP(Views eView) const
{
	switch(eView) 
	{
	case MAIN:
		return m_WPMain;
	case UEBERSICHT:
		return m_WPUebersicht;
	case FFT:
		return m_WPFFT;
	case FFT3D:
		return m_WPFFT3D;
	case ANALYSE:
		return m_WPAnalyse;
	case ZEITREIHE:
		return m_WPZeitreihe;
	case WAVELET:
		return m_WPWavelet;
	case REKO:
		return m_WPReko;
	case NOTENBILD:
		return m_WPNotenbild;
	case SONO:
		return m_WPSono;
	default:
		return m_WPMain;
	}
}

void CSoundsApp::PutWP(const WINDOWPLACEMENT& newval,Views eView)
{	
	switch(eView) {
	case MAIN:
		m_WPMain=newval;
		m_WPMain.length=sizeof(m_WPMain);
		break;
	case UEBERSICHT:
		m_WPUebersicht=newval;
		m_WPUebersicht.length=sizeof(m_WPUebersicht);
		break;
	case FFT:
		m_WPFFT=newval;
		m_WPFFT.length=sizeof(m_WPFFT);
		break;
	case FFT3D:
		m_WPFFT3D=newval;
		m_WPFFT3D.length=sizeof(m_WPFFT3D);
		break;
	case ANALYSE:
		m_WPAnalyse=newval;
		m_WPAnalyse.length=sizeof(m_WPAnalyse);
		break;
	case ZEITREIHE:
		m_WPZeitreihe=newval;
		m_WPZeitreihe.length=sizeof(m_WPZeitreihe);
		break;
	case WAVELET:
		m_WPWavelet=newval;
		m_WPWavelet.length=sizeof(m_WPWavelet);
		break;
	case REKO:
		m_WPReko=newval;
		m_WPReko.length=sizeof(m_WPReko);
		break;
	case NOTENBILD:
		m_WPNotenbild=newval;
		m_WPNotenbild.length=sizeof(m_WPNotenbild);
		break;
	case SONO:
		m_WPSono=newval;
		m_WPSono.length=sizeof(m_WPSono);
		break;
	}
}

//Profilauswahldialogroutinen

BOOL CSoundsApp::StartStdProfileDlg()
{
	
	CProfileDLG Dlg;
	switch(m_Profil) {
	case STANDARD:
		Dlg.m_Profile_Radio_int=0;
		break;
	case MUSIKER:
		Dlg.m_Profile_Radio_int=1;
		break;
	case ANALYTIKER:
		Dlg.m_Profile_Radio_int=2;
		break;
	case KOMPLETT:
		Dlg.m_Profile_Radio_int=3;
		break;
	case OBERSCHULE:
		Dlg.m_Profile_Radio_int=4;
		break;
	case GRUNDSCHULE:
		Dlg.m_Profile_Radio_int=5;
		break;
	}
		Dlg.m_Profil=m_Profil;
		if (Dlg.DoModal()==IDOK)
		{
			m_Profil=Dlg.m_Profil;
			return TRUE;
		}
		else
		{
			return FALSE;
		}
}

// END WINDOW PLACEMENT CODE
BOOL CSoundsApp::StartProfilDlg() 
{
	CStartProfileDLG DlgStart;
	INT iSelection;
	DlgStart.m_ProfilPath=GetModulPath()+"Profile\\";

StartDlg:
	if (DlgStart.DoModal()==IDOK)
	{
		iSelection=DlgStart.m_Radio_Choose_Profiletyp;  
		m_strSelfDefinedProfileName=DlgStart.m_Combo_Eintrag;
	}
	else
	{
		return FALSE;
	}
	switch(iSelection) {
	case 0:
		m_Profil=RECENT;
		return TRUE;
	case 1:
		if (StartStdProfileDlg()) return TRUE;
		else goto StartDlg;
	case 2:
		if (m_strSelfDefinedProfileName=="") goto StartDlg;
		m_strSelfDefinedProfileName="SoundsUserProfil-"+m_strSelfDefinedProfileName+".ini";
		m_Profil=SELFDEFINED;
		return TRUE;
	default:
		m_Profil=RECENT;
		return TRUE;
	}
}

BOOL CSoundsApp::StartGrundschulDlg() 
{
	CGrundschuleStartDLG DlgStart;
	INT iSelection;
	
	if (DlgStart.DoModal()==IDOK)
	{
		iSelection=DlgStart.m_Radio;  
	}
	else
	{
		return FALSE;
	}
	switch(iSelection) {
	case 0:
		m_bStartWithDatei=TRUE;
		return TRUE;
	case 1:
		m_bStartWithDatei=FALSE;
		return TRUE;
	default:
		m_bStartWithDatei=TRUE;
		return TRUE;
	}
}


void CSoundsApp::OnEinstellungenProfilChoose() 
{
	if (StartProfilDlg())
	{
		//Wave entfernen
		if (g_bIsWaveLoaded) mp_doc->OnResetwave();
		
		//offene Fenster schlieen
		if (IniFensterReko) mp_doc->OnAnsicht3drekonstruktion();
		if (IniFensterZeitreihe)	mp_doc->OnAnsichtZeitreihe();
		if (IniFensterFFT) mp_doc->OnAnsichtFFT();	
		if (IniFensterSono)	mp_doc->OnAnsichtSono();	
		if (IniFensterFFT3D)	mp_doc->OnAnsicht3dfft();	
		if (IniFensterAnalyse)	mp_doc->OnAnsichtAnalyse();	
		if (IniFensterNotenbild)	mp_doc->OnAnsichtNotenbild();
		if (IniFensterWavelet)	mp_doc->OnAnsichtWavelet();

		//IniFile einlesen
		if (!ReadIniFile()) exit(0);

		if (m_Profil==GRUNDSCHULE) 
		{
			StartGrundschulDlg();
		}

		ProfilVerwirklichen();
	}
}

void CSoundsApp::ProfilVerwirklichen()
{
	CString AppTitle;
	AppTitle.LoadString(IDS_NO_FILE_CHOOSEN);

	//check for correct language setting
	if ((AppTitle=="keine Datei ausgewhlt")&&(IniDokumentPlayFile=="no file selected")) IniDokumentPlayFile="keine Datei ausgewhlt";
	if ((AppTitle=="no file selected")&&(IniDokumentPlayFile=="keine Datei ausgewhlt")) IniDokumentPlayFile="no file selected";

	//Set Language
	SetThreadLocale(IniAllgemeinLanguage);	

	//IniWavefile einlesen
	if (IniDokumentPlayFile!=AppTitle) 
	{
		CFileStatus status;
		if( CFile::GetStatus( IniDokumentPlayFile, status ) )
		{
		  // Datei existiert 
			CString Extension=IniDokumentPlayFile.Right(3);
			Extension.MakeUpper();
			if (Extension=="WAV") 
				mp_doc->WaveFileEinlesen(IniDokumentPlayFile);
			else
				mp_doc->Zeitreiheeinlesen(IniDokumentPlayFile);
			AppTitle=IniDokumentPlayFile.Right(IniDokumentPlayFile.GetLength()
																						-IniDokumentPlayFile.ReverseFind('\\')-1);
		}
		else
		{
			//Datei existiert nicht
			AfxMessageBox(E_PROFILVERWIRKLICHEN,MB_ICONSTOP);
		}
	}
//	*mp_doc->GetWaveFilename()=IniDokumentPlayFile;
	mp_doc->SetTitle(AppTitle);

	//Toolbar,Statusbar und Menzeile an- oder ausschalten
	CMainFrame* pFrame=(CMainFrame*)AfxGetMainWnd();

	//Toolbars
	if (IniAllgemeinToolbarNormal) pFrame->m_wndToolBarNormal.ShowWindow(SW_SHOW);
	else pFrame->m_wndToolBarNormal.ShowWindow(SW_HIDE);
	if (IniAllgemeinToolbarSchule) pFrame->m_wndToolBarSchule.ShowWindow(SW_SHOW);
	else pFrame->m_wndToolBarSchule.ShowWindow(SW_HIDE);

	//Statusbar
	if (IniAllgemeinStatusbar) pFrame->m_wndStatusBar.ShowWindow(SW_SHOW);
	else pFrame->m_wndStatusBar.ShowWindow(SW_HIDE);
		//Fenstergren neu berechnen
	pFrame->RecalcLayout();
		//Fenstergre von bersichtsfenster setzen
	WINDOWPLACEMENT wp;
	wp=GetWP(UEBERSICHT);
	SwitchWindowplacementAbsolutePercent(FALSE,&wp);
	POSITION pos = mp_doc->GetFirstViewPosition();
	CView* pView=NULL;
	while (pos != NULL)
	{
	  pView = mp_doc->GetNextView(pos);
		CRuntimeClass* pRuntimeKlasse=pView->GetRuntimeClass();
		if (pRuntimeKlasse->m_lpszClassName=="CSoundsOverView")
		{
			CSoundsOverView* pSoundsOverView=(CSoundsOverView*)pView;
			CSplitterFrame* pFrame=(CSplitterFrame*)pView->GetParentFrame();
			pFrame->SetWindowPlacement(&wp);
			if (IniAllgemeinGrundschulprofil) 
			{
				pFrame->m_wndSplitter.SetRowInfo(0,200,100);
				pFrame->m_wndSplitter.SetRowInfo(1,1,0);
				pFrame->m_wndSplitter.RecalcLayout();
			}
			else
			{
				pFrame->m_wndSplitter.SetRowInfo(0,50,50);
				pFrame->m_wndSplitter.SetRowInfo(1,100,50);
				pFrame->m_wndSplitter.RecalcLayout();
			}
			break;
		}
	}

	//Mens einstellen
	if (!IniAllgemeinGrundschulprofil) 
	{
		CMenu Menu;
		Menu.LoadMenu(IDR_MENU);
		pFrame->SetMenu(&Menu);
		Menu.Detach();
		SwitchWindowDlgBars(TRUE,FALSE);
		m_strAppTitle="SOUNDS";
	}
	else
	{
		CMenu Menu;
		Menu.LoadMenu(IDR_MAINFRAME);
		pFrame->SetMenu(&Menu);
		Menu.Detach();
		SwitchWindowDlgBars(FALSE,FALSE);
		m_strAppTitle="SOUNDS for Kids";
	}

		//in Inifile vorgesehene Fenster ffnen mit eingelesenen Parametern
	if (IniFensterReko) mp_doc->OnAnsicht3drekonstruktion();
	if (IniFensterZeitreihe)	mp_doc->OnAnsichtZeitreihe();
	if (IniFensterFFT) mp_doc->OnAnsichtFFT();	
	if (IniFensterSono)	mp_doc->OnAnsichtSono();	
	if (IniFensterFFT3D)	mp_doc->OnAnsicht3dfft();	
	if (IniFensterAnalyse)	mp_doc->OnAnsichtAnalyse();	
	if (IniFensterNotenbild)	mp_doc->OnAnsichtNotenbild();
	if (IniFensterWavelet)	mp_doc->OnAnsichtWavelet();

	if(IniAllgemeinGrundschulprofil&&m_Profil!=RECENT)
	{
		if (m_bStartWithDatei) 
		{
			mp_doc->OnDatenWavefileeinlesen();
		}
		else
		{
//			AfxMessageBox("Jetzt bitte das Mikrofon an den Computer anschlieen \nund dann zum Test hineinsprechen.\nWenn dann im Programm nichts zu sehen ist, \nist der Eingang der Soundkarte wahrscheinlich noch nicht auf Mikrofon eingestellt.");
			mp_doc->OnDatenAudioeingang();
		}
	}
	::SendMessage(AfxGetMainWnd()->GetSafeHwnd(),WM_USER_SETWAVEFILEBAR,0,0);
	mp_doc->UpdateAllViews(NULL,50);
}

void CSoundsApp::OnEinstellungenProfilWrite() 
{
	CSaveProfileDLG DlgSave;
	CString Temp;
	Temp=m_strSelfDefinedProfileName;
	Temp.Replace("SoundsUserProfil-","");
	Temp.Replace(".ini","");
	DlgSave.m_Filename=Temp;
	DlgSave.m_FilenameLong=m_strSelfDefinedProfileName;
	if (DlgSave.DoModal()==IDOK)
	{
		m_strSelfDefinedProfileName=DlgSave.m_FilenameLong;
		m_Profil=SELFDEFINED;
		GetWindowPlacementsAndParameters();
		WriteIniFile();
	}
	
}


void CSoundsApp::SwitchWindowDlgBars(BOOL bDlgOn,BOOL bRedrawFrame)
{
	POSITION pos = mp_doc->GetFirstViewPosition();
	CView* pView=NULL;
	pos = mp_doc->GetFirstViewPosition();
	while (pos != NULL)
	{
		pView = mp_doc->GetNextView(pos);
	  CRuntimeClass* pRuntimeKlasse=pView->GetRuntimeClass();
		if (pRuntimeKlasse->m_lpszClassName=="CSoundsOverView")
		{
			CSplitterFrame* pFrame=(CSplitterFrame*)pView->GetParentFrame();
			if (bRedrawFrame) 
				pFrame->DoPlacement(TRUE);
//			else
//				pFrame->m_wndDlgBar.ShowWindow(bDlgOn);
			pFrame->RecalcLayout(TRUE);
		}
				else if (pRuntimeKlasse->m_lpszClassName=="CAnalyseView") 
				{
					CAnalyseFrame* pFrame=(CAnalyseFrame*)pView->GetParentFrame();
					if (bRedrawFrame) 
						pFrame->DoPlacement(TRUE);
					else
						pFrame->m_wndDlgBar.ShowWindow(bDlgOn);
					pFrame->RecalcLayout(TRUE);
				}
				else if (pRuntimeKlasse->m_lpszClassName=="CZeitreiheView")
				{
					CZeitreiheFrame* pFrame=(CZeitreiheFrame*)pView->GetParentFrame();
					if (bRedrawFrame) 
						pFrame->DoPlacement(TRUE);
					else
						pFrame->m_wndDlgBar.ShowWindow(bDlgOn);
					pFrame->RecalcLayout(TRUE);
				}
				else if (pRuntimeKlasse->m_lpszClassName=="CFFT3DView") 
				{
					CFFT3DFrame* pFrame=(CFFT3DFrame*)pView->GetParentFrame();
					if (bRedrawFrame) 
						pFrame->DoPlacement(TRUE);
					else
						pFrame->m_wndDlgBar.ShowWindow(bDlgOn);
					pFrame->RecalcLayout(TRUE);
				}
				else if (pRuntimeKlasse->m_lpszClassName=="CFFTView")
				{
					CFFTFrame* pFrame=(CFFTFrame*)pView->GetParentFrame();
					if (bRedrawFrame) 
						pFrame->DoPlacement(TRUE);
					else
						pFrame->m_wndDlgBar.ShowWindow(bDlgOn);
					pFrame->RecalcLayout(TRUE);
				}
				else if (pRuntimeKlasse->m_lpszClassName=="CNotenbildView")
				{
					CNotenbildFrame* pFrame=(CNotenbildFrame*)pView->GetParentFrame();
					if (bRedrawFrame) 
						pFrame->DoPlacement(TRUE);
					else
						pFrame->m_wndDlgBar.ShowWindow(bDlgOn);
					pFrame->RecalcLayout(TRUE);
				}
				else if (pRuntimeKlasse->m_lpszClassName=="CRekoView")
				{
					CD3DRekoFrame* pFrame=(CD3DRekoFrame*)pView->GetParentFrame();
					if (bRedrawFrame) 
						pFrame->DoPlacement(TRUE);
					else
						pFrame->m_wndDlgBar.ShowWindow(bDlgOn);
					pFrame->RecalcLayout(TRUE);
				}
				else if (pRuntimeKlasse->m_lpszClassName=="CSonoView")
				{
					CSonoFrame* pFrame=(CSonoFrame*)pView->GetParentFrame();
					if (bRedrawFrame) 
						pFrame->DoPlacement(TRUE);
					else
						pFrame->m_wndDlgBar.ShowWindow(bDlgOn);
					pFrame->RecalcLayout(TRUE);
				}
				else if (pRuntimeKlasse->m_lpszClassName=="CWaveletView")
				{
					CWaveletFrame* pFrame=(CWaveletFrame*)pView->GetParentFrame();
					if (bRedrawFrame) 
						pFrame->DoPlacement(TRUE);
					else
						pFrame->m_wndDlgBar.ShowWindow(bDlgOn);
					pFrame->RecalcLayout(TRUE);
				}
			}   
}

void CSoundsApp::GetWindowPlacementsAndParameters()
{
	mp_doc->IniFileWrite();
	POSITION pos = mp_doc->GetFirstViewPosition();
	CView* pView=NULL;

	while (pos != NULL)
	{
    pView = mp_doc->GetNextView(pos);
    CRuntimeClass* pRuntimeKlasse=pView->GetRuntimeClass();
		CFrameWnd* pFrame=pView->GetParentFrame();
		WINDOWPLACEMENT wp;
		pFrame->GetWindowPlacement(&wp);
		SwitchWindowplacementAbsolutePercent(TRUE,&wp);
		if (pRuntimeKlasse->m_lpszClassName=="CSoundsOverView") PutWP(wp,UEBERSICHT);
		else if (pRuntimeKlasse->m_lpszClassName=="CAnalyseView") 
		{ 
			PutWP(wp,ANALYSE); 
			CAnalyseView* pView2=(CAnalyseView*)pView;
			pView2->IniFileWrite();
		}
		else if (pRuntimeKlasse->m_lpszClassName=="CZeitreiheView") PutWP(wp,ZEITREIHE);
		else if (pRuntimeKlasse->m_lpszClassName=="CFFT3DView") 
		{ 
			PutWP(wp,FFT3D); 
			CFFT3DView* pView2=(CFFT3DView*)pView;
			pView2->IniFileWrite();
		}
		else if (pRuntimeKlasse->m_lpszClassName=="CFFTView")
		{ 
			PutWP(wp,FFT); 
			CFFTView* pView2=(CFFTView*)pView;
			pView2->IniFileWrite();
		}
		else if (pRuntimeKlasse->m_lpszClassName=="CNotenbildView")
		{ 
			PutWP(wp,NOTENBILD); 
			CNotenbildView* pView2=(CNotenbildView*)pView;
			pView2->IniFileWrite();
		}
		else if (pRuntimeKlasse->m_lpszClassName=="CRekoView")
		{ 
			PutWP(wp,REKO); 
			CRekoView* pView2=(CRekoView*)pView;
			pView2->IniFileWrite();
		}
		else if (pRuntimeKlasse->m_lpszClassName=="CSonoView")
		{ 
			PutWP(wp,SONO); 
			CSonoView* pView2=(CSonoView*)pView;
			pView2->IniFileWrite();
		}
		else if (pRuntimeKlasse->m_lpszClassName=="CWaveletView")
		{ 
			PutWP(wp,WAVELET); 
			CWaveletView* pView2=(CWaveletView*)pView;
			pView2->IniFileWrite();
		}
	}   
}

//Berechnet die von GetWindowPlacement gewonnenen Koordinaten
void CSoundsApp::SwitchWindowplacementAbsolutePercent(BOOL bToPercent,WINDOWPLACEMENT* pwp)
{
//	CMainFrame* pWnd=(CMainFrame*)m_pMainWnd->GetParentFrame();
	CRect MainWindowRect;
	CMainFrame* pWnd=(CMainFrame*)m_pMainWnd;
	m_pMainWnd->GetClientRect(MainWindowRect);
	INT PixelX=MainWindowRect.right;
	INT PixelY=MainWindowRect.bottom
							-(IniAllgemeinToolbarNormal?*pWnd->GetToolBarNormalHeight():0)
							-(IniAllgemeinToolbarSchule?*pWnd->GetToolBarSchuleHeight():0)
							-(IniAllgemeinStatusbar?*pWnd->GetStatusBarHeight():0);
	if (bToPercent) 
	{
		pwp->rcNormalPosition.left=(INT)ceil(pwp->rcNormalPosition.left*10000.0f/PixelX);
		pwp->rcNormalPosition.top=(INT)ceil(pwp->rcNormalPosition.top*10000.0f/PixelY);
		pwp->rcNormalPosition.right=(INT)ceil(pwp->rcNormalPosition.right*10000.0f/PixelX);
		pwp->rcNormalPosition.bottom=(INT)ceil(pwp->rcNormalPosition.bottom*10000.0f/PixelY);
	}
	else
	{
		pwp->rcNormalPosition.left=(INT)ceil(PixelX*pwp->rcNormalPosition.left/10000.0f);
		pwp->rcNormalPosition.top=(INT)ceil(PixelY*pwp->rcNormalPosition.top/10000.0f);
		pwp->rcNormalPosition.right=(INT)ceil(PixelX*pwp->rcNormalPosition.right/10000.0f);
		pwp->rcNormalPosition.bottom=(INT)ceil(PixelY*pwp->rcNormalPosition.bottom/10000.0f);
		//Rundungsfehler beheben
		pwp->rcNormalPosition.right-=pwp->rcNormalPosition.right%2;
		pwp->rcNormalPosition.bottom-=pwp->rcNormalPosition.bottom%2;
		pwp->rcNormalPosition.top-=pwp->rcNormalPosition.top%2;
		pwp->rcNormalPosition.left-=pwp->rcNormalPosition.left%2;
	}
}


void CSoundsApp::OnEinstellungenLanguage() 
{
	CLanguageDLG LangDlg;
  if (LangDlg.DoModal()==IDOK) 
	{
		static DWORD dwLanguage;
		// initialization code
		if (LangDlg.m_strLanguage=="English")
		{
			 dwLanguage = MAKELCID(MAKELANGID(LANG_ENGLISH, SUBLANG_DEFAULT),SORT_DEFAULT);
		}
		if (LangDlg.m_strLanguage=="Deutsch")
		{
			 dwLanguage = MAKELCID(MAKELANGID(LANG_GERMAN, SUBLANG_DEFAULT),SORT_DEFAULT);
		}
		// load resource	

		SetThreadLocale(dwLanguage);	

		//Wave entfernen
		if (g_bIsWaveLoaded) mp_doc->OnResetwave();
		
		//offene Fenster schlieen
		if (IniFensterReko) mp_doc->OnAnsicht3drekonstruktion();
		if (IniFensterZeitreihe)	mp_doc->OnAnsichtZeitreihe();
		if (IniFensterFFT) mp_doc->OnAnsichtFFT();	
		if (IniFensterSono)	mp_doc->OnAnsichtSono();	
		if (IniFensterFFT3D)	mp_doc->OnAnsicht3dfft();	
		if (IniFensterAnalyse)	mp_doc->OnAnsichtAnalyse();	
		if (IniFensterNotenbild)	mp_doc->OnAnsichtNotenbild();
		if (IniFensterWavelet)	mp_doc->OnAnsichtWavelet();

		//IniFile einlesen
		if (!ReadIniFile()) exit(0);

		ProfilVerwirklichen();
	}

}
