// SoundsDoc.h : Schnittstelle der Klasse CSoundsDoc
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SOUNDSDOC_H__D333F760_1C27_4A59_93BB_EC948FFA4F8E__INCLUDED_)
#define AFX_SOUNDSDOC_H__D333F760_1C27_4A59_93BB_EC948FFA4F8E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct tagDBLPOINT { 
    DOUBLE x; 
    DOUBLE y; 
} DBLPOINT; 

typedef CArray<DOUBLE,DOUBLE> DBLArray; 

#define NUM_REC_NOTIFICATIONS  16
#define NUM_PLAY_NOTIFICATIONS  16

#define MAX(a,b)        ( (a) > (b) ? (a) : (b) )
#define MIN(a,b)        ( (a) < (b) ? (a) : (b) )

//#include "Generator.h"

class CSoundsDoc : public CDocument
{
	DECLARE_DYNCREATE(CSoundsDoc)
	CSoundsDoc();

// Variablen

protected:
//	LPDIRECTSOUNDCAPTUREBUFFER m_pDSBCapture;
//	LPDIRECTSOUNDNOTIFY        m_pDSNotify;
//	DSBPOSITIONNOTIFY          m_aPosNotify[NUM_REC_NOTIFICATIONS+1];  
//	DWORD                      m_dwNotifySize;
	DWORD                      m_dwNumPlayNotifications;
//	DWORD                      m_dwCaptureBufferSize;
//	DWORD                      m_dwNextCaptureOffset;
// 	CWaveFile*								 m_pCaptureWaveFile;
	WAVEFORMATEX*							 m_pwfxInput;
	WAVEFORMATEX							 m_wfxWave;
	CArray<DOUBLE,DOUBLE>			 m_ZeitreiheArray;
	CArray<DOUBLE,DOUBLE>			 m_FrequenzenArray;

	CArray<DBLArray*,DBLArray*>	 m_AutoKorrArray;
	

	CArray<DOUBLE,DOUBLE>			 m_AutoKorrArray0;
	CArray<DOUBLE,DOUBLE>			 m_AutoKorrArray1;
	CArray<DOUBLE,DOUBLE>			 m_AutoKorrArray2;
	CArray<DOUBLE,DOUBLE>			 m_AutoKorrArray3;
	CArray<DOUBLE,DOUBLE>			 m_AutoKorrArray4;
	CArray<DOUBLE,DOUBLE>			 m_AutoKorrArray5;
	CArray<DOUBLE,DOUBLE>			 m_AutoKorrArray6;
	CArray<DOUBLE,DOUBLE>			 m_AutoKorrArray7;
	CArray<DOUBLE,DOUBLE>			 m_AutoKorrArray8;
	CArray<DOUBLE,DOUBLE>			 m_AutoKorrArray9;
	CArray<DOUBLE,DOUBLE>			 m_AutoKorrArray10;

	CArray<DOUBLE,DOUBLE>			 m_WAVKomplettArray;
	CArray<FLOAT,FLOAT>				 m_PGMKomplettArray;
	CArray<DOUBLE,DOUBLE>				 m_WaveletPacketArray;
	BOOL											 m_Signed;
	INT												 m_BitRate;
	INT												 m_BitRateConverted;
	INT												 m_SampleRateConverted;
	DOUBLE										 m_MaxAmplitude;


	DWORD											 m_dwNotifyThreadID;
	int												 m_counter;
	BYTE*											 m_pSoundBuffer;
	DWORD											 m_SoundBufferSize;
	BYTE*											 m_pSoundBufferConverted;
	BYTE*											 m_AktualPlaySoundBuffer;
	DWORD											 m_SoundBufferConvertedSize;
	DWORD											 m_AktualPlaySoundBufferSize;
	CPalette									 m_Pal;
	CWaveFile*								 m_pTempWaveConverted;
	DWORD											 m_PlayCursor;
	UINT											 m_TimerID;
	BOOL											 m_bReadLinkerKanal;
	BOOL											 m_bStereo;
	
	CArray<DBLPOINT,DBLPOINT>	 m_Obertonpeaks;
	WaveletCoeffs*						 m_pWaveletCoeffs;
	WaveletTransform*					 m_pWaveletTransformObjekt;

	CWaveletTrafo*						 m_pWaveletTrafo;

	CString											m_strProgress;

	DWORD											m_dwBufferRegionStart;
	DWORD											m_dwBufferRegionEnd;
	
public:
	CMsHelp										m_help;
	HICON											m_hIcon;
	CString										m_strHelpFile;
	BOOL												m_bIsNot3D;


	CStreamingSound*					 m_pStreamingSound;
	CSound*										 m_pSound;
	HANDLE                     m_hEventCaptureBufferNotify; 
	HANDLE										 m_hEventPlayBufferNotify;
	HANDLE										 m_hEventCaptureStart;
	HANDLE										 m_hEventCaptureDone;
	HANDLE										 m_hEventKillCaptureThread;
	HANDLE										 m_hEventCaptureThreadKilled;
	HANDLE										 m_hEventNotifyDone;
	HANDLE										 m_hEventKillPlayThread;
	HANDLE										 m_hEventPlayThreadKilled;
	HANDLE										 m_hEventIsLooped;

	CWinThread*								 m_pCaptureWorkerThread;
	CCaptureThreadInfo				 m_CaptureThreadInfo;

	CChildFrame*							 m_pViewInfo;
	CD3DRekoFrame*						 m_pViewD3DReko;
	CFFTFrame*								 m_pViewFFT;
	CZeitreiheFrame*					 m_pViewZeitreihe;
	CSonoFrame*								 m_pViewSono;
	CFFT3DFrame*							 m_pViewFFT3D;
	CAnalyseFrame*						 m_pViewAnalyse;
	CNotenbildFrame*					 m_pViewNotenbild;
	CWaveletFrame*						 m_pViewWavelet;
	
	INT				m_intBits;
	CString		m_strChannels;
	CString		m_strFormat;
	INT				m_intSamples;
	CString		m_strPlayFile;
	CString		m_strRecordFile;
	INT				m_NumFFTPoints;
	INT				m_NumBigFFTPoints;

	INT				m_FirstNullstelleAutokorr;
// 	Generator m_Gen;


// Operationen
public:
// 	inline CWaveFile* GetCaptureWav(){ return m_pCaptureWaveFile;}
	inline WaveletCoeffs* GetWaveletCoeffs(){ return m_pWaveletCoeffs;}
	inline WAVEFORMATEX* GetCaptureWavFormat(){ return m_pwfxInput;}
	inline WAVEFORMATEX* GetWaveFormat(){ return &m_wfxWave;}
	VOID GetWaveFormatFromIndex( INT nIndex, WAVEFORMATEX* pwfx );
	inline CArray<DOUBLE,DOUBLE>* GetZeitreiheArray() { return &m_ZeitreiheArray; }
	inline CArray<DOUBLE,DOUBLE>* GetFrequenzenArray() { return &m_FrequenzenArray; }
	inline CArray<DOUBLE,DOUBLE>* GetWAVKomplettArray() { return &m_WAVKomplettArray; }
	inline CArray<DBLArray*,DBLArray*>* GetAutoKorrArray() { return &m_AutoKorrArray; }
	inline CArray<FLOAT,FLOAT>* GetPGMArray() { return &m_PGMKomplettArray; }
	inline CArray<DOUBLE,DOUBLE>* GetWaveletPacketArray() { return &m_WaveletPacketArray; }
	inline CArray<DBLPOINT,DBLPOINT>* GetPeakArray() { return &m_Obertonpeaks; }
	inline BOOL* GetSigned() { return &m_Signed; }
	inline BYTE* GetSoundBuffer() { return m_pSoundBuffer; }
	inline DWORD* GetSoundBufferSize() { return &m_SoundBufferSize; }
	inline DWORD* GetAktualPlaySoundBufferSize() { return &m_AktualPlaySoundBufferSize; }
	inline DWORD* GetPlayCursor() { return &m_PlayCursor; }
	inline INT* GetBitRate() { return &m_BitRate; }
	inline INT* GetSampleRate() { return &m_intSamples; }
	inline INT* GetFFTPoints() { return &m_NumFFTPoints; }
	inline INT* GetBigFFTPoints() { return &m_NumBigFFTPoints; }
	inline INT* GetAutoKorrNullstelle() { return &m_FirstNullstelleAutokorr; }
	inline DOUBLE* GetMaxAmplitude() { return &m_MaxAmplitude; }
	inline CString* GetWaveFilename() { return &m_strPlayFile; }
	inline CWaveletTrafo* GetWaveletTrafo() { return m_pWaveletTrafo; }
	inline CString* GetProgressString() { return &m_strProgress; }

	CString* GetWaveText();
	VOID OnCaptureDone();
	VOID OnPlayNotifyDone(DWORD Offset);
	VOID PutNewWaveCutPointsInArrays(DWORD Start, DWORD End);
	CPalette* GetPalette() { return &m_Pal; }
// 	VOID DoMultipleFFT(int FFTPoints,int count);
	VOID DoWavelet(int FFTPoints);
	VOID DoFFT(int FFTPoints);
	VOID DoWaveletPacket(int FFTPoints);

	BOOL DoFFTAtPoint(CArray<DOUBLE,DOUBLE>* pZeitreihe, int Start, int FFTPoints, CArray<DOUBLE,DOUBLE>* pFrequenzen);
	void SetObertonPeaks(CArray<DBLPOINT,DBLPOINT>* pPunktarray);
	void		WaveFileEinlesen( CString strPlayFile );
	void IniFileWrite();
	void IniFileRead();
	void DeActivate3DViews();
	void UpdateStatusBar();
	void SetSelectedRegion(DWORD Start, DWORD End);
	void Zeitreiheeinlesen(CString DATFile);
	void CalcAllAutoKorrelationFunctions(int NumOfFuncs);

protected:
	HRESULT CreateConvertedTempWaveForSoundPlay(LPTSTR Filename);
	HRESULT CreateCSoundObjekt( CSound** ppSound, LPTSTR strWaveFileName, DWORD dwCreationFlags, 
                               GUID guid3DAlgorithm, DWORD dwNumBuffers );
	void		CreateCaptureThread();
	void		CreatePlayThread();
	HRESULT	LoadWaveAndCreateBuffer( TCHAR* strFileName );
	HRESULT PlayBuffer( BOOL bLooped );
	HRESULT	CreateAbbild(TCHAR* strFileName);
	BOOL		CreatePalette(CPalette* pPal);
	HRESULT ConvertAsIsToMono();
	HRESULT	ConvertZeitreiheToWave(CArray<DOUBLE,DOUBLE&>* pZeitreihe);
	void		ChangeCWTtoFrequencies();
	void		DeActivateOtherViews(INT ViewNr);
	void		WriteWaveParametersInVariables(WAVEFORMATEX* pwfx);
	BOOL		ConvertMP3toWAV(CString strInputFileName,CString strOutputFileName,HWND MessagehWnd);
	void		SaveWAV2WAV(LPTSTR strFileNameWrite,LPTSTR strFileNameRead);
	BOOL		SaveWAV2MP3(LPTSTR strFileNameWrite,LPTSTR strFileNameRead);
	void		CalcAutoKorrelationFunction(int FFTPoints,FFTReal* FFTObjekt,
																						 DblFFTPts* const Frequenz,
																						 DblFFTPts* const Amplitude,
																						 CArray<DOUBLE,DOUBLE>* pArrayAutokorr);

	HRESULT CreateFilterByName(LPCTSTR lpszName,IBaseFilter** ppFilter);
	HRESULT AddFilterByName(IGraphBuilder* pGB, LPCTSTR lpszDispName,LPCTSTR lpszName,IBaseFilter** ppFilter);

// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CSoundsDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	//}}AFX_VIRTUAL

// Implementierung
public:
	virtual ~CSoundsDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	void InitDocument();

// Generierte Message-Map-Funktionen
protected:
public:
	afx_msg void OnFensterAnalyse();
	afx_msg void OnFensterFFT3D();
	afx_msg void OnFensterFFT();
	afx_msg void OnFensterNotenbild();
	afx_msg void OnFensterReko();
	afx_msg void OnFensterSono();
	afx_msg void OnFensterMain();
	afx_msg void OnFensterWavelet();
	afx_msg void OnFensterZeitreihe();
	//{{AFX_MSG(CSoundsDoc)
	afx_msg HRESULT OnEinstellungenWaveformat();
	afx_msg void OnDatenZeitreiheeinlesen();
	afx_msg HRESULT OnDatenAudioeingang();
	afx_msg void OnUpdateDatenAudioeingang(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRecordStart(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRecordStop(CCmdUI* pCmdUI);
	afx_msg void OnRecordStart();
	afx_msg void OnRecordStop();
	afx_msg void OnDatenWavefileeinlesen();
	afx_msg void OnPlaywave();
	afx_msg void OnUpdatePlaywave(CCmdUI* pCmdUI);
	afx_msg void OnStopwave();
	afx_msg void OnUpdateStopwave(CCmdUI* pCmdUI);
	afx_msg void OnResetwave();
	afx_msg void OnPlayloop();
	afx_msg void OnUpdatePlayloop(CCmdUI* pCmdUI);
	afx_msg void OnUpdateResetwave(CCmdUI* pCmdUI);
	afx_msg void OnEinstellungenFft();
	afx_msg void OnAnsicht3drekonstruktion();
	afx_msg void OnAnsichtFFT();
	afx_msg void OnAnsichtZeitreihe();
	afx_msg void OnAnsichtInfo();
	afx_msg void OnUpdateAnsichtInfo(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAnsichtD3DReko(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAnsichtFFT(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAnsichtZeitreihe(CCmdUI* pCmdUI);
	afx_msg void OnAudioeingang();
	afx_msg void OnUpdateAudioeingang(CCmdUI* pCmdUI);
	afx_msg void OnAnsichtSono();
	afx_msg void OnAnsicht3dfft();
	afx_msg void OnUpdateAnsicht3dfft(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAnsichtSono(CCmdUI* pCmdUI);
	afx_msg void OnReadWave();
	afx_msg void OnFileMruFile1();
	afx_msg void OnAnsichtAnalyse();
	afx_msg void OnUpdateAnsichtAnalyse(CCmdUI* pCmdUI);
	afx_msg void OnAnsichtNotenbild();
	afx_msg void OnUpdateAnsichtNotenbild(CCmdUI* pCmdUI);
	afx_msg void OnHelpFinder();
	afx_msg void OnHelpIndex();
	afx_msg void OnUpdateAnsichtWavelet(CCmdUI* pCmdUI);
	afx_msg void OnAnsichtWavelet();
	afx_msg void OnViewStatusBar();
	afx_msg void OnViewToolbarnormal();
	afx_msg void OnUpdateViewToolbarnormal(CCmdUI* pCmdUI);
	afx_msg void OnViewToolbarschule();
	afx_msg void OnUpdateViewToolbarschule(CCmdUI* pCmdUI);
	afx_msg void OnRewind();
	afx_msg void OnUpdateRewind(CCmdUI* pCmdUI);
	afx_msg void OnSaveWave();
	afx_msg void OnUpdateSaveWave(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_SOUNDSDOC_H__D333F760_1C27_4A59_93BB_EC948FFA4F8E__INCLUDED_)
