// Splines.h: Schnittstelle fr die Klasse CSplines.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SPLINES_H__A7454B2D_B96E_4418_8434_7C827851B74F__INCLUDED_)
#define AFX_SPLINES_H__A7454B2D_B96E_4418_8434_7C827851B74F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <windows.h>
#include <string.h>

/* Matrix type */
typedef struct {
	size_t nCols;
	size_t nRows;
  double **ppElems;
} MATRIX, *PMATRIX;


/*
 * Zeroes a matrix
 */
#define MatrixClear(pMatrix)  (memset (pMatrix, 0, sizeof (double) * (pMatrix)->nCols * (pMatrix)->nRows))

/*
 * Returns the number of columns
 */
#define MatrixCols(pMatrix)   ((pMatrix)->nCols)

/*
 * Returns the number of rows
 */
#define MatrixRows(pMatrix)   ((pMatrix)->nRows)

/*
 * Returns the matrix element at nRow, nCol position
 */
#define MatrixElemAt(pMatrix, nRow, nCol)  ((pMatrix)->ppElems [nRow][nCol])


class CSplines  
{
protected:
	DOUBLE			m_dBeta1;
	DOUBLE			m_dBeta2;


public:
	CSplines();
	virtual ~CSplines();
	void ZeichneBSpline(CDC* pDC, const POINT paPoints [], size_t nSize,COLORREF color);
	
protected:
	PMATRIX MatrixCreate (size_t nRows, size_t nCols);
	void MatrixDestroy (PMATRIX pMatrix) ;
	PMATRIX MatrixMultiply (const PMATRIX pLeft, const PMATRIX pRight);
	POINT * MatrixMultiplyPoint (const PMATRIX pMatrix, const POINT paPoint [], size_t nSize);
	BOOL InitBetaSpline (PMATRIX *pMs, PMATRIX *pT, double dBeta1, double dBeta2);

};

#endif // !defined(AFX_SPLINES_H__A7454B2D_B96E_4418_8434_7C827851B74F__INCLUDED_)
