// StereoDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Sounds.h"
#include "StereoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CStereoDlg 


CStereoDlg::CStereoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStereoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStereoDlg)
	m_intBits = 0;
	m_strChannels = _T("");
	m_strFormat = _T("PCM");
	m_strHinweis = _T("Hinweis:");
	m_intSamples = 0;
	m_strPlayFile = _T("");
	//}}AFX_DATA_INIT
}


void CStereoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStereoDlg)
	DDX_Control(pDX, IDC_RADIOCHANNEL_L, m_ChannelRadioCtrl);
	DDX_Text(pDX, IDC_BITS, m_intBits);
	DDX_Text(pDX, IDC_CHANNELS, m_strChannels);
	DDX_Text(pDX, IDC_FORMAT, m_strFormat);
	DDX_Text(pDX, IDC_HINWEIS, m_strHinweis);
	DDX_Text(pDX, IDC_SAMPLES, m_intSamples);
	DDX_Text(pDX, IDC_WAVEFILEPLAY, m_strPlayFile);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStereoDlg, CDialog)
	//{{AFX_MSG_MAP(CStereoDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CStereoDlg 

BOOL CStereoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CSoundsDoc* pDoc=GetDocument();
	m_intBits=*pDoc->GetBitRate();
	m_intSamples=*pDoc->GetSampleRate();
	m_strChannels=pDoc->m_strChannels;
	m_strFormat = pDoc->m_strFormat;
	m_strPlayFile = pDoc->m_strPlayFile;
	CButton* pRadioLinks=(CButton*)GetDlgItem(IDC_RADIOCHANNEL_L);
	CButton* pRadioRechts=(CButton*)GetDlgItem(IDC_RADIOCHANNEL_R);
	if (m_strChannels=="Mono") 
	{
		m_strHinweis.LoadString(IDS_HINT_MONO);
		pRadioLinks->EnableWindow(FALSE);
		pRadioRechts->EnableWindow(FALSE);
	}
	else
	{
		m_strHinweis.LoadString(IDS_HINT_STEREO);
		pRadioLinks->EnableWindow(TRUE);
		pRadioRechts->EnableWindow(TRUE);
		pRadioLinks->SetCheck(TRUE);
	}
	if (m_intBits>16) 
	{
		m_strHinweis.LoadString(IDS_MORETHAN16BIT);
		CButton* pOK=(CButton*)GetDlgItem(IDOK);
		pOK->EnableWindow(FALSE);
	}

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CStereoDlg::OnOK() 
{

	m_bIsLinkerKanal=m_ChannelRadioCtrl.GetCheck();
	CDialog::OnOK();
}
